<?php

namespace Teknisa\FIN\Modules\ContaPagar\Factory;

use Teknisa\Model\Financeiro\Entities\Ajbolrec;
use Teknisa\Model\Financeiro\Entities\Ajbolpag;
use Teknisa\Model\Financeiro\Entities\Ajctpagar;
use Teknisa\Model\Financeiro\Entities\Ajctreceber;
use Teknisa\Model\Financeiro\Entities\Compensacontpag;
use Teknisa\Model\Financeiro\Entities\Itemcompcontpag;
use Teknisa\Model\Financeiro\Entities\Movdebbanc;
use Teknisa\Model\Financeiro\Entities\Contapagar;
use Teknisa\Model\Financeiro\Entities\Contareceber;
use Teknisa\Model\Financeiro\Entities\Boletpagar;
use Teknisa\Model\Financeiro\Entities\Boletreceber;
use Teknisa\Libs\Util\DateUtil;
use Teknisa\Model\Financeiro\Entities\Baixarecebida;
use Teknisa\Model\Financeiro\Entities\Baixapaga;

class Pag18000CompensacaoTitulosPagarFactory
{

    protected $entityManager;

    public function __construct($entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getAjusteCompBoletoRec($nrorg, $cdfilial, $nrlanbolrec, $cdajuctrec)
    {
        $parans = array();
        $parans['nrorg'] = $nrorg;
        $parans['cdfilial'] = $cdfilial;
        $parans['nrlanbolrec'] = $nrlanbolrec;
        $parans['cdajuctrec'] = $cdajuctrec;
        $ajbolrec = $this->entityManager->getRepository(Ajbolrec::class)->findOneBy($parans);
        return $ajbolrec;
    }

    public function insereAjusteBoletoRec($cdfilial, $nrlanbolrec, $cdajuctrec, $vrfinalbrec, $idOrigemAjRec, $nrorg, $operador){
        $ajbolrec = new Ajbolrec();
        $ajbolrec->setCdfilial($cdfilial);
        $ajbolrec->setNrlanbolrec($nrlanbolrec);
        $ajbolrec->setCdajuctrec($cdajuctrec);
        $ajbolrec->setVrajbolrec($vrfinalbrec);
        $ajbolrec->setIdorigajbrec($idOrigemAjRec);
        $ajbolrec->setNrorg($nrorg);
        $ajbolrec->setDtinclusao(DateUtil::getDataAtual());
        $ajbolrec->setNrorginclusao($nrorg);
        $ajbolrec->setCdoperinclusao($operador);
        return $ajbolrec;
    }

    public function updateAjusteBoletoRec(Ajbolrec $ajbolrec, $valorAjustado){
        $ajbolrec->setVrajbolrec($valorAjustado);
        return $ajbolrec;
    }

    public function getMovimentoDebito($cdreducont, $nrmovidebi, $nrorg){
        $parans = array();
        $parans['nrorg'] = $nrorg;
        $parans['cdreducont'] = $cdreducont;
        $parans['nrmovidebi'] = $nrmovidebi;
        $movdebbanc = $this->entityManager->getRepository(Movdebbanc::class)->findOneBy($parans);
        return $movdebbanc;
    }

    public function atualizaCompensacaoDebito(Movdebbanc $movdebbanc, $idlancomcontpag){
        $movdebbanc->setIdlancomcontpag($idlancomcontpag);
        return $movdebbanc;
    }

    public function getAjusteContaPagar($cdfilial, $nrlanctonf, $nrseqvenpag, $nrparcelapag, $nrorg){
        $parans = array();
        $parans['cdfilial'] = $cdfilial;
        $parans['nrlanctonf'] = $nrlanctonf;
        $parans['nrseqvenpag'] = $nrseqvenpag;
        $parans['nrparcelapag'] = $nrparcelapag;
        $parans['nrorg'] = $nrorg;
        $contaPagar = $this->entityManager->getRepository(Ajctpagar::class)->findOneBy($parans);
        return $contaPagar;
    }

    public function updateAjusteContaPagar(Ajctpagar $ajctpag, $dtmovfluxo, $idmovfluxo, $nrorg, $cdoperador){
        $ajctpag->setDtmovfluxo($dtmovfluxo);
        $ajctpag->setIdmovfluxo($idmovfluxo);
        $ajctpag->setDtultatu(DateUtil::getDataAtual());
        $ajctpag->setNrorgultatu($nrorg);
        $ajctpag->setCdoperultatu($cdoperador);
        return $ajctpag;
    }

    public function getAjusteContaReceber($cdfilial, $nrlanctonf, $nrseqvenrec, $nrparcelarec, $nrorg){
        $parans = array();
        $parans['cdfilial'] = $cdfilial;
        $parans['nrlanctonf'] = $nrlanctonf;
        $parans['nrseqvenrec'] = $nrseqvenrec;
        $parans['nrparcelarec'] = $nrparcelarec;
        $parans['nrorg'] = $nrorg;
        $contaReceber = $this->entityManager->getRepository(Ajctreceber::class)->findOneBy($parans);
        return $contaReceber;
    }

    public function updateAjusteContaReceber(Ajctreceber $ajctreceber, $dtmovfluxo, $idmovfluxo, $nrorg, $cdoperador){
        $ajctreceber->setDtmovfluxo($dtmovfluxo);
        $ajctreceber->setIdmovfluxo($idmovfluxo);
        $ajctreceber->setDtultatu(DateUtil::getDataAtual());
        $ajctreceber->setNrorgultatu($nrorg);
        $ajctreceber->setCdoperultatu($cdoperador);
        return $ajctreceber;
    }

    public function getAjusteBoletoPagar($cdfilibpag, $nrlanbolpag, $cdajuctpag, $nrorg){
        $parans = array();
        $parans['cdfilial'] = $cdfilibpag;
        $parans['nrlanbolpag'] = $nrlanbolpag;
        $parans['cdajuctpag'] = $cdajuctpag;
        $parans['nrorg'] = $nrorg;
        $ajbolpag = $this->entityManager->getRepository(Ajbolpag::class)->findOneBy($parans);
        return $ajbolpag;
    }

    public function updateAjusteBoletoPagar(Ajbolpag $ajbolpag, $valorAjustado){
        $ajbolpag->setVrajbolpag($valorAjustado);
        return $ajbolpag;
    }

    public function insereAjusteBoletoPagar($cdfilibpag, $nrlanbolpag, $cdajuctpag, $vrajbolpag, $idorigajbpag, $nrorg, $operador){
        $ajbolpag = new Ajbolpag();
        $ajbolpag->setCdfilial($cdfilibpag);
        $ajbolpag->setNrlanbolpag($nrlanbolpag);
        $ajbolpag->setCdajuctpag($cdajuctpag);
        $ajbolpag->setVrajbolpag($vrajbolpag);
        $ajbolpag->setIdorigajbpag($idorigajbpag);
        $ajbolpag->setNrorg($nrorg);
        $ajbolpag->setNrorginclusao($nrorg);
        $ajbolpag->setCdoperinclusao($operador);
        $ajbolpag->setDtinclusao(DateUtil::getDataAtual());
        return $ajbolpag;
    }

    public function getContaPagar($cdfilial, $nrlanctonf, $nrseqvenpag, $nrparcelapag, $nrorg){
        $parans = array();
        $parans['cdfilial'] = $cdfilial;
        $parans['nrlanctonf'] = $nrlanctonf;
        $parans['nrseqvenpag'] = $nrseqvenpag;
        $parans['nrparcelapag'] = $nrparcelapag;
        $parans['nrorg'] = $nrorg;
        $contaPagar = $this->entityManager->getRepository(Contapagar::class)->findOneBy($parans);
        return $contaPagar;
    }

    public function updateContaPagar(Contapagar $contaPagar, $idmovfluxo, $idstatpag, $dtmovfluxo, $nrorg, $operador){
        $contaPagar->setIdmovfluxo($idmovfluxo);
        $contaPagar->setIdstatpag($idstatpag);
        $contaPagar->setDtmovfluxo($dtmovfluxo);
        $contaPagar->setCdoperultatu($operador);
        $contaPagar->setDtultatu(DateUtil::getDataAtual());
        $contaPagar->setNrorgultatu($nrorg);
        return $contaPagar;
    }

    public function getContaReceber($cdfilial, $nrlanctonf, $nrseqvenrec, $nrparcelarec, $nrorg){
        $parans = array();
        $parans['cdfilial'] = $cdfilial;
        $parans['nrlanctonf'] = $nrlanctonf;
        $parans['nrseqvenrec'] = $nrseqvenrec;
        $parans['nrparcelarec'] = $nrparcelarec;
        $parans['nrorg'] = $nrorg;
        $contaReceber = $this->entityManager->getRepository(ContaReceber::class)->findOneBy($parans);
        return $contaReceber;
    }

    public function updateContaReceber(ContaReceber $contaReceber, $idmovfluxo, $idstatrec, $dtmovfluxo, $nrorg, $operador){
        $contaReceber->setIdmovfluxo($idmovfluxo);
        $contaReceber->setIdstatrec($idstatrec);
        $contaReceber->setDtmovfluxo($dtmovfluxo);
        $contaReceber->setCdoperultatu($operador);
        $contaReceber->setDtultatu(DateUtil::getDataAtual());
        $contaReceber->setNrorgultatu($nrorg);
        return $contaReceber;
    }

    public function getTipoAjusteContaPagar($nrorg, $cdfilial, $nrlanctonf, $nrparcelapag, $nrseqvenpag){
        $params = array();
        $params['nrorg'] = $nrorg;
        $params['cdfilial'] = $cdfilial;
        $params['nrlanctonf'] = $nrlanctonf;
        $params['nrparcelapag'] = $nrparcelapag;
        $params['nrseqvenpag'] = $nrseqvenpag;

        $sql = 'SELECT AR.CDFILIAL    , AR.NRLANCTONF  , AR.NRSEQVENPAG, AR.NRPARCELAPAG,
                       AR.DTAJUSTEPAG , AR.CDAJUCTPAG  , TA.IDAJUCTPAG , AR.CDCLASSFINA ,
                       AR.CDEMMFAJCNTP, AR.CDFIMFAJCNTP, AR.DTMOVFLUXO , AR.IDMOVFLUXO  ,
                       AR.VRAJUSTEPAG
                  FROM AJCTPAGAR AR
                  JOIN CONTAPAGAR CT
                    ON (CT.CDFILIAL     = :CDFILIAL      ) AND
                       (CT.NRLANCTONF   = :NRLANCTONF    ) AND
                       (CT.NRSEQVENPAG  = :NRSEQVENPAG   ) AND
                       (CT.NRPARCELAPAG = :NRPARCELAPAG  ) AND
                       (CT.NRORG        = :NRORG         ) AND
                       (AR.CDFILIAL     = CT.CDFILIAL    ) AND
                       (AR.NRLANCTONF   = CT.NRLANCTONF  ) AND
                       (AR.NRSEQVENPAG  = CT.NRSEQVENPAG ) AND
                       (AR.NRPARCELAPAG = CT.NRPARCELAPAG) AND
                       (AR.NRORG        = CT.NRORG       )
                  JOIN TIPOAJPAGAR TA
                    ON (TA.CDAJUCTPAG   = AR.CDAJUCTPAG)
                   AND (TA.NRORG   = AR.NRORG)';
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getBoletosAjusteContaPagar($nrorg, $cdfilial, $nrlanctonf, $nrparcelapag, $nrseqvenpag){
       /* $params = array();
        $params['nrorg'] = $nrorg;
        $params['cdfilial'] = $cdfilial;
        $params['nrlanctonf'] = $nrlanctonf;
        $params['nrparcelapag'] = $nrparcelapag;
        $params['nrseqvenpag'] = $nrseqvenpag;

        $sql = 'SELECT AR.CDFILIAL    , AR.NRLANCTONF  , AR.NRSEQVENPAG, AR.NRPARCELAPAG,
                       AR.DTAJUSTEPAG , AR.CDAJUCTPAG  , TA.IDAJUCTPAG , AR.CDCLASSFINA ,
                       AR.CDEMMFAJCNTP, AR.CDFIMFAJCNTP, AR.DTMOVFLUXO , AR.IDMOVFLUXO  ,
                       AR.VRAJUSTEPAG
                  FROM AJCTPAGAR AR
                  JOIN CONTAPAGAR CT
                    ON (CT.CDFILIAL     = :CDFILIAL      ) AND
                       (CT.NRLANCTONF   = :NRLANCTONF    ) AND
                       (CT.NRSEQVENPAG  = :NRSEQVENPAG   ) AND
                       (CT.NRPARCELAPAG = :NRPARCELAPAG  ) AND
                       (CT.NRORG        = :NRORG         ) AND
                       (AR.CDFILIAL     = CT.CDFILIAL    ) AND
                       (AR.NRLANCTONF   = CT.NRLANCTONF  ) AND
                       (AR.NRSEQVENPAG  = CT.NRSEQVENPAG ) AND
                       (AR.NRPARCELAPAG = CT.NRPARCELAPAG) AND
                       (AR.NRORG        = CT.NRORG       )
                  JOIN TIPOAJPAGAR TA
                    ON (TA.CDAJUCTPAG   = AR.CDAJUCTPAG)
                   AND (TA.NRORG   = AR.NRORG)';
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();*/
    }

    /*SELECT 'N' AS IDMARCADO, NF.CDEMPRESA, NF.CDFILIRECE, FI.NMFILIAL,
       CP.CDFILIBPAG, BO.NRLANBOLPAG, BO.DTVENBOLPAG, BO.VRFINALBPAG,
       FO.NRINSJURFORN, FO.IDTPIJURFORN, FO.NMRAZSOCFORN, FO.CDFORNECED,
       CP.CDFILIAL, CP.NRLANCTONF, CP.NRSEQVENPAG, CP.NRPARCELAPAG, CP.VRATUAPAG AS VRORIGPAG,
       CP.CDFIMOVFLPAG, CP.CDCLASSFINA, CP.DTMOVFLUXO, NF.DTENTRSAID,
       TO_CHAR(BO.DTVENBOLPAG, 'DD/MM/YYYY') AS VENCIMENTO,
       TO_CHAR(CP.VRATUAPAG)   AS VRORIGINAL,
       TO_CHAR(BO.VRFINALBPAG) AS VRLIQUIDO,
       NF.NRNOTAFISC, NF.CDSERIEENTR,
       (NF.NRNOTAFISC || '/' || NF.CDSERIEENTR) AS DOCUMENTO
  FROM BOLETPAGAR BO, FORNECEDOR FO, CONTAPAGAR CP, NOTAFISCAL NF, FILIAL FI, TIPOCTPAGAR TP,
       COMPENSACONTPAG CMP
 WHERE BO.CDEMPRESA = CMP.CDEMPRESA
   AND BO.CDFORNECED = FO.CDFORNECED
   AND CP.CDFILIBPAG = BO.CDFILIAL
   AND CP.NRLANBOLPAG = BO.NRLANBOLPAG
   AND CP.CDFILIAL = NF.CDFILIAL
   AND CP.NRLANCTONF = NF.NRLANCTONF
   AND NF.CDFILIRECE = FI.CDFILIAL
   AND CP.CDTPCTPAGAR = TP.CDTPCTPAGAR
   AND CMP.CDEMPRESA = :CDEMPRESA
   AND CMP.NRLANCCOMPPAG = :NRLANCCOMPPAG
   AND BO.CDFILIAL = CMP.CDFILIAL
   AND BO.NRLANBOLPAG = CMP.NRLANBOLPAG
ORDER BY
   BO.DTVENBOLPAG, FO.CDFORNECED, NF.NRNOTAFISC, NF.CDSERIEENTR
*/

    public function getBoletoPagar($cdfilibpag, $nrlanbolpag, $nrorg){
        $parans = array();
        $parans['cdfilial'] = $cdfilibpag;
        $parans['nrlanbolpag'] = $nrlanbolpag;
        $parans['nrorg'] = $nrorg;
        $boletPagar = $this->entityManager->getRepository(Boletpagar::class)->findOneBy($parans);
        return $boletPagar;
    }

    public function atualizaAjusteBoletoPagar(Boletpagar $boletPagar, $vrfinalbpag, $idbpagreal, $nrorg, $operador){
        $boletPagar->setVrfinalbpag($vrfinalbpag);
        $boletPagar->setIdbpagreal($idbpagreal);
        $boletPagar->setCdoperultatu($operador);
        $boletPagar->setDtultatu(DateUtil::getDataAtual());
        $boletPagar->setNrorgultatu($nrorg);
        return $boletPagar;
    }

    public function atualizaBoletoPagar(Boletpagar $boletPagar, $idstatus, $idsitucnabp, $nrbaixapag, $filiproc, $cdtpbaixapag, $operador, $nrorg){
        $boletPagar->setIdstatbpag($idstatus);
        $boletPagar->setNrbaixapag($nrbaixapag);
        $boletPagar->setCdfilibaipag($filiproc);
        $boletPagar->setCdtpbaixapag($cdtpbaixapag);
        $boletPagar->setIdsitucnabp($idsitucnabp);
        $boletPagar->setCdoperultatu($operador);
        $boletPagar->setDtultatu(DateUtil::getDataAtual());
        $boletPagar->setNrorgultatu($nrorg);
        return $boletPagar;
    }

    public function getBaixaRecebida($cdfilial, $nrbaixarec, $nrorg){
        $parans = array();
        $parans['cdfilial'] = $cdfilial;
        $parans['nrbaixarec'] = $nrbaixarec;
        $parans['nrorg'] = $nrorg;
        $baixaRecebida = $this->entityManager->getRepository(Baixarecebida::class)->findOneBy($parans);
        return $baixaRecebida;
    }

    public function insereBaixaRec($empresa, $nrmovbanc, $nrlctbbrec, $nrbaixarec, $nrreciborec,
        $idstatusbrec, $vrbaixa, $operador, $cdreducont, $dtbaixacomp,
        $cdfilial, $cdtpbaixarec, $dsbaixarec, $nrorg){

        $baixaRecebida = new Baixarecebida();
        $baixaRecebida->setCdempresa($empresa);
        $baixaRecebida->setNrmovbanc($nrmovbanc);
        $baixaRecebida->setNrlctbbrec($nrlctbbrec);
        $baixaRecebida->setNrbaixarec($nrbaixarec);
        $baixaRecebida->setNrreciborec($nrreciborec);
        $baixaRecebida->setIdstatusbrec($idstatusbrec);
        $baixaRecebida->setCdfilial($cdfilial);
        $baixaRecebida->setDtbaixarec($dtbaixacomp);
        $baixaRecebida->setVrbaixarec($vrbaixa);
        $baixaRecebida->setCdreducont($cdreducont);
        $baixaRecebida->setCdtpbaixarec($cdtpbaixarec);
        $baixaRecebida->setCdoperador($operador);
        $baixaRecebida->setDtlancbaixar(DateUtil::getDataAtual());
        $baixaRecebida->setDsbaixarec($dsbaixarec);
        $baixaRecebida->setNrorg($nrorg);
        $baixaRecebida->setNrorginclusao($nrorg);
        $baixaRecebida->setDtinclusao(DateUtil::getDataAtual());
        $baixaRecebida->setCdoperinclusao($operador);
        return $baixaRecebida;
    }

    public function insereBaixaPaga($cdempresa, $filproc, $cdtpbaixapag, $documento, $cdreducont, $valorbaixa,
        $cdfilibpag, $nrlanbolpag, $nrorg, $operador, $nrbaixapag, $idstatusbpag){
        $data = DateUtil::getDataAtual();
        $data = DateUtil::truncateString($data);
        $data = DateUtil::getDatadeString($data);
        $data = DateUtil::truncateData($data);
        
        $baixaPaga = new Baixapaga();
        
        $baixaPaga->setCdfilial($filproc);
        $baixaPaga->setNrbaixapag($nrbaixapag);
        $baixaPaga->setCdempresa($cdempresa);
        $baixaPaga->setDtbaixapag($data);
        $baixaPaga->setVrbaixapag($valorbaixa);
        $baixaPaga->setDtlancbaixap(DateUtil::getDataAtual());
        $baixaPaga->setCdoperador($operador);
        $baixaPaga->setCdtpbaixapag($cdtpbaixapag);
        $baixaPaga->setCdreducont($cdreducont);
        $baixaPaga->setDsbaixapag($documento);
        $baixaPaga->setNrorg($nrorg);
        $baixaPaga->setNrorginclusao($nrorg);
        $baixaPaga->setDtinclusao(DateUtil::getDataAtual());
        $baixaPaga->setCdoperinclusao($operador);
        $baixaPaga->setIdstatusbpag($idstatusbpag);
        return $baixaPaga;
    }

    public function getBaixapaga($cdfilial, $nrbaixapag, $nrorg){
        $parans = array();
        $parans['cdfilial'] = $cdfilial;
        $parans['nrbaixapag'] = $nrbaixapag;
        $parans['nrorg'] = $nrorg;
        $baixaPaga = $this->entityManager->getRepository(Baixapaga::class)->findOneBy($parans);
        return $baixaPaga;
    }

    public function getBoletosRec($cdfilial, $nrlanbolrec, $nrorg){
        $parans = array();
        $parans['cdfilial'] = $cdfilial;
        $parans['nrlanbolrec'] = $nrlanbolrec;
        $parans['nrorg'] = $nrorg;
        $boletReceber = $this->entityManager->getRepository(Boletreceber::class)->findOneBy($parans);
        return $boletReceber;
    }

    public function atualizaAjusteBoletoReceber(Boletreceber $boletReceber, $vrfinalbrec, $nrorg, $operador){
        $boletReceber->setVrfinalbrec($vrfinalbrec);
        $boletReceber->setCdoperultatu($operador);
        $boletReceber->setDtultatu(DateUtil::getDataAtual());
        $boletReceber->setNrorgultatu($nrorg);
        return $boletReceber;
    }

    public function atualizaBoletosRec(Boletreceber $boletReceber, $status, $nrbaixa, $filialproc, $cdtpbaixarec, $nrorg, $operador){
        $boletReceber->setIdstatbrec($status);
        $boletReceber->setNrbaixarec($nrbaixa);
        $boletReceber->setCdfilibairec($filialproc);
        $boletReceber->setCdtpbaixarec($cdtpbaixarec);
        $boletReceber->setDtliqbolrec(DateUtil::getDataAtual());
        $boletReceber->setNrorgultatu($nrorg);
        $boletReceber->setDtultatu(DateUtil::getDataAtual());
        $boletReceber->setCdoperultatu($operador);
        return $boletReceber;
    }

    public function getBoletPagar($cdfilial, $nrlanbolpag, $nrorg){
        $parans = array();
        $parans['cdfilial'] = $cdfilial;
        $parans['nrlanbolpag'] = $nrlanbolpag;
        $parans['nrorg'] = $nrorg;
        $boletPagar = $this->entityManager->getRepository(Boletpagar::class)->findBy($parans);
        return $boletPagar;
    }

    public function atualizaBoletPagar(Boletpagar $boletPagar, $status, $nrbaixa, $tiporec, $filibaixa, $idsitucnabp, $nrorg, $operador){
        $boletPagar->setIdstatbpag($status);
        $boletPagar->setNrbaixapag($nrbaixa);
        $boletPagar->setCdtpbaixapag($tiporec);
        $boletPagar->setCdfilibaipag($filibaixa);
        $boletPagar->setIdsitucnabp($idsitucnabp);
        $boletPagar->setNrorgultatu($nrorg);
        $boletPagar->setDtultatu(DateUtil::getDataAtual());
        $boletPagar->setCdoperultatu($operador);
        return $boletPagar;
    }

    public function insereCompensacontpag($cdempresa, $nrcompensacao, $cdfilial, $nrlanbolpag, $cdoperlanccomcp, $cdforneced, $cdtpbaixarec,
        $cdtpbaixapag, $cdajuctrec, $cdajuctpag, $cdreducont, $cdfilibaixarec, $nrbaixarec, $cdfilibaixapag, $nrbaixapag,
        $idtpitutlcompag, $qtitenscomppag, $vrtotalcomppag, $nrorg, $cdoperador){
        $data = DateUtil::getDataAtual();
        $data = DateUtil::truncateString($data);
        $data = DateUtil::getDatadeString($data);
        $data = DateUtil::truncateData($data);
        $compensaContPag = new Compensacontpag();
        $compensaContPag->setCdempresa($cdempresa);
        $compensaContPag->setNrlanccomppag($nrcompensacao);
        $compensaContPag->setCdfilial($cdfilibaixapag);
        $compensaContPag->setNrlanbolpag($nrlanbolpag);
        $compensaContPag->setCdoperlanccomcp($cdoperlanccomcp);
        $compensaContPag->setCdforneced($cdforneced);
        $compensaContPag->setCdtpbaixarec($cdtpbaixarec);
        $compensaContPag->setCdtpbaixapag($cdtpbaixapag);
        $compensaContPag->setCdajuctrec($cdajuctrec);
        $compensaContPag->setCdajuctpag($cdajuctpag);
        $compensaContPag->setCdreducont($cdreducont);
        $compensaContPag->setCdfilibaixarec($cdfilibaixarec);
        $compensaContPag->setNrbaixarec($nrbaixarec);
        $compensaContPag->setCdfilibaixapag($cdfilibaixapag);
        $compensaContPag->setNrbaixapag($nrbaixapag);
        $compensaContPag->setDtlanccomppag(DateUtil::getDataAtual());
        $compensaContPag->setDtcompenctpag($data);
        $compensaContPag->setDtbaixacomp(DateUtil::getDataAtual());
        $compensaContPag->setIdtpitutlcompag($idtpitutlcompag);
        $compensaContPag->setQtitenscomppag($qtitenscomppag);
        $compensaContPag->setVrtotalcomppag($vrtotalcomppag);
        $compensaContPag->setNrorg($nrorg);
        $compensaContPag->setNrorginclusao($nrorg);
        $compensaContPag->setDtinclusao(DateUtil::getDataAtual());
        $compensaContPag->setCdoperinclusao($cdoperador);
        return $compensaContPag;
    }

    public function insereItensCompensacaoPagar($cdempresa, $nrlanccomppag, $nrseqitcomppag, $cdfilial, $nrlanbolrec,
                                                $cdreducont, $nrmovidebi, $vritemcomppag, $nrorg, $cdoperador){
        $itemCompensaContPag = new Itemcompcontpag();
        $itemCompensaContPag->setCdempresa($cdempresa);
        $itemCompensaContPag->setNrlanccomppag($nrlanccomppag);
        $itemCompensaContPag->setCdfilial($cdfilial);
        $itemCompensaContPag->setNrlanbolrec($nrlanbolrec);
        $itemCompensaContPag->setNrseqitcomppag($nrseqitcomppag);
        $itemCompensaContPag->setCdreducont($cdreducont);
        $itemCompensaContPag->setNrmovidebi($nrmovidebi);
        $itemCompensaContPag->setVritemcomppag($vritemcomppag);
        $itemCompensaContPag->setNrorg($nrorg);
        $itemCompensaContPag->setNrorginclusao($nrorg);
        $itemCompensaContPag->setDtinclusao(DateUtil::getDataAtual());
        $itemCompensaContPag->setCdoperinclusao($cdoperador);
        return $itemCompensaContPag;
    }

    public function getItensCompensados($cdempresa, $nrlanccomppag, $nrorg){
        $parans = array();
        $parans['cdempresa'] = $cdempresa;
        $parans['nrlanccomppag'] = $nrlanccomppag;
        $parans['nrorg'] = $nrorg;
        $itemcompcontpag = $this->entityManager->getRepository(Itemcompcontpag::class)->findBy($parans);
        return $itemcompcontpag;
    }

    public function getCompensacao($cdempresa, $nrlanccomppag, $nrorg){
        $parans = array();
        $parans['cdempresa'] = $cdempresa;
        $parans['nrlanccomppag'] = $nrlanccomppag;
        $parans['nrorg'] = $nrorg;
        $compensacontpag = $this->entityManager->getRepository(Compensacontpag::class)->findOneBy($parans);
        return $compensacontpag;
    }
}
?>