<?php
namespace Folha\Repositories;

use \HCM\Util\DateUtil;
use HCM\Util\FPA;

class FpaItecalcfolha extends \Doctrine\ORM\EntityRepository
{
    /**
     * Retorna soma dos valores das tarifas multiplicadas pela referência para ser gravadas
     * @param int $nrcalcfolha
     * @param string $dtmescomepetencia
     * @param int $nrorg
     * @param string $nrvinculom
     * @param mixed $lista_nrvinculom
     * @param mixed $lista_lotevinculos
     * @return array|bool
     */
    public static function getVinculosLiquidoVale($nrcalcfolha, $dtmescomepetencia, $nrorg, $nrvinculom, $nrestrutsind, $nrestrutlegal, $nrestrutgeren, $lista_nrvinculom, $tipodelinha = null, $lista_lotevinculos, $dtiniadmissao, $dtfimadmissao)
    {
        $condEstrutura = "";
        $condAdmissao = "";
        
        if($nrestrutsind || $nrestrutlegal || $nrestrutgeren){
            $condEstrutura = " JOIN GPE_VINCULOH
                                ON GPE_VINCULOH.NRORG = :P_NRORG
                               AND ( INSTR(','||:P_NRESTRUTSIND||',', ','||GPE_VINCULOH.NRESTRUTSIND||',' ) > 0 OR :P_NRESTRUTSIND IS NULL )
                               AND ( INSTR(','||:P_NRESTRUTLEGAL||',', ','||GPE_VINCULOH.NRESTRUTLEGAL||',' ) > 0 OR :P_NRESTRUTLEGAL IS NULL )
                               AND (GPE_VINCULOH.NRESTRUTGEREN = :P_NRESTRUTGEREN OR :P_NRESTRUTGEREN IS NULL)
                               AND GPE_VINCULOH.NRVINCULOM = VAB_HISTVALEVINC.NRVINCULOM
                               AND ( INSTR(','
                                            || :P_NRESTRUTLEGALOPER
                                            || ',', ','
                                                    || GPE_VINCULOH.NRESTRUTLEGAL
                                                    || ',') > 0
                                      OR :P_NRESTRUTLEGALOPER IS NULL )
                                AND ( INSTR(','
                                            || :P_NRESTRUTGERENOPER
                                            || ',', ','
                                                    || GPE_VINCULOH.NRESTRUTGEREN
                                                    || ',') > 0
                                      OR :P_NRESTRUTGERENOPER IS NULL )
                               AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                                   WHERE NRORG = GPE_VINCULOH.NRORG
                                                                     AND NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                     AND DTMESCOMPETENC <= :P_DTOCORRENCIA) ";
        }
        
        if(!empty($dtiniadmissao) && !empty($dtfimadmissao)){
            $condAdmissao = " JOIN GPE_VINCULOM ON GPE_VINCULOM.NRORG = :P_NRORG AND GPE_VINCULOM.NRVINCULOM = VAB_HISTVALEVINC.NRVINCULOM AND GPE_VINCULOM.DTADMISSAOVINC >= :P_DTINIADMISSAO AND GPE_VINCULOM.DTADMISSAOVINC <= :P_DTFIMADMISSAO";
        } else if(empty($dtiniadmissao) && !empty($dtfimadmissao)){
            $condAdmissao = " JOIN GPE_VINCULOM ON GPE_VINCULOM.NRORG = :P_NRORG AND GPE_VINCULOM.NRVINCULOM = VAB_HISTVALEVINC.NRVINCULOM AND GPE_VINCULOM.DTADMISSAOVINC <= :P_DTFIMADMISSAO";
        } else if(!empty($dtiniadmissao) && empty($dtfimadmissao)){
            $condAdmissao = " JOIN GPE_VINCULOM ON GPE_VINCULOM.NRORG = :P_NRORG AND GPE_VINCULOM.NRVINCULOM = VAB_HISTVALEVINC.NRVINCULOM AND GPE_VINCULOM.DTADMISSAOVINC >= :P_DTINIADMISSAO";
        }
        
        $sql = <<<SQL
SELECT SUM(DECODE( NVL(TIPOLINHAVINC.IDGERALIQUIDO, 'N'), 'S', NVL(VAB_TARIFA.VRTARIFA, 0), 0) * VAB_HISTVALEVINC.QTAPURVALE * VAB_HISTVALEVINC.QTDIASVALE) VREVENTO,
    VAB_HISTVALEVINC.NRVINCULOM,
    VAB_HISTVALEVINC.NRCALCULOFOLHA,
    VAB_HISTVALEVINC.NRORG,
    TO_CHAR(VAB_HISTVALEVINC.DTMESCOMPAPVALE,'DD/MM/YYYY') DTMESCOMPAPVALE,
    MAX(VAB_HISTVALEVINC.QTDIASVALE) QTDIASVALE,
    TO_CHAR(VAB_HISTVALEVINC.DTPGTOVALE, 'DD/MM/YYYY') DTPGTOVALE

FROM VAB_HISTVALEVINC

$condEstrutura

$condAdmissao

INNER JOIN VAB_TARIFA
    ON VAB_TARIFA.NRTARIFA = VAB_HISTVALEVINC.NRTARIFA
INNER JOIN TIPOLINHAVINC
    ON VAB_HISTVALEVINC.NRTIPOLINHAVINC = TIPOLINHAVINC.NRTIPOLINHAVINC
WHERE VAB_HISTVALEVINC.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
    AND VAB_HISTVALEVINC.NRORG = :P_NRORG
    AND TO_CHAR(VAB_HISTVALEVINC.DTMESCOMPAPVALE, 'DD/MM/YYYY') = :P_DTOCORRENCIA
    AND VAB_HISTVALEVINC.NRVINCULOM NOT IN ($nrvinculom)
    AND (INSTR(:P_LISTA_NRVINCULOM, '_'||VAB_HISTVALEVINC.NRVINCULOM||'_') > 0 OR :P_LISTA_NRVINCULOM = 'A')
    AND (VAB_HISTVALEVINC.NRTIPOLINHAVINC = :P_NRTIPOLINHAVINC OR :P_NRTIPOLINHAVINC is null)
    AND (VAB_HISTVALEVINC.NRVINCULOM IN (SELECT NRVINCULOM FROM FPA_ITEMLOTEVINC WHERE NRORG = :P_NRORG AND INSTR(','||:P_LISTA_LOTE_VINCULOS||',', ','||NRLOTEVINC||',') > 0) OR :P_LISTA_LOTE_VINCULOS IS NULL)
GROUP BY VAB_HISTVALEVINC.NRVINCULOM,
    VAB_HISTVALEVINC.NRCALCULOFOLHA,
    VAB_HISTVALEVINC.NRORG,
    TO_CHAR(VAB_HISTVALEVINC.DTMESCOMPAPVALE,'DD/MM/YYYY'),
    VAB_HISTVALEVINC.DTPGTOVALE
ORDER BY 1
SQL;

//$dtmescomepetencia = new \TkDateTime($dtmescomepetencia);
//$dtmescomepetencia = $dtmescomepetencia->toString('dd/MM/YYYY');

        $param = array('P_NRCALCULOFOLHA'   => $nrcalcfolha,
                       'P_NRORG'            => $nrorg,
                       'P_DTOCORRENCIA'     => $dtmescomepetencia,
                       'P_NRESTRUTSIND'     => $nrestrutsind,
                       'P_NRESTRUTLEGAL'    => $nrestrutlegal,  
                       'P_NRESTRUTGEREN'    => $nrestrutgeren,
                       'P_LISTA_NRVINCULOM' => $lista_nrvinculom,
                       'P_NRTIPOLINHAVINC'  => $tipodelinha,
                       'P_LISTA_LOTE_VINCULOS' => $lista_lotevinculos,
                       'P_DTINIADMISSAO' => $dtiniadmissao,
                       'P_DTFIMADMISSAO' => $dtfimadmissao,
                       'P_NRESTRUTLEGALOPER'    => FPA::getNrestrutlegalOper(),
                       'P_NRESTRUTGERENOPER'    => FPA::getNrestrutgerenOper());
        //$result = Connection::getInstance()->fetchAll($sql, $param);
        $result = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $param);
        if($result){
            return $result;
        }else{
            return false;
        }
    }


    /**
     * Retorna soma dos valores das tarifas multiplicadas pela referência para ser gravadas
     * @param int $nrcalcfolha
     * @param \DateTime $dtmescomepetencia
     * @param $nrorg
     * @param string $nrvinculom
     * @param mixed $lista_nrvinculom
     * @return array|bool
     */
    public static function getVinculosVale($nrcalcfolha, $dtmescomepetencia, $nrorg, $nrvinculom, $nrestrutsind, $nrestrutlegal, $nrestrutgeren, $lista_nrvinculom, $tipodelinha = null, $lista_lotevinculos, $dtiniadmissao, $dtfimadmissao)
    {
        if(!($dtmescomepetencia instanceof \DateTime)){
            $dtmescomepetencia = DateUtil::getDataDeString($dtmescomepetencia, DateUtil::FORMATO_BRASILEIRO, true);
        }

		$dtiniperiodo = $dtmescomepetencia->format('d/m/Y');
		$dtfimperiodo = $dtmescomepetencia->format('t/m/Y');
        
        $condAdmissao = "";
        $condEstrutura = "";
        
        if($nrestrutsind || $nrestrutlegal || $nrestrutgeren){
            $condEstrutura = " JOIN GPE_VINCULOH
                                ON GPE_VINCULOH.NRORG = :P_NRORG
                               AND ( INSTR(','||:P_NRESTRUTSIND||',', ','||GPE_VINCULOH.NRESTRUTSIND||',' ) > 0 OR :P_NRESTRUTSIND IS NULL )
                               AND ( INSTR(','||:P_NRESTRUTLEGAL||',', ','||GPE_VINCULOH.NRESTRUTLEGAL||',' ) > 0 OR :P_NRESTRUTLEGAL IS NULL )
                               AND (GPE_VINCULOH.NRESTRUTGEREN = :P_NRESTRUTGEREN OR :P_NRESTRUTGEREN IS NULL)
                               AND GPE_VINCULOH.NRVINCULOM = VAB_HISTVALEVINC.NRVINCULOM
                               AND ( INSTR(','
                                            || :P_NRESTRUTLEGALOPER
                                            || ',', ','
                                                    || GPE_VINCULOH.NRESTRUTLEGAL
                                                    || ',') > 0
                                      OR :P_NRESTRUTLEGALOPER IS NULL )
                                AND ( INSTR(','
                                            || :P_NRESTRUTGERENOPER
                                            || ',', ','
                                                    || GPE_VINCULOH.NRESTRUTGEREN
                                                    || ',') > 0
                                      OR :P_NRESTRUTGERENOPER IS NULL )
                               AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                                   WHERE NRORG = GPE_VINCULOH.NRORG
                                                                     AND NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                     AND DTMESCOMPETENC <= :P_DTMESCOMPETENCIA) ";
        }
        
        if(!empty($dtiniadmissao) && !empty($dtfimadmissao)){
            $condAdmissao = " JOIN GPE_VINCULOM ON GPE_VINCULOM.NRORG = :P_NRORG AND GPE_VINCULOM.NRVINCULOM = VAB_HISTVALEVINC.NRVINCULOM AND GPE_VINCULOM.DTADMISSAOVINC >= :P_DTINIADMISSAO AND GPE_VINCULOM.DTADMISSAOVINC <= :P_DTFIMADMISSAO";
        } else if(empty($dtiniadmissao) && !empty($dtfimadmissao)){
            $condAdmissao = " JOIN GPE_VINCULOM ON GPE_VINCULOM.NRORG = :P_NRORG AND GPE_VINCULOM.NRVINCULOM = VAB_HISTVALEVINC.NRVINCULOM AND GPE_VINCULOM.DTADMISSAOVINC <= :P_DTFIMADMISSAO";
        } else if(!empty($dtiniadmissao) && empty($dtfimadmissao)){
            $condAdmissao = " JOIN GPE_VINCULOM ON GPE_VINCULOM.NRORG = :P_NRORG AND GPE_VINCULOM.NRVINCULOM = VAB_HISTVALEVINC.NRVINCULOM AND GPE_VINCULOM.DTADMISSAOVINC >= :P_DTINIADMISSAO";
        }


        $sql = <<<SQL
SELECT SUM(CEIL(VREVENTO/NVL(VRMULTIPLOINTEG, 0.01))*NVL(VRMULTIPLOINTEG, 0.01)) VREVENTO,
    VAB_HISTVALEVINC.NRVINCULOM,
    MAX(VAB_HISTVALEVINC.QTDIASVALE) QTDIASVALE,
    VAB_HISTVALEVINC.NRCALCULOFOLHA,
    DTMESCOMPAPVALE,
    DTPGTOVALE
FROM (SELECT
        (CASE
            WHEN (SUM(VAB_TARIFA.VRTARIFA * VAB_HISTVALEVINC.QTAPURVALE * VAB_HISTVALEVINC.QTDIASVALE)< NVL(VAB_HISTVALEVINC.VRDEDUCAOVALE, 0))
                THEN 0
            ELSE
                (SUM(VAB_TARIFA.VRTARIFA * VAB_HISTVALEVINC.QTAPURVALE * (VAB_HISTVALEVINC.QTDIASVALE))- NVL(VAB_HISTVALEVINC.VRDEDUCAOVALE, 0))
        END) VREVENTO,
        VAB_HISTVALEVINC.NRVINCULOM,
        SUM(VAB_HISTVALEVINC.QTDIASVALE) QTDIASVALE,
        VAB_HISTVALEVINC.NRCALCULOFOLHA,
        VAB_INTEGTRANSPH.CDINTEGTRANSP,
		VAB_INTEGTRANSPH.VRMULTIPLOINTEG,
        TO_CHAR(VAB_HISTVALEVINC.DTMESCOMPAPVALE, 'DD/MM/YYYY') DTMESCOMPAPVALE,
        TO_CHAR(VAB_HISTVALEVINC.DTPGTOVALE, 'DD/MM/YYYY') DTPGTOVALE
      FROM VAB_HISTVALEVINC
        
      $condEstrutura
      
      $condAdmissao

      INNER JOIN VAB_TARIFA
          ON VAB_TARIFA.NRTARIFA = VAB_HISTVALEVINC.NRTARIFA

      LEFT JOIN VAB_INTEGTRANSPH
          ON VAB_INTEGTRANSPH.NRORG = VAB_HISTVALEVINC.NRORG
          AND VAB_INTEGTRANSPH.NRTIPOLINHAVINC = VAB_HISTVALEVINC.NRTIPOLINHAVINC
          AND VAB_INTEGTRANSPH.DTMESCOMPINTEG = (SELECT MAX(MAX_INTEGTRANSPH.DTMESCOMPINTEG)
                                                  FROM VAB_INTEGTRANSPH MAX_INTEGTRANSPH
                                                  WHERE VAB_INTEGTRANSPH.NRORG = MAX_INTEGTRANSPH.NRORG
                                                      AND VAB_INTEGTRANSPH.NRINTEGTRANSPM = MAX_INTEGTRANSPH.NRINTEGTRANSPM
                                                      AND VAB_HISTVALEVINC.DTMESCOMPAPVALE <= :P_DTMESCOMPETENCIA)

          AND (EXISTS (SELECT 1 FROM VAB_LINHAVINC
                        WHERE VAB_LINHAVINC.NRORG = VAB_HISTVALEVINC.NRORG
                          AND VAB_LINHAVINC.NRVINCULOM = VAB_HISTVALEVINC.NRVINCULOM
                          AND VAB_LINHAVINC.NRINTEGTRANSPM = VAB_INTEGTRANSPH.NRINTEGTRANSPM
                          AND VAB_LINHAVINC.NRTIPOLINHAVINC = VAB_HISTVALEVINC.NRTIPOLINHAVINC
                          AND VAB_LINHAVINC.NRSENTIDOLINHA = VAB_HISTVALEVINC.NRSENTIDOLINHA
                          AND VAB_LINHAVINC.NRLINHATARIFA = VAB_HISTVALEVINC.NRLINHATRANSP
                          AND VAB_LINHAVINC.DTINILINHAVINC <= '$dtiniperiodo'
                          AND (VAB_LINHAVINC.DTFIMLINHAVINC >='$dtfimperiodo'OR VAB_LINHAVINC.DTFIMLINHAVINC IS NULL)))													  

      WHERE VAB_HISTVALEVINC.NRORG                                = :P_NRORG
          AND (VAB_HISTVALEVINC.NRTIPOLINHAVINC = :P_NRTIPOLINHAVINC OR :P_NRTIPOLINHAVINC is null)
          AND VAB_HISTVALEVINC.NRCALCULOFOLHA                         = :P_NRCALCULOFOLHA
          AND TO_CHAR(VAB_HISTVALEVINC.DTMESCOMPAPVALE, 'DD/MM/YYYY') = :P_DTMESCOMPETENCIA
          AND (INSTR(:P_LISTA_NRVINCULOM, '_'||VAB_HISTVALEVINC.NRVINCULOM||'_') > 0 OR :P_LISTA_NRVINCULOM = 'A')
          AND (VAB_HISTVALEVINC.NRVINCULOM IN (SELECT NRVINCULOM FROM FPA_ITEMLOTEVINC WHERE NRORG = :P_NRORG AND INSTR(','||:P_LISTA_LOTE_VINCULOS||',', ','||NRLOTEVINC||',') > 0) OR :P_LISTA_LOTE_VINCULOS IS NULL)
      GROUP BY VAB_HISTVALEVINC.NRVINCULOM,
          --VAB_HISTVALEVINC.QTDIASVALE,
          VAB_HISTVALEVINC.NRCALCULOFOLHA,
          VAB_INTEGTRANSPH.CDINTEGTRANSP,
		  VAB_INTEGTRANSPH.VRMULTIPLOINTEG,		  
          VAB_INTEGTRANSPH.VRSALDOULTCONSULTA,
          VAB_HISTVALEVINC.VRDEDUCAOVALE,
          TO_CHAR(VAB_HISTVALEVINC.DTMESCOMPAPVALE, 'DD/MM/YYYY'),
          TO_CHAR(VAB_HISTVALEVINC.DTPGTOVALE, 'DD/MM/YYYY')
)VAB_HISTVALEVINC
GROUP BY VAB_HISTVALEVINC.NRVINCULOM,
    VAB_HISTVALEVINC.NRCALCULOFOLHA,
    DTMESCOMPAPVALE,
    DTPGTOVALE
ORDER BY NRVINCULOM
SQL;

        $param = array( 'P_DTMESCOMPETENCIA'   => $dtmescomepetencia,
            'P_NRORG'          => $nrorg,
            'P_NRCALCULOFOLHA' => $nrcalcfolha,
            'P_DTMESCOMPETENCIA'   => $dtmescomepetencia->format('d/m/Y'),
            'P_NRESTRUTSIND'     => $nrestrutsind,
            'P_NRESTRUTLEGAL'    => $nrestrutlegal,  
            'P_NRESTRUTGEREN'    => $nrestrutgeren,
            'P_LISTA_NRVINCULOM' => $lista_nrvinculom,
            'P_NRTIPOLINHAVINC'  => $tipodelinha,
            'P_LISTA_LOTE_VINCULOS' => $lista_lotevinculos,
            'P_DTINIADMISSAO' => $dtiniadmissao,
            'P_DTFIMADMISSAO' => $dtfimadmissao,
            'P_NRESTRUTLEGALOPER'    => FPA::getNrestrutlegalOper(),
            'P_NRESTRUTGERENOPER'    => FPA::getNrestrutgerenOper()
            );
        //$result = Connection::getInstance()->fetchAll($sql, $param);
        $result = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $param);

        if($result){
            return $result;
        }else{
            return false;
        }
    }

    public static function getVinculosFolha($nrcalculofolha, $dtmescompetencia, $nrorg, $lista_nrvinculom)
    {
        $sql = <<<SQL
SELECT  FPA_ITECALCFOLHA.NRVINCULOM,
       /* NREVENTOM, */
        'S' IDEVENDEMONCALC,
        NULL AS QTDIASVALE,
        SUM(VREVENTOFOLHA) AS VREVENTO
FROM FPA_ITECALCFOLHA
    JOIN FPA_EVENTOM
        ON FPA_EVENTOM.IDTIPOEVENTO = :P_IDTIPOEVENTO
        AND FPA_EVENTOM.NREVENTOM = FPA_ITECALCFOLHA.NREVENTOM
WHERE NRCALCULOFOLHA = :P_NRCALCULOFOLHA
  AND FPA_ITECALCFOLHA.NRORG = :P_NRORG
   /* AND NREVENTOM = P_EVENTO */
    AND (INSTR(:P_LISTA_NRVINCULOM, '_'||NRVINCULOM||'_') > 0 OR :P_LISTA_NRVINCULOM = 'A')
/*    AND NRVINCULOM NOT IN ( SELECT LIQ_ITECALCFOLHA.NRVINCULOM
                              FROM FPA_ITECALCFOLHA LIQ_ITECALCFOLHA
                             WHERE LIQ_ITECALCFOLHA.NRVINCULOM = FPA_ITECALCFOLHA.NRVINCULOM
                               AND LIQ_ITECALCFOLHA.NRORG = FPA_ITECALCFOLHA.NRORG
                               AND LIQ_ITECALCFOLHA.NRCALCULOFOLHA = FPA_ITECALCFOLHA.NRCALCULOFOLHA
                               AND LIQ_ITECALCFOLHA.DTOCORRENCIA = LIQ_ITECALCFOLHA.DTOCORRENCIA
                               AND LIQ_ITECALCFOLHA.NREVENTOM = 3040)*/
GROUP BY NRVINCULOM
SQL;

//$dtmescompetencia = new \TkDateTime($dtmescompetencia);
//$dtmescompetencia = $dtmescompetencia->toString('dd/MM/YYYY');

        $param = array( 'P_NRCALCULOFOLHA'  => $nrcalculofolha,
            'P_NRORG'           => $nrorg,
            'P_DTOCORRENCIA'    => $dtmescompetencia,
            /* 'P_EVENTO'          => 480, */
            'P_IDTIPOEVENTO'    => 'PROVENTO',
            'P_LISTA_NRVINCULOM'=> $lista_nrvinculom);
        //$result = Connection::getInstance()->fetchAll($sql, $param);
        $result = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $param);
        if($result){
            return $result;
        }else{
            return false;
        }

    }

    /**
     * Retorna data de geração do último cnab por evento do vínculo
     * @param int $nrorg
     * @param int $nrcalcfolha
     * @param int $nreventom
     * @param string $nrvinculom
     * @param date $dtPagamento
     * @return string|null
     */
    public static function retornaDataGerUltCNAB($nrorg, $nrcalculofolha, $nreventom, $nrvinculom, $dtPagamento)
    {
        $sql = <<<SQL
SELECT DTGERULTCNAB
FROM FPA_ITECALCFOLHA
WHERE FPA_ITECALCFOLHA.NRORG = :P_NRORG
AND FPA_ITECALCFOLHA.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
AND FPA_ITECALCFOLHA.NREVENTOM = :P_NREVENTOM
AND FPA_ITECALCFOLHA.NRVINCULOM = :P_NRVINCULOM
AND FPA_ITECALCFOLHA.DTOCORRENCIA = NVL(:P_DTOCORRENCIA, FPA_ITECALCFOLHA.DTOCORRENCIA)
SQL;

        $param = array(
            'P_NRORG'          => $nrorg,
            'P_NRCALCULOFOLHA' => $nrcalculofolha,
            'P_NREVENTOM'      => $nreventom,
            'P_NRVINCULOM'     => $nrvinculom,
            'P_DTOCORRENCIA'   => $dtPagamento);
        $result = Connection::getInstance()->fetchAll($sql, $param);
        return $result[0]['DTGERULTCNAB'];
    }

    public static function limpaDataGerUltCNAB($nrorg, $nrcalculofolha, $nreventom, $nrvinculom, $dtPagamento = null)
    {
/*        $sql = <<<SQL
UPDATE FPA_ITECALCFOLHA
SET DTGERULTCNAB = NULL
WHERE FPA_ITECALCFOLHA.NRORG = :P_NRORG
AND FPA_ITECALCFOLHA.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
AND FPA_ITECALCFOLHA.NREVENTOM = :P_NREVENTOM
AND FPA_ITECALCFOLHA.NRVINCULOM = :P_NRVINCULOM
AND FPA_ITECALCFOLHA.DTOCORRENCIA = NVL(:P_DTOCORRENCIA, FPA_ITECALCFOLHA.DTOCORRENCIA)
SQL;
        $param = array(
            'P_NRORG'          => $nrorg,
            'P_NRCALCULOFOLHA' => $nrcalculofolha,
            'P_NREVENTOM'      => $nreventom,
            'P_NRVINCULOM'     => $nrvinculom,
            'P_DTOCORRENCIA'   => $dtPagamento);

        Connection::getInstance()->execute($sql, $param);*/
    }
    
    public static function getItensCalculados($nrcalculovale, $nrorg, $dtmescompetenc, $nrestrutsind, $nrestrutlegal, $nrestrutgeren, $lista_nrvinculom, $lista_lotevinculos, $dtiniadmissao, $dtfimadmissao)
    {
        $condAdmissao = "";
        
        if(!empty($dtiniadmissao) && !empty($dtfimadmissao)){
            $condAdmissao = " JOIN GPE_VINCULOM ON GPE_VINCULOM.NRORG = :P_NRORG AND GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND GPE_VINCULOM.DTADMISSAOVINC >= :P_DTINIADMISSAO AND GPE_VINCULOM.DTADMISSAOVINC <= :P_DTFIMADMISSAO";
        } else if(empty($dtiniadmissao) && !empty($dtfimadmissao)){
            $condAdmissao = " JOIN GPE_VINCULOM ON GPE_VINCULOM.NRORG = :P_NRORG AND GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND GPE_VINCULOM.DTADMISSAOVINC <= :P_DTFIMADMISSAO";
        } else if(!empty($dtiniadmissao) && empty($dtfimadmissao)){
            $condAdmissao = " JOIN GPE_VINCULOM ON GPE_VINCULOM.NRORG = :P_NRORG AND GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND GPE_VINCULOM.DTADMISSAOVINC >= :P_DTINIADMISSAO";
        }
        
        $params = [
            'NRORG'                 => $nrorg,
            'P_NRORG'               => $nrorg,
            'P_NRESTRUTSIND'        => $nrestrutsind,
            'P_NRESTRUTLEGAL'       => $nrestrutlegal,
            'P_NRESTRUTGEREN'       => $nrestrutgeren,
            'DTCOMPETENC'           => $dtmescompetenc,
            'NRCALCULOVALE'         => $nrcalculovale,
            'LISTA_NRVINCULOM'      => $lista_nrvinculom,
            'P_LISTA_LOTE_VINCULOS' => $lista_lotevinculos,
            'P_DTINIADMISSAO'       => $dtiniadmissao,
            'P_DTFIMADMISSAO'       => $dtfimadmissao,
            'P_NRESTRUTLEGALOPER'    => FPA::getNrestrutlegalOper(),
            'P_NRESTRUTGERENOPER'    => FPA::getNrestrutgerenOper()
        ];
 
        $sql = <<<SQL
    SELECT      
        FPA_ITECALCFOLHA.NRCALCULOFOLHA,
        FPA_ITECALCFOLHA.NRVINCULOM,
        /*FPA_ITECALCFOLHA.NREVENTOM*/ 480 AS NREVENTOM, /*Todos os proventos da tela de Itens De Movimentos do VT devem ser considerados no lote como evento 480*/
        FPA_ITECALCFOLHA.NRORG,
        SUM(FPA_ITECALCFOLHA.VREVENTOFOLHA) AS VREVENTOLOTE
    FROM 
        FPA_ITECALCFOLHA
    JOIN 
        GPE_VINCULOH
    ON 
    (
        GPE_VINCULOH.NRORG = FPA_ITECALCFOLHA.NRORG
        AND GPE_VINCULOH.NRVINCULOM = FPA_ITECALCFOLHA.NRVINCULOM
        AND ( INSTR(','||:P_NRESTRUTSIND||',', ','||GPE_VINCULOH.NRESTRUTSIND||',' ) > 0 OR :P_NRESTRUTSIND IS NULL )
        AND ( INSTR(','||:P_NRESTRUTLEGAL||',', ','||GPE_VINCULOH.NRESTRUTLEGAL||',' ) > 0 OR :P_NRESTRUTLEGAL IS NULL )
        AND (GPE_VINCULOH.NRESTRUTGEREN = :P_NRESTRUTGEREN OR :P_NRESTRUTGEREN IS NULL)
        AND (INSTR(:LISTA_NRVINCULOM, '_'||GPE_VINCULOH.NRVINCULOM||'_') > 0 OR :LISTA_NRVINCULOM = 'A')
        AND (GPE_VINCULOH.NRVINCULOM IN (SELECT NRVINCULOM FROM FPA_ITEMLOTEVINC WHERE NRORG = :P_NRORG AND INSTR(','||:P_LISTA_LOTE_VINCULOS||',', ','||NRLOTEVINC||',') > 0) OR :P_LISTA_LOTE_VINCULOS IS NULL)
        AND ( INSTR(','
                                            || :P_NRESTRUTLEGALOPER
                                            || ',', ','
                                                    || GPE_VINCULOH.NRESTRUTLEGAL
                                                    || ',') > 0
                                      OR :P_NRESTRUTLEGALOPER IS NULL )
                                AND ( INSTR(','
                                            || :P_NRESTRUTGERENOPER
                                            || ',', ','
                                                    || GPE_VINCULOH.NRESTRUTGEREN
                                                    || ',') > 0
                                      OR :P_NRESTRUTGERENOPER IS NULL )
        AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                           WHERE H1.NRORG = GPE_VINCULOH.NRORG
                                           AND H1.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                           AND H1.DTMESCOMPETENC <= :DTCOMPETENC)
    )
    
    JOIN FPA_EVENTOM 
        ON FPA_EVENTOM.NREVENTOM = FPA_ITECALCFOLHA.NREVENTOM
        AND FPA_EVENTOM.IDTIPOEVENTO = 'PROVENTO'
        
    $condAdmissao
    
    WHERE FPA_ITECALCFOLHA.NRORG = :NRORG
        AND FPA_ITECALCFOLHA.DTOCORRENCIA BETWEEN ADD_MONTHS(:DTCOMPETENC, -1) AND LAST_DAY(TO_DATE(:DTCOMPETENC, 'DD/MM/YYYY'))
        AND FPA_ITECALCFOLHA.NRCALCULOFOLHA = :NRCALCULOVALE
        AND FPA_ITECALCFOLHA.NREVENTOM NOT IN (3030, 3040)
        GROUP BY FPA_ITECALCFOLHA.NRCALCULOFOLHA,
        FPA_ITECALCFOLHA.NRVINCULOM,
        FPA_ITECALCFOLHA.NRORG
SQL;

        $result = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        // $result = Connection::getInstance()->fetchAll($sql, $param);
        
        return $result;
    }
}    