function Rec12300_NotasDevolucaoDisponiveis_Controller(General, ScreenService, templateManager, ZhFilterPreferences) {
	
	this.setReadSelect = function(value, devolucoesDisponiveis, nameField){
		var field = devolucoesDisponiveis.getField(nameField);
		var name = field.name;
		if(value === 'L'){
			field.readOnly = false;
			field.validations.required = true;
		} else {
			delete field.validations.required;
			field.readOnly = true;
		}
		
		// Limpa Campos quando é selecionado Lista
		if(name == 'NMTIPOOPER'){
			field.setValue("");
		} else if(name == 'NMFANTCLIE'){
			field.setValue("");
		} else if(name =='NMFILIAL'){
			field.setValue("");
		}
		
		templateManager.updateTemplate();
	};

	this.checaDisponibilidade = function(field, valor){
		if(field.value() === 'N' && valor > 0){
			field.setValue('S');
			ScreenService.showMessage('Operação bloqueada. Nota Fiscal de Devolução já foi utilizada.');
		}
	};
	
	this.filter = function(widget) {
		var rowFilter = {
			'TPCDCLIENTE'  : 'T',
			'TPCDFILIORIG' : 'T',
			'TPCDTIPOOPER' : 'T',
			'STATUS'       : 'T'
		};
		ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
		ZhFilterPreferences.openFilterWidget(widget, rowFilter);
	};

	this.AjustaFiltro = function(rowFilter){
		var widget = templateManager.container.getWidget('rec12300_notas_devolucao_disponiveis_grid');
		var pos = 0;
		var deletePos = null;
		widget.dataSourceFilter.forEach(function(filter) {
			switch(filter.name){
				case 'DOCINICIAL': filter.value = (rowFilter.DOCINICIAL) ? rowFilter.DOCINICIAL : null;
					break;
				case 'DOCFINAL': filter.value = (rowFilter.DOCFINAL) ? rowFilter.DOCFINAL : null;
					break;
				case 'CDCLIENTE': filter.value = (rowFilter.TPCDCLIENTE == 'L') ? rowFilter.CDCLIENTE.join('_') : '';
					break;
				case 'TPCDCLIENTE': filter.value = rowFilter.TPCDCLIENTE;
					break;
				case 'CDFILIORIG': filter.value = (rowFilter.TPCDFILIORIG == 'L') ? rowFilter.CDFILIORIG.join('_') : '';
					break;
				case 'TPCDFILIORIG': filter.value = rowFilter.TPCDFILIORIG;
					break;
				case 'CDTIPOOPER': filter.value = (rowFilter.TPCDTIPOOPER == 'L') ? rowFilter.CDTIPOOPER.join('_') : '';
					break;
				case 'TPCDTIPOOPER': filter.value = rowFilter.TPCDTIPOOPER;
					break;
				case 'DATAINI': filter.value = (rowFilter.hasOwnProperty('DATA')) ? rowFilter.DATA.start : null;
					break;
				case 'DATAFIN': filter.value = (rowFilter.hasOwnProperty('DATA')) ? rowFilter.DATA.end : null;
					break;
				case 'STATUS': filter.value = rowFilter.STATUS;
					break;
				case 'DATA': deletePos = pos;
					break;
			}
			pos++;
		});
		if (deletePos){
			widget.dataSourceFilter.splice(deletePos, 1);
		}
	};
	
	this.filtroCompensacao = function(widget){
    	var nrlanctonf = templateManager.container.getWidget('rec12300_notas_devolucao_disponiveis_grid').currentRow.NRLANCTONF;
    	var cdfilial = templateManager.container.getWidget('rec12300_notas_devolucao_disponiveis_grid').currentRow.CDFILIAL;
    	
    	widget.dataSourceFilter = [
    			{
	                "name": "NRLANCTONF",
	                "operator": "=",
	                "value": nrlanctonf
    			},
    			{
	                "name": "CDFILIAL",
	                "operator": "=",
	                "value": cdfilial
    			}
    		];
    		widget.reload();
    };
	
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Rec12300_NotasDevolucaoDisponiveis_Controller', Rec12300_NotasDevolucaoDisponiveis_Controller);
});