var Bco11100_movimentacaoContaCorrente_Controller = function(ScreenService, General, templateManager, ZHPromise, restEngine, contabilizacaoController, Bco11100_movimentacaoContaCorrente_Service, ZhFilterPreferences){
    var self = this;
    
    /**
     * Preenche Valores do Stripe
     */
    self.preencheValoresStripe = function(widget){
        var stripeLancamento    = templateManager.container.getWidget('stripeLancamento');
        var stripeTransferencia = templateManager.container.getWidget('stripeTransferencia');
        var stripeExtrato       = templateManager.container.getWidget('stripeExtrato');

        if (widget.name == 'lancamentoContaCorrente'){
            var filtroLancamento = templateManager.container.getWidget('lancamentoContaCorrente').appliedFilter;
            
            stripeLancamento.currentRow.EMPRESA    = filtroLancamento.FILTER_ROW.CDEMPRESA + ' - ' + filtroLancamento.FILTER_ROW.NMEMPRESA;
            stripeLancamento.currentRow.CDCONTCORR = filtroLancamento.FILTER_ROW.CDCONTCORR;
            stripeLancamento.currentRow.DSCONTCORR = filtroLancamento.FILTER_ROW.CONTACORRENTE;
        }else if (widget.name == 'transferenciaContaCorrente'){
            var filtroTransferencia = templateManager.container.getWidget('transferenciaContaCorrente').appliedFilter;
            
            stripeTransferencia.currentRow.EMPRESA = filtroTransferencia.FILTER_ROW.CDEMPRESA + ' - ' + filtroTransferencia.FILTER_ROW.NMEMPRESA;
            
            if (filtroTransferencia.FILTER_ROW.CONTAORIGEM)
                 stripeTransferencia.currentRow.ORIGEM = filtroTransferencia.FILTER_ROW.CONTAORIGEM + ' - ' + filtroTransferencia.FILTER_ROW.ORIGEM;
            else stripeTransferencia.currentRow.ORIGEM = '';
            
            if (filtroTransferencia.FILTER_ROW.CONTADESTINO)
                 stripeTransferencia.currentRow.DESTINO = filtroTransferencia.FILTER_ROW.CONTADESTINO + ' - ' + filtroTransferencia.FILTER_ROW.DESTINO;
            else stripeTransferencia.currentRow.DESTINO = '';
        }else{
            var filtroExtrato = templateManager.container.getWidget('extrato').appliedFilter;
            
            stripeExtrato.currentRow.EMPRESA       = filtroExtrato.FILTER_ROW.CDEMPRESA + ' - ' + filtroExtrato.FILTER_ROW.NMEMPRESA;
            stripeExtrato.currentRow.CONTACORRENTE = filtroExtrato.FILTER_ROW.CDCONTCORR + ' - ' + filtroExtrato.FILTER_ROW.CONTACORRENTE;
            stripeExtrato.currentRow.PERIODO       = 'De ' + filtroExtrato.FILTER_ROW.DTMOVBANC.start + ' até ' + filtroExtrato.FILTER_ROW.DTMOVBANC.end;
        }
    };
    
    /**
     * Altera Stripe
     * Alteração de stripe de acordo com a tela ativada
     */ 
    self.alteraStripe = function(widget){
        var stripeLancamento    = templateManager.container.getWidget('stripeLancamento');
        var stripeTransferencia = templateManager.container.getWidget('stripeTransferencia');
        var stripeExtrato       = templateManager.container.getWidget('stripeExtrato');

        if (widget.name == 'lancamentoContaCorrente'){
            stripeLancamento.isVisible    = true;
            stripeTransferencia.isVisible = false;
            stripeExtrato.isVisible       = false;
        }else if (widget.name == 'transferenciaContaCorrente'){
            stripeLancamento.isVisible    = false;
            stripeTransferencia.isVisible = true;
            stripeExtrato.isVisible       = false;
        }else{
            stripeLancamento.isVisible    = false;
            stripeTransferencia.isVisible = false;
            stripeExtrato.isVisible       = true;
        }
    };

    self.validaActionContabilizacaoTransferencia = function(widget){
        if (widget.currentRow.NRLCTBTRAN){
            widget.getAction('CONTABILIZACAO').isVisible = true;
        }else{
            widget.getAction('CONTABILIZACAO').isVisible = false;
        }
    };

    self.consultarContabilizacaoTransferencia = function(){
        var widget = templateManager.container.getWidget('transferenciaContaCorrente');
        if (widget.currentRow.NRLANCCONT){
            var contabil = [];
            contabil.push({});
            contabil[0].CDEMPRESA  = widget.currentRow.CDEMPRESA;
            contabil[0].NRLANCCONT = widget.currentRow.NRLCTBTRAN;
            contabilizacaoController.exibeContabilizacao(contabil);
        }
    };



    this.setValorFinal = function(widget, valorInicial, valorFinal){
        var novoValorInicial = (valorInicial.value()) ? valorInicial.value() : 0;
        valorInicial.value(novoValorInicial);
        if (widget.getField(valorFinal).value() < novoValorInicial){
            widget.getField(valorFinal).value(valorInicial.value());
        }
    };

    self.setStripeData = function(gridWidget) {
        var currentRow = gridWidget.appliedFilter.FILTER_ROW;
        var stripeWidget = templateManager.container.getWidget("stripe");
        stripeWidget.currentRow = {};
        stripeWidget.currentRow.EMPRESA = currentRow.CDEMPRESA + ' - ' + currentRow.NMEMPRESA;
        stripeWidget.currentRow.CDEMPRESA = currentRow.CDEMPRESA;
        stripeWidget.currentRow.NMEMPRESA = currentRow.NMEMPRESA;
    };

    self.concatenaCamposSelectMultiple = function(widget, fields, codigos){
        var field = null;
        for (i = 0; i < fields.length; i++) {
            field = widget.getField(fields[i]);
            self.setValorConcatenado(widget, field, field.filterProperties.name, codigos[i], 'T'+field.filterProperties.name);
        }
    };

    self.setValorConcatenado = function(widget, field, fieldName, codigo, todos){
        var valorConcatenado = '_';

        if (field.value()) {
            if (field.value().length > 0) {
                field.dataSource.data.forEach(function (data) {
                    if (data.__isSelected) {
                        valorConcatenado += data[codigo] + "_";
                    }
                });
                valorConcatenado = (valorConcatenado != '_') ? valorConcatenado : '';
                widget.dataSourceFilter.forEach(function (filtro) {
                    if (filtro.name.localeCompare(fieldName) === 0) {
                        filtro.value = valorConcatenado;
                    }else if (filtro.name.localeCompare(todos) === 0){
                        filtro.value = '';
                    }
                });
            }else{
                widget.dataSourceFilter.forEach(function (filtro) {
                    if (filtro.name.localeCompare(todos) === 0){
                        filtro.value = 'T';
                    }
                });
            }
        }else{
            if (field.name.localeCompare(fieldName) === 0){
                widget.dataSourceFilter.forEach(function(filtro){
                    if (filtro.name.localeCompare(todos) === 0){
                        filtro.value = 'T';
                    }
                });
            }
        }
    };

    self.setDataSourceFilhos = function(){
        var lancamento = templateManager.container.getWidget('lancamentoContaCorrente');
        var transferencia = templateManager.container.getWidget('transferenciaContaCorrente');
        var extrato = templateManager.container.getWidget('extrato');
        ScreenService.openSwipe(lancamento.getParent()).then(function(){
            self.setLancamentoContaCorrente(lancamento).then(function(){
                lancamento.activate().then(function(){
                    self.iniciaLancamentoFiltro(lancamento);

                });
            });
            self.setTransferenciaContaCorrente(transferencia).then(function(){
                self.iniciaTransferenciaFiltro(transferencia);
            });
            self.setExtratoContaCorrente(extrato).then(function(){
                self.iniciaExtratoFiltro(extrato);
            });
        });
    };

    self.iniciaTransferenciaFiltro = function(transferencia){
        var route = 'fin#/crud/geral_bco';
        General.callRestEngine(route, 'FilterData', [])
            .then(function(response){
                var dttranbanc = transferencia.dataSourceFilter.filter(function(filtro){
                    return filtro.name == 'DTTRANBANC';
                });
                if (dttranbanc.length == 0){
                    var diasAnt  = response.dataset.geral_bco[0].QTDIAANTTRAN;
                    var diasPos  = response.dataset.geral_bco[0].QTDIAAPOTRAN;
                    var start = moment().subtract(diasAnt, 'days').format('DD/MM/YYYY');
                    var end   = moment().add(diasPos, 'days').format('DD/MM/YYYY');
                    var periodoInicial = {
                        "name": "DTTRANBANC",
                        "value": [start, end],
                        "operator": "BETWEEN",
                        "static": true
                    };
                    transferencia.dataSourceFilter.push(periodoInicial);

                    transferencia.getField('DTTRANBANC').filterProperties.defaultValue = {
                        start: start,
                        end: end
                    };
                    transferencia.getField('DTTRANBANC').filterProperties.newLine = true;
                }
                var vrtranbanc_ini = transferencia.dataSourceFilter.filter(function(filtro){
                    return filtro.name == 'VRTRANBANC_INI';
                });
                if (vrtranbanc_ini.length == 0){
                    transferencia.getField('VRTRANBANC_INI').filterProperties.defaultValue = 0;
                    transferencia.getField('VRTRANBANC_INI').filterProperties.newLine = true;
                }
                var vrtranbanc_fin = transferencia.dataSourceFilter.filter(function(filtro){
                    return filtro.name == 'VRTRANBANC_FIN';
                });
                if (vrtranbanc_ini.length == 0){
                    transferencia.getField('VRTRANBANC_FIN').filterProperties.defaultValue = 0;
                    transferencia.getField('VRTRANBANC_FIN').filterProperties.newLine = true;
                }
                transferencia.dataSourceFilter.forEach(function(filtro){
                    switch(filtro.name){
                        case 'VRTODOS': filtro.value = 'T';
                            break;
                        case 'THISTORICO': filtro.value = 'T';
                            break;
                    }
                });
                transferencia.reload();
            })
            .catch(function(erro){
                ScreenService.showMessage(erro.data.error);
            });
    };

    self.setExtratoContaCorrente = function(extrato){
        var deferred = ZHPromise.defer();
        var widgetMovimentacao = templateManager.container.getWidget('movimentacaoContaCorrente');
        extrato.dataSourceFilter.forEach(function(filtro){
            switch(filtro.name){
                case 'CDREDUCONT': filtro.value = (widgetMovimentacao.currentRow.CDREDUCONT) ? widgetMovimentacao.currentRow.CDREDUCONT : null;
                    break;
                default: break;
            }
        });
        deferred.resolve();
        return deferred.promise;
    };


    self.iniciaExtratoFiltro = function(extrato){
        var dtmovbanc = extrato.dataSourceFilter.filter(function(filtro){
            return filtro.name == 'DTMOVBANC';
        });
        
        if (dtmovbanc.length == 0){
            var start = moment().subtract(1, 'Month').format('DD/MM/YYYY');
            var end   = moment().format('DD/MM/YYYY');
            var periodoInicial = {
                "name": "DTMOVBANC",
                "value": [start, end],
                "operator": "BETWEEN",
                "static": true
            };
            extrato.dataSourceFilter.push(periodoInicial);
            extrato.getField('DTMOVBANC').filterProperties.defaultValue = {
                start: start,
                end: end
            };
            extrato.getField('DTMOVBANC').filterProperties.newLine = true;
        }
        extrato.reload();
    };

    self.setLancamentoContaCorrente = function(lancamento){
        var deferred = ZHPromise.defer();
        var widgetMovimentacao = templateManager.container.getWidget('movimentacaoContaCorrente');
        lancamento.dataSourceFilter.forEach(function(filtro){
            switch(filtro.name){
                case 'CDREDUCONT': filtro.value = widgetMovimentacao.currentRow.CDREDUCONT;
                    break;
                default: break;
            }
        });
        deferred.resolve();
        return deferred.promise;
    };
    
    self.aplicaFiltroSaldoContaCorrente = function(widget, preference){
    
    var currentFilter    = preference.FILTER_ROW;
    
    
    var currentFilterNew = Util.clone(currentFilter);
    
    if(currentFilterNew.DATA){
      var partes = currentFilterNew.DATA.split("/");
      var data  = new Date(partes[2], partes[1] - 1, partes[0]);
      
      data.setDate(data.getDate() + 1);
      
      currentFilterNew.DATA = moment(data).format('DD/MM/YYYY');
    }
    
    
    var dataSourceFilter = Bco11100_movimentacaoContaCorrente_Service.buildDataSourceFilterFromFilterRow(currentFilterNew);
    
    widget.dataSourceFilter = dataSourceFilter;
    
    widget.dataSourceFilter.push(
        {
          "name": "CDOPERADOR",
          "operator": "=",
          "value": getLocalVar('CDOPERADOR')
        }
    );
    
    preference.FILTER_ROW = dataSourceFilter;
            
    };

};

Configuration(function (ContextRegister){
    ContextRegister.register('Bco11100_movimentacaoContaCorrente_Controller', Bco11100_movimentacaoContaCorrente_Controller);
});