package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.TitulosAReceberPage;
import org.testng.annotations.Test;

public class TitulosAReceberTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    TitulosAReceberPage titulosAReceberPage;

    @Test
    public void efetuarLancamentoTituloAReceber(){
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAReceberPage= new TitulosAReceberPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";
        String cliente = "Leandro Henrique Ferreira";
        String vrDocumentoRec = "555";
        String dataVencimento = "01012050";
        String nrDocumentoRec = "112233";
        String nfInicial = "0112233";
        String nfFinal = "0112233";

        //Efetuar login
        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosReceber();
        //Confirma Filtro
        titulosAReceberPage.clicarAplicarFiltro(nfInicial, nfFinal);
        //Adicionar Titulo
        titulosAReceberPage.clicarAdionarTituloAReceber();
        titulosAReceberPage.adicionarTituloAReceber(cliente,vrDocumentoRec,dataVencimento, nrDocumentoRec);
        titulosAReceberPage.alterarExcluirTituloAReceber();

    }
    @Test
    public void prorrogarTituloAReceber() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAReceberPage = new TitulosAReceberPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";
        String cliente = "Leandro Henrique Ferreira";
        String vrDocumentoRec = "555";
        String dataVencimento = "01012030";
        String nrDocumentoRec = "112244";
        String nfInicial = "0112244";
        String nfFinal = "0112244";
        String vencimento = "01012050";

        //Efetuar login
        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosReceber();
        //Confirma Filtro
        titulosAReceberPage.clicarAplicarFiltro(nfInicial, nfFinal);
        //Adicionar Titulo
        titulosAReceberPage.clicarAdionarTituloAReceber();
        titulosAReceberPage.adicionarTituloAReceber(cliente, vrDocumentoRec, dataVencimento, nrDocumentoRec);
        titulosAReceberPage.prorrogarTituloAReceber(vencimento);
        titulosAReceberPage.alterarExcluirTituloAReceber();
    }
    @Test
    public void renegociarTituloAReceber() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAReceberPage = new TitulosAReceberPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";
        String nfInicial = "0112255";
        String nfFinal = "0112255";
        String vrAjusteRen = "100";
        String percAjusteRen = "9";
        String descricaoRen = "Renegociar Título";
        String dtVencimentoRen = "01012025";

        //Efetuar login
        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosReceber();
        //Confirma Filtro
        titulosAReceberPage.clicarAplicarFiltro(nfInicial, nfFinal);
        titulosAReceberPage.renegociarTituloAReceber(descricaoRen,vrAjusteRen, percAjusteRen, dtVencimentoRen);
        titulosAReceberPage.cancelaRenegociacaoTitulosAReceber();
    }
    @Test
    public void emitirTituloAReceber() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAReceberPage = new TitulosAReceberPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";
        String nfInicial = "0112266";
        String nfFinal = "0112266";

        //Efetuar login
        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosReceber();
        //Confirma Filtro
        titulosAReceberPage.clicarAplicarFiltro(nfInicial, nfFinal);
        titulosAReceberPage.emitirTituloAReceber();
    }

    @Test
    public void gerarRemessaTituloAReceber() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAReceberPage = new TitulosAReceberPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";
        String nfInicial = "0112277";
        String nfFinal = "0112277";

        //Efetuar login
        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosReceber();
        //Confirma Filtro
        titulosAReceberPage.clicarAplicarFiltro(nfInicial, nfFinal);
        titulosAReceberPage.gerarRemessaTituloAReceber();
    }

    @Test
    public void enviarEmailTituloAReceber() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAReceberPage = new TitulosAReceberPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";
        String nfInicial = "0112288";
        String nfFinal = "0112288";

        //Efetuar login
        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosReceber();
        //Confirma Filtro
        titulosAReceberPage.clicarAplicarFiltro(nfInicial, nfFinal);
        titulosAReceberPage.enviarEmailTituloAReceber();
    }

    @Test
    public void BaixarTituloAReceber() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAReceberPage = new TitulosAReceberPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";
        String nfInicial = "0112299";
        String nfFinal = "0112299";
        String txtObservacao = "Baixa Automatica";

        //Efetuar login
        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosReceber();
        //Confirma Filtro
        titulosAReceberPage.clicarAplicarFiltro(nfInicial, nfFinal);
        titulosAReceberPage.baixarTituloAReceber(txtObservacao);
    }

    @Test
    public void cadastramentoAutTituloAReceber() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAReceberPage = new TitulosAReceberPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";
        String cliente = "Leandro Henrique Ferreira";
        String vrDocumento = "333";

        //Efetuar login
        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosReceber();
        titulosAReceberPage.cadastramentoAutTituloAReceber(cliente, vrDocumento);
    }
    @Test
    public void enviarCartaCobrancaTituloAReceber() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAReceberPage = new TitulosAReceberPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";
        String nfInicial = "0112211";
        String nfFinal = "0112211";

        //Efetuar login
        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosReceber();
        //Confirma Filtro
        titulosAReceberPage.clicarAplicarFiltro(nfInicial, nfFinal);
        titulosAReceberPage.cartaCobrancaEmailTitulosAReceber();
    }

    @Test
    public void descontarTituloAReceber() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAReceberPage = new TitulosAReceberPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";
        String nfInicial = "0112222";
        String nfFinal = "0112222";
        String vrDocumento = "99";
        String descricaoDesconto = "Automatização";

        //Efetuar login
        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosReceber();
        //Confirma Filtro
        titulosAReceberPage.clicarAplicarFiltro(nfInicial, nfFinal);
        titulosAReceberPage.descontarTituloAReceber(vrDocumento, descricaoDesconto);
    }

}