package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;

import java.util.concurrent.TimeUnit;

public class ContaCorrenteExcluirPage extends PageBase {

    //Navegar até Conta Corrente
    By BotaoProcurar = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[1]/section/input");
    By Financeiro = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section[2]/section/header/div/div/ul/li[1]/label/a");
    By MENU = By.xpath("//div[@class='bars']");
    By ContaCorrente = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[4]/span/span[3]");

    //Filtro

    By Banco = By.cssSelector("#NMBANCO");
    By OpcaoBanco = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[1]/div/div[1]/div[1]/div/div[3]/span[4]");

    By Agencia = By.cssSelector("#NMAGENCIA");
    By OpcaoAgencia = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[1]/div/div[1]/div[2]/div/div[3]/span[1]");

    By CDREDUCONT = By.cssSelector("#CDREDUCONT");

    By MaisCampos = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[2]/label/span[2]");

    By AplicarFiltro = By.cssSelector("#footer > div.zh-footer-right > ul > li > a > span");

    //Adiconar Conta
    By ClicarAdcionar = By.xpath("//*[@id=\"footer\"]/div[2]/ul/li/a/div");

    By CampoContaCorrente = By.cssSelector("#CDCONTCORR");

    By CampoBanco = By.cssSelector("#NMBANCO");
    By OpcaoCampoBanco = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[1]/div[1]/div/div[3]/span[4]");

    By CampoAgencia = By.cssSelector("#NMAGENCIA");
    By OpcaoCampoAgencia = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[1]/div[2]/div/div[3]/span[1]");

    By Tipo = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[2]/div[3]/div/div[2]/span");
    By OpcaoTipo = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[2]/div[3]/div/div[2]/ul/li[1]");

    By Descricao = By.cssSelector("#DSCONTCORR");

    By Empresa = By.cssSelector("#NMEMPRESA");
    By OpcaoEmpresa = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[4]/div/div/div[3]/span");

    By ContaContabil = By.cssSelector("#NMCONTCTBL");
    By OpcaoContaContabil = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[5]/div[1]/div/div[3]/span[1]");

    By ContaDesconto = By.cssSelector("#NMCCTBCAUCIO");
    By OpcaoContaDesconto = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[5]/div[2]/div/div[3]/span[2]");

    By ContaAtiva = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[5]/div[3]/div/div[2]");
    By OpcaoContaAtiva = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[5]/div[3]/div/div[2]/ul/li[1]");

    By Salvar = By.xpath("//*[@id=\"footer\"]/div[3]/ul/li/a/span");

    //Implantação de Saldo

    By OpcaoSim = By.xpath("/html/body/span/section/section/div[2]/aside[1]/aside/section/footer/button[1]");

    By Data = By.cssSelector("#DTSDOCCORR");
    By SaldoImplantado = By.cssSelector("#VRSDOIMPLA");

    By BotaoOk = By.xpath("/html/body/span/section/section/div[2]/aside[1]/aside/section/footer/button");

    //Evoluir Saldo

    By CheckBox = By.cssSelector("#grid-1547514630820780607600 > div.body > div > div > div.td.grid-checkbox-column.zh-side-column.fixed.zh-ripple-effect > span > svg > rect");

    By BotaoEvoluirSaldo= By.xpath("//*[@id=\"footer\"]/div[3]/ul/li/a/span");

    By DATAINICIAL = By.cssSelector("#DATAINICIAL");

    By ContaTeste = By.xpath("//*[@id=\"grid-1547514630820780607600\"]/div[2]/div/div/div[2]/span");
    By Excluir = By.cssSelector(".zh-ripple-effect:nth-child(2) .zh-test-box");




    public void NavegarParaContaCorrente(String Procurar) {
        waitForElement(Financeiro);
        waitForElement(MENU);
        click(MENU);
        click(BotaoProcurar);
        clear(BotaoProcurar);
        sendKeys(BotaoProcurar, Procurar);
        click(ContaCorrente);
    }

    public void Filtro() {

        waitForElement(Banco);
        click(Banco);
        click(OpcaoBanco);

        click(Agencia);
        click(OpcaoAgencia);

        click(CDREDUCONT);
        click(MaisCampos);

        click(AplicarFiltro);
    }

    public void AdicionarConta(String CodigoReduzidoCCC, String NumeroCCC, String DescricaoCCC) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);

        waitForElement(CampoBanco);
        click(CampoBanco);
        click(OpcaoCampoBanco);

        click(CampoAgencia);
        click(OpcaoCampoAgencia);

        click(CDREDUCONT);
        clear(CDREDUCONT);
        sendKeys(CDREDUCONT, CodigoReduzidoCCC);

        click(CampoContaCorrente);
        clear(CampoContaCorrente);
        sendKeys(CampoContaCorrente, NumeroCCC);

        click(Descricao);
        clear(Descricao);
        sendKeys(Descricao, DescricaoCCC);

        click(Tipo);
        click(OpcaoTipo);

        click(Empresa);
        click(OpcaoEmpresa);

        click(ContaContabil);
        click(OpcaoContaContabil);

        click(ContaDesconto);
        click(OpcaoContaDesconto);

        click(ContaAtiva);
        click(OpcaoContaAtiva);

        click(Salvar);

    }

    public void ImplantacaoSaldo(String DTSDOCCORR, String VRSDOIMPLA) {

        waitForElement(OpcaoSim);
        click(OpcaoSim);

        waitForElement(Data);

        click(Data);
        clear(Data);
        sendKeys(Data, DTSDOCCORR);

        click(SaldoImplantado);
        clear(SaldoImplantado);
        sendKeys(SaldoImplantado, VRSDOIMPLA);

        click(Salvar);
        click(BotaoOk);

    }

    public void EvoluirSaldo(String DATAINICIALEvolucao) {

        waitForElement(CheckBox);
        click(CheckBox);

        click(BotaoEvoluirSaldo);

        click(DATAINICIAL);

        //clear(DATAINICIAL);
        sendKeys(DATAINICIAL, DATAINICIALEvolucao);

        click(BotaoEvoluirSaldo);
        click(BotaoOk);

    }

    public void Excluir() {
        waitForElement(ContaTeste);
        click(ContaTeste);
        click(Excluir);
        click(OpcaoSim);


    }

    public void AlertaUsuario() throws InterruptedException {
        this.driver.manage().timeouts().implicitlyWait(1, TimeUnit.MINUTES);
        driver.findElement(By.cssSelector("body > span > section > section > div.default-window > aside:nth-child(5) > aside > section > footer > button:nth-child(1)")).click();
    }

}
