var Pag00001_TitulosAPagar_Controller = function(templateManager, ScreenService, ZHPromise, General, contabilizacaoController, Pag00001_TitulosAPagar_Service, ZhFilterPreferences, localStorageEngine, metaDataFactory, ValidationEngine)
{
    /**
     * Variáveis de Inicialização
     **/
    var self = this;
    var idhabibole_geral       = null;
    var idutilpadrbolhab_geral = null;
    
    var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
    
    /** [Início]Título a Pagar/Pagos[Filtro] */

    /**
     * Force Activate
     */
    self.forceActivate = function(){
        templateManager.container.getWidget('TitulosAPagarGrid').activate();
    };

    /**
     * Preenche Valor Final
     * @param widget
     * @param inicial
     * @param final
     */
    self.preencheValorFinal = function(widget, inicial, final){
        var fieldInicial = widget.getField(inicial);
        var fieldFinal = widget.getField(final);
        if ((!fieldFinal.value()) || (parseInt(fieldInicial.value()) > parseInt(fieldFinal.value()))){
            fieldFinal.setValue(fieldInicial.value());
        }
    };

    /**
     * Filtro
     * @param widget
     */
    self.filtroCnabRetorno = function(widget, preference){
        var currentRowFiltro = preference.FILTER_ROW;

        var vrbaixapagini     = currentRowFiltro.VRBAIXAPAGINI;
        var vrbaixapagfin     = currentRowFiltro.VRBAIXAPAGFIN;
        var vrtotalcnabpagini = currentRowFiltro.VRTOTALCNABPAGINI;
        var vrtotalcnabpagfin = currentRowFiltro.VRTOTALCNABPAGFIN;
        var nrnotafiscini     = currentRowFiltro.NRNOTAFISCINI;
        var nrnotafiscfin     = currentRowFiltro.NRNOTAFISCFIN;
        var vrfinalbpagini    = currentRowFiltro.VRFINALBPAGINI;
        var vrfinalbpagfin    = currentRowFiltro.VRFINALBPAGFIN;
        var vrbolpagini       = currentRowFiltro.VRBOLPAGINI;
        var vrbolpagfin       = currentRowFiltro.VRBOLPAGFIN;
        var nrcnabpagremini   = currentRowFiltro.NRCNABPAGREMINI;
        var nrcnabpagremfin   = currentRowFiltro.NRCNABPAGREMFIN;
        var nrcnabpagretini   = currentRowFiltro.NRCNABPAGRETINI;
        var nrcnabpagretfin   = currentRowFiltro.NRCNABPAGRETFIN;
        var cdreducont        = currentRowFiltro.CDREDUCONT;

        widget.dataSourceFilter.forEach(function (filtro) {
            switch(filtro.name){
                case 'VRBAIXAPAGINI': filtro.value = vrbaixapagini <= 0 ? null : vrbaixapagini;
                    break;
                case 'VRBAIXAPAGFIN': filtro.value = vrbaixapagfin <= 0 ? null : vrbaixapagfin;
                    break;
                case 'VRBAIXAPAGTOT': filtro.value = ((vrbaixapagini == 0) && (vrbaixapagfin == 0)) || (!vrbaixapagini && !vrbaixapagfin) ? 'T' : null;
                    break;
                case 'VRTOTALCNABPAGINI': filtro.value = vrtotalcnabpagini <= 0 ? null : vrtotalcnabpagini;
                    break;
                case 'VRTOTALCNABPAGFIN': filtro.value = vrtotalcnabpagfin <= 0 ? null : vrtotalcnabpagfin;
                    break;
                case 'VRTOTALCNABPAGTOT': filtro.value = ((vrtotalcnabpagini == 0) && (vrtotalcnabpagfin == 0)) || (!vrtotalcnabpagini && !vrtotalcnabpagfin) ? 'T' : null;
                    break;
                case 'NRNOTAFISCINI': filtro.value = nrnotafiscini;
                    break;
                case 'NRNOTAFISCFIN': filtro.value = nrnotafiscfin;
                    break;
                case 'NRNOTAFISCTOT': filtro.value = (nrnotafiscini && nrnotafiscfin) ? null : 'T';
                    break;
                case 'VRFINALBPAGINI': filtro.value = vrfinalbpagini <= 0 ? null : vrfinalbpagini;
                    break;
                case 'VRFINALBPAGFIN': filtro.value = vrfinalbpagfin <= 0 ? null : vrfinalbpagfin;
                    break;
                case 'VRFINALBPAGTOT': filtro.value = ((vrfinalbpagini == 0) && (vrfinalbpagfin == 0)) || (!vrfinalbpagini && !vrfinalbpagfin) ? 'T' : null;
                    break;
                case 'VRBOLPAGINI': filtro.value = vrbolpagini <= 0 ? null : vrbolpagini;
                    break;
                case 'VRBOLPAGFIN': filtro.value = vrbolpagfin <= 0 ? null : vrbolpagfin;
                    break;
                case 'VRBOLPAGTOT': filtro.value = ((vrbolpagini == 0) && (vrbolpagfin == 0)) || (!vrbolpagini && !vrbolpagfin) ? 'T' : null;
                    break;
                case 'NRCNABPAGREMINI': filtro.value = nrcnabpagremini;
                    break;
                case 'NRCNABPAGREMFIN': filtro.value = nrcnabpagremfin;
                    break;
                case 'NRCNABPAGREMTOT': filtro.value = (nrcnabpagremini && nrcnabpagremfin) ? null : 'T';
                    break;
                case 'NRCNABPAGRETINI': filtro.value = nrcnabpagretini;
                    break;
                case 'NRCNABPAGRETFIN': filtro.value = nrcnabpagretfin;
                    break;
                case 'NRCNABPAGRETTOT': filtro.value = (nrcnabpagretini && nrcnabpagretfin) ? null : 'T';
                    break;
                case 'CDREDUCONT': filtro.value = cdreducont;
                    break;
                case 'TCDREDUCONT': filtro.value = (cdreducont) ? null : 'T';
                    break;
            }
        });
        
    };
    
    self.cloneFilter = function (widgetOrigem_name, widgetDestino_name){
        var widgetOrigem  = templateManager.container.getWidget(widgetOrigem_name);
        var widgetDestino = templateManager.container.getWidget(widgetDestino_name);
        
        widgetDestino.appliedFilter = widgetDestino.appliedFilter == undefined ? [] : widgetDestino.appliedFilter;
        widgetDestino.appliedFilter.FILTER_ROW = widgetOrigem.appliedFilter.FILTER_ROW;
        
        widgetDestino._filterInfo = widgetOrigem._filterInfo;
    };
    
    self.cloneData = function (widgetOrigem_name, widgetDestino_name){
        var widgetOrigem  = templateManager.container.getWidget(widgetOrigem_name);
        var widgetDestino = templateManager.container.getWidget(widgetDestino_name);
        
        widgetDestino.dataSourceFilter         = widgetOrigem.dataSourceFilter;
        widgetDestino.dataSource.data          = widgetOrigem.dataSource.data;
        
        self.buildDataSourceKanban();
    };

	/**
     * Busca Empresa
     * @return empresa
     */
    self.buscaEmpresa = function (cdempresa){
        return Pag00001_TitulosAPagar_Service.buscaEmpresa(cdempresa).then(function(empresa) {
            return empresa;
        });
    };

    /**
     * Busca Parametro por Filial - Filial - Empresa Controla Filial
     * @return paramfilial_filial_emprcntrfil
     */
    self.buscaParamfilialFilialEmprcntrfil = function (cdempresa, cdfilial){
        return Pag00001_TitulosAPagar_Service.buscaParamfilialFilialEmprcntrfil(cdempresa, cdfilial).then(function(paramfilial_filial_emprcntrfil) {
            return paramfilial_filial_emprcntrfil;
        });
    };

    /**
     * Tipo de Operação
     * @return tipooperac
     */
    self.buscaTipooperac = function (cdtipooper){
        return Pag00001_TitulosAPagar_Service.buscaTipooperac(cdtipooper).then(function(tipooperac) {
            return tipooperac;
        });
    };

    /**
     * Série de Entrada
     * @return serieentr
     */
    self.buscaSerieentr = function (cdserieentr){
        return Pag00001_TitulosAPagar_Service.buscaSerieentr(cdserieentr).then(function(serieentr) {
            return serieentr;
        });
    };

    /**
     * Tipo de Conta a Pagar
     * @return cdtpctpagar
     */
    self.buscaTipoctpagar = function (cdtpctpagar){
        return Pag00001_TitulosAPagar_Service.buscaTipoctpagar(cdtpctpagar).then(function(tipoctpagar) {
            return tipoctpagar;
        });
    };

    /**
     * Busca Filial
     * @return filial
     */
    self.buscaFilial = function (){
        return Pag00001_TitulosAPagar_Service.buscaFilial().then(function(filial) {
            return filial;
        });
    };

    /**
     * Busca Parametrização Geral Pagar
     * @return paramGeral
     */
    self.buscaGeralPag = function (){
        return Pag00001_TitulosAPagar_Service.buscaGeralPag().then(function(geralpag) {
            return geralpag;
        });
    };

    /**
     * Busca Parâmetros de Estoque
     * @return dataProcessamento
     */
    self.buscaParamEstoque = function (){
        return Pag00001_TitulosAPagar_Service.buscaParamEstoque().then(function(paramestoque) {
            return paramestoque;
        });
    };

    /**
     * Busca Parâmetros de Contabilização
     * @return contOpeCtbl
     */
    self.buscaContOpeCtbl = function (){
        return Pag00001_TitulosAPagar_Service.buscaContOpeCtbl().then(function(paramestoque) {
            return paramestoque;
        });
    };
    
    self.openFilterTitulosAPagar = function(widgetTitulosAPagar){
        self.buscaDadosIniciaisFiltro(widgetTitulosAPagar).then(function(){
            var rowSetFilter = {};
            if(sessionStorage.getItem('DASHBOARD_NAME') == 'widgetTitulosPagar'){
                rowSetFilter = {
                    'DTVENBOLPAG': {
                        "start": sessionStorage.getItem('DTVENBOLPAG.start'),
                        "end": sessionStorage.getItem('DTVENBOLPAG.end'),
                    },    
                    'CDEMPRESA': sessionStorage.getItem('CDEMPRESA'),
                    'NMEMPRESA': sessionStorage.getItem('NMEMPRESA'),
                    'IDSTATBPAG': ["A"]
                };
                ZhFilterPreferences.setOriginalFilter(widgetTitulosAPagar.id, rowSetFilter);
                ZhFilterPreferences.openFilterWidget(widgetTitulosAPagar, rowSetFilter);
            } else if((sessionStorage.getItem('DASHBOARD_NAME') == 'boletPagarVenc') || (sessionStorage.getItem('DASHBOARD_NAME') == 'boletPagarAberto') || (sessionStorage.getItem('DASHBOARD_NAME') == 'boletPagarBaixa')){
                rowSetFilter = {
                    'DTVENBOLPAG': {
                        "start": sessionStorage.getItem('DTVENBOLPAG.start'),
                        "end": sessionStorage.getItem('DTVENBOLPAG.end'),
                    },    
                    'CDEMPRESA': sessionStorage.getItem('CDEMPRESA'),
                    'NMEMPRESA': sessionStorage.getItem('NMEMPRESA'),
                    'IDSTATBPAG': getItem('IDSTATBPAG').split(",")
                };
                ZhFilterPreferences.setOriginalFilter(widgetTitulosAPagar.id, rowSetFilter);
                ZhFilterPreferences.openFilterWidget(widgetTitulosAPagar, rowSetFilter);
            } else {
                rowSetFilter = {
                    'DTVENBOLPAG': widgetTitulosAPagar.DTVENBOLPAG,
                    'CDEMPRESA': widgetTitulosAPagar.empresa.CDEMPRESA,
                    'NMEMPRESA': widgetTitulosAPagar.empresa.NMEMPRESA
                };
                ZhFilterPreferences.setOriginalFilter(widgetTitulosAPagar.id, rowSetFilter);
                ZhFilterPreferences.openFilterWidget(widgetTitulosAPagar, rowSetFilter);
            }
            
            if((sessionStorage.getItem('DASHBOARD_NAME') == 'rastreioContabil')){
                var fornecedor = [];
                fornecedor.push(sessionStorage.getItem('CDFORNECED'));
                if(sessionStorage.getItem('ORIGEM') == 'BAIXA_PAG'){
                    rowSetFilter = {   
                        'DTVENBOLPAG': {start : '', end : ''},
                        'DTBAIXAPAG': {start : sessionStorage.getItem('DTBAIXAPAG'), 
                                         end : sessionStorage.getItem('DTBAIXAPAG')},
                        'VRBAIXAPAGINI': sessionStorage.getItem('VRBAIXAPAGINI'),
                        'VRBAIXAPAGFIN': sessionStorage.getItem('VRBAIXAPAGFIN'),
                        'CDEMPRESA': sessionStorage.getItem('CDEMPRESA'),
                        'NMEMPRESA': sessionStorage.getItem('NMEMPRESA')
                    };
                }else{
                    rowSetFilter = {   
                        'DTVENBOLPAG': {start : '', end : ''},
                        'NRNOTAFISCINI': sessionStorage.getItem('NRNOTAFISCINI'),
                        'NRNOTAFISCFIN': sessionStorage.getItem('NRNOTAFISCFIN'),
                        'CDEMPRESA': sessionStorage.getItem('CDEMPRESA'),
                        'NMEMPRESA': sessionStorage.getItem('NMEMPRESA'),
                        'CDFORNECED': fornecedor
                    };
                }
                
                ZhFilterPreferences.setOriginalFilter(widgetTitulosAPagar.id, rowSetFilter);
                ZhFilterPreferences.openFilterWidget(widgetTitulosAPagar, rowSetFilter);
            }
            
        });

    };
    
    self.buscaDadosIniciaisFiltro = function(widgetTitulosAPagar) {
        var deferred = ZHPromise.defer();
        self.buscaPadraoEmpresa(widgetTitulosAPagar).then(function(){
            self.buscaPadraoIntervaloVencimento(widgetTitulosAPagar).then(function(){
                deferred.resolve();        
            });    
        });
        
        return deferred.promise;
    };

    /**
     * Busca Padrão Empresa
     * @param widget
     */
    self.buscaPadraoEmpresa = function(widget) {
        var deferred = ZHPromise.defer();
        self.buscaFilial().then(function(response_filial){
            var filial   = response_filial.dataset.filial[0];
            var cdempresa = filial.CDEMPRESA;

            self.buscaEmpresa(cdempresa).then(function (response_empresa){
                var empresa = response_empresa.dataset.empresa[0];
                widget.empresa = empresa;
                deferred.resolve();
            });
        });
        
        return deferred.promise;
    };

    /**
     * Busca Padrão Intervalo Vencimento
     * @returns {{start: *, end: *}}
     */
    self.buscaPadraoIntervaloVencimento = function (widget){
        var deferred = ZHPromise.defer();
        var geralpag     = self.buscaGeralPag();
        var paramestoque = self.buscaParamEstoque();

        ZHPromise.all([geralpag, paramestoque]).then(function(response){
            geralpag     = response[0].dataset.geral_pag[0];
            paramestoque = response[1].dataset.paramestoque_processamento[0];
            
            idhabibole_geral       = geralpag.IDHABIBOLE;
            idutilpadrbolhab_geral = geralpag.IDUTILPADRBOLHAB;

            var qtdiaantlanr = geralpag?geralpag.QTDIAANTBOLP?geralpag.QTDIAANTBOLP:0:0;
            var qtdiaapolanr = geralpag?geralpag.QTDIAAPOBOLP?geralpag.QTDIAAPOBOLP:0:0;
            var dtprocessa   = paramestoque?paramestoque.DTPROCESSA?paramestoque.DTPROCESSA:moment():moment();

            var start = moment(dtprocessa, 'DD/MM/YYYY').subtract(qtdiaantlanr, 'days').format('DD/MM/YYYY');
            var end   = moment(dtprocessa, 'DD/MM/YYYY').add(qtdiaapolanr, 'days').format('DD/MM/YYYY');

            widget.DTVENBOLPAG = {start : start, end : end};
            deferred.resolve();
        });
        return deferred.promise;
    };

    /** [Fim]Título a Pagar/Pagos [Filtro] */

    /** [Início]Título a Pagar/Pagos */

    /**
     * Novo Título a Pagar
     */
    self.novoTituloAPagar = function(){
        if(!templateManager.container.getWidget('TitulosAPagarGrid').appliedFilter.FILTER_ROW.CDEMPRESA) {
            ScreenService.showMessage('Operação bloqueada. Empresa não selecionada no filtro.');
            return;
        }
        
        General.callRestEngine('fin#/crud/geral_pag','FilterData', []).then(function(result){
            if(result.dataset.geral_pag.length == 0){
                ScreenService.showMessage('Operação bloqueada. Parametrizações não encontradas, verifique a tela de Parâmetros de Títulos a Pagar.');
                return;
            }
            
            self.validaTipoContaEmpresa().then(function(){
                var widgetDocumentosForm = templateManager.container.getWidget('DocumentosForm');
                widgetDocumentosForm.getField('NMRATEIO').setValue('');
                widgetDocumentosForm.getField('NMRATEIO').readOnly = true;
                widgetDocumentosForm.isVisible = true;
                widgetDocumentosForm.editing = true;
                ScreenService.openSwipe(widgetDocumentosForm).then(function(){
                    templateManager.updateTemplate();
                    self.buscaPadraoTitulo();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                    return;
                });
            }, function (error) {
                ScreenService.showMessage('Operação bloqueada. Empresa selecionada no filtro não possui tipo de conta relacionada na tela Tipo de Título a Pagar.');
                return;
            });
            
            
        }, function (error) {
            ScreenService.showMessage(error.data.error);
            return;
        });
        
    };
    
    self.validaTipoContaEmpresa = function(){
        var deferred = ZHPromise.defer();
        
        var filter = [
            {
                "name": "CDEMPRESA",
                "operator": "=",
                "value": "T"
            }
        ];
        
        General.callRestEngine('fin#/crud/emprtpctpag_empresa','FilterData',filter).then(function(empresas){
            empresas = empresas.dataset.emprtpctpag_empresa;
            
            if(empresas.length > 0){
                var cdempresa = templateManager.container.getWidget('TitulosAPagarGrid').appliedFilter.FILTER_ROW.CDEMPRESA;
                
                filter = [
                    {
                        "name": "CDEMPRESA",
                        "operator": "=",
                        "value": cdempresa
                    }
                ];
        
                General.callRestEngine('fin#/crud/emprtpctpag_empresa','FilterData',filter).then(function(empresas){
                    empresas = empresas.dataset.emprtpctpag_empresa;
                    
                    if(empresas.length > 0)
                       deferred.resolve();
                    else deferred.reject();
                });
            }else{
                deferred.resolve();
            }
        });
        
        return deferred.promise;
    };
    
    /**
     * Busca Padrão Título
     */
    self.buscaPadraoTitulo = function (){
        var widgetTitulosAPagarGrid = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetDocumentosForm    = templateManager.container.getWidget('DocumentosForm');
        
        widgetDocumentosForm.getField('CDEMPRESA').setValue(widgetTitulosAPagarGrid.appliedFilter.FILTER_ROW.CDEMPRESA);
        widgetDocumentosForm.getField('NMEMPRESA').setValue(widgetTitulosAPagarGrid.appliedFilter.FILTER_ROW.NMEMPRESA);
        
        self.buscaPadraoFilial(widgetDocumentosForm);
        
        widgetDocumentosForm.getField('NRORG').setValue(getLocalVar('NRORG'));
        widgetDocumentosForm.getField('CDFILIAL').setValue(getLocalVar('CDFILIAL'));
        widgetDocumentosForm.getField('CDOPERACTPG').setValue(getLocalVar('CDOPERADOR'));
        widgetDocumentosForm.getField('IDSTATUS').setValue('A');
        widgetDocumentosForm.getField('DTEMISSAO').setValue(moment().format('DD/MM/YYYY'));
        widgetDocumentosForm.getField('DTENTRSAID').setValue(moment().format('DD/MM/YYYY')); 
        widgetDocumentosForm.getField('DTATUAVENPAG').setValue(moment().format('DD/MM/YYYY'));
        widgetDocumentosForm.getField('CDFORNECED').setValue(null);
        widgetDocumentosForm.getField('NMRAZSOCFORN').setValue(null);
        widgetDocumentosForm.getField('CDTIPOOPER').setValue(null);
        widgetDocumentosForm.getField('NMTIPOOPER').setValue(null);
        widgetDocumentosForm.getField('CDTPCTPAGAR').setValue(null);
        widgetDocumentosForm.getField('DSTPCTPAGAR').setValue(null);
        widgetDocumentosForm.getField('DSDEFACTPAG').setValue(null);
        widgetDocumentosForm.getField('VRNOTAFISC').setValue(null);
        
        // Parcelamento
        var widgetParcelamentoDocGrid = templateManager.container.getWidget('ParcelamentoDocGrid');
        
        widgetParcelamentoDocGrid.currentRow = {};
        widgetParcelamentoDocGrid.dataSource.data = [];
    };
    
    /**
     * Busca Padrão Título
     */
    self.changeValorDoc = function (){
        var widgetDocumentosForm = templateManager.container.getWidget('DocumentosForm');
        var widgetParcelamentoDocGrid = templateManager.container.getWidget('ParcelamentoDocGrid');
        var gridRateio = templateManager.container.getWidget("RateioDocGrid");
        
        widgetParcelamentoDocGrid.currentRow = {};
        widgetParcelamentoDocGrid.dataSource.data = [];
        
        if(self.formataValor(widgetDocumentosForm.currentRow.VRNOTAFISC) > 0){
            widgetDocumentosForm.getField('NMRATEIO').readOnly    = false;
            widgetParcelamentoDocGrid.currentRow.__index          = 0;
            widgetParcelamentoDocGrid.currentRow.NRPARCBOLPAG     = '00';
            widgetParcelamentoDocGrid.currentRow.NRPARCBOLPAGVISU = '000';
            widgetParcelamentoDocGrid.currentRow.IDEXCLUIR        = null;
            widgetParcelamentoDocGrid.currentRow.DSCONTAPAG       = widgetDocumentosForm.currentRow.DSDEFACTPAG?widgetDocumentosForm.currentRow.DSDEFACTPAG:widgetDocumentosForm.currentRow.DSTPCTPAGAR;
            widgetParcelamentoDocGrid.currentRow.VRFINALBPAG      = widgetDocumentosForm.currentRow.VRNOTAFISC;
            widgetParcelamentoDocGrid.dataSource.data             = [widgetParcelamentoDocGrid.currentRow];
        }else{
            widgetDocumentosForm.getField('NMRATEIO').readOnly    = true;
            widgetDocumentosForm.getField('NMRATEIO').setValue('');
            gridRateio.dataSource.data = [];
            
        }
        
        templateManager.updateTemplate();
    };

    /**
     * Edita Titulo A Pagar
     * @param args
     */
    self.editTituloAPagar = function(args){
        var widget = args.owner.widget;

        if((widget.currentRow.IDSTATBPAG == 'B') || (widget.currentRow.IDSTATBPAG == 'P')) {
            ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
            return;
        }
        if(widget.currentRow.IDSITUCNABP != '00') {
            ScreenService.showMessage('Operação bloqueada. Título enviado, via CNAB, não pode ser alterado.');
            return;
        }
        if(widget.currentRow.IDSTATUS == 'V') {
            ScreenService.showMessage('Operação bloqueada. Título previsto não pode ser alterado.');
            return;
        }
        if(widget.currentRow.IDBLOQNFFINCP == 'B') {
            ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
            return;
        }

        General.widgetEdit(args.owner.widget);
        self.changeTipoBaixa(widget, true);
        self.changeDsboletpag(false);
    };

    /**
     * Edita Titulo A Pagar
     * @param args
     */
    self.editaTituloAPagar = function(args){
        var widget = args.owner.widget;
        widget.currentRow.CODEQRPIX = widget.currentRow.CODEQRPIX ? widget.currentRow.CODEQRPIX : null;//por algum motivo o default value n quer preencher
        if(widget.isValid()){
            //pix santanter 
            // if(widget.currentRow.CDBANCO == '033' && (widget.currentRow.CHAVEPIX ||widget.currentRow.CODEQRPIX)  && !widget.currentRow.CDCCORBOLP){
            //     ScreenService.showMessage('Operação bloqueada. Santander requer conta do favorecido para pagamento pix.', 'checked');
            //     return;
            // }
            if(widget.currentRow.DSLINHBARPAG && !widget.currentRow.CDBARRAPAG){
                ScreenService.showMessage('Operação bloqueada. Representação numérica inválida.', 'checked');
                return;
            }

            if(widget.currentRow.CDBARRAPAG && !widget.currentRow.DSLINHBARPAG) {
                self.validaCodigoBarras('TitulosAPagarGrid', 'CDBARRAPAG', 'DSLINHBARPAG', 'VRBOLPAG', 'VRFINALBPAG').then(function () {
                    self.validaPix(widget).then(function(){
                        self.confirmaEditaTituloAPagar(widget);    
                    });
                });
            }else {
                self.validaPix(widget).then(function(){
                    self.confirmaEditaTituloAPagar(widget);    
                });
            }
        }
    };
    
   /**
    *Valida Pix antes de salvar
    * se resolvida a promisse salva
    */

    self.validaPix = function(widget){
        var deferred = ZHPromise.defer();
        widget.naoRelacionaPix = false;
        if(widget.getField('CHAVEPIX')._lastItemSearch && !widget.naoRelacionaPix){
            if(!widget.currentRow.IDCHAVEPIX){
                ScreenService.showMessage('Operação bloqueada. Informe o tipo de chave pix.', 'checked');
                deferred.reject();
                return deferred;
            }
            ScreenService.confirmMessage('Deseja salvar essa chave pix para este fornecedor?', 'question', function () {
                var pixWidget = widget.getField('CHAVEPIX').widgets[0];
                pixWidget.relacionandoPix = true;
                self.abrePopUpAddPIX(pixWidget);
                return deferred.reject();
            }, function(){
                widget.naoRelacionaPix = true;
                widget.currentRow.CHAVEPIX = widget.getField('CHAVEPIX')._lastItemSearch;
                return deferred.resolve();
            });
        }
        else{
            deferred.resolve();
        }
        return deferred;
    };


    /**
     * Valida Is Reload
     * @param widget
     * @param field_name
     */
    self.validaIsReload = function(widget, field_name){
        var contaFavorecido =  widget.getField(field_name);
        if (contaFavorecido.isReload){
            contaFavorecido.reload().then(function(){
                self.validaReloadContaFavorecido(widget, field_name, false);
            });
        }
    };

    /**
     * Valida Reload Conta Favorecido
     * @param widget
     * @param field_name
     * @param status
     */
    self.validaReloadContaFavorecido = function(widget, field_name, status){
        widget.getField(field_name).isReload = status;
    };

    /**
     * Confirma Titulo A Pagar
     * @param widget
     * @param args
     */
    self.confirmaEditaTituloAPagar = function(widget){

        Pag00001_TitulosAPagar_Service.editaTituloAPagar(widget.currentRow).then(function () {
            
            if(widget.backupRow.DTVENBOLPAG.substr(0, 10) != widget.currentRow.DTVENBOLPAG.substr(0, 10)){
                
                var params = {
                    nrorg       : getLocalVar('NRORG'),
                    dtvenbolpag : widget.currentRow.DTVENBOLPAG,
                    cdmotipror  : widget.currentRow.CDMOTIPROR,
                    idtppror    : 'F',
                    nrdiasvenc  : 0
                };
    
                var checkedrows = [
                    params,
                    [widget.currentRow]
                ];
    
                Pag00001_TitulosAPagar_Service.prorrogaTituloAPagar(checkedrows).then(function () {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Registro salvo com sucesso.', 'checked');
                    widget.view();
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            }else{
                General.changeWidgetAcessibility(widget.widgets, true);
                ScreenService.showMessage('Registro salvo com sucesso.', 'checked');
                widget.view();
                widget.reload();
            }
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });

    };

    /**
     * Habilita/Desabilita campos de acordo com Tipo de Baixa
     * @param insertOrEdit
     */
    self.changeTipoBaixa = function(widget, insertOrEdit) {
        var idbaixautilp = widget.getField('IDBAIXAUTILP').value();
        var cdBarraPag = widget.getField('CDBARRAPAG');
        var cdContaFavorecido = widget.getField('CDCCORBOLP');

        if(['B', 'R', 'P', 'G', 'I', 'H', 'J', 'K', 'N', 'Q', 'U', 'V', 'X'].includes(idbaixautilp)){
            widget.getField('CDCCORBOLP').readOnly = true;
        }else{
            widget.getField('CDCCORBOLP').readOnly = false;
        }

        if(['B', 'R', 'H', 'J', 'K', 'N', 'Q', 'U', 'V', 'X', 'I', 'G'].includes(idbaixautilp)){
            widget.getField('DSLINHBARPAG').readOnly = false;
            widget.getField('CDBARRAPAG').readOnly   = false;
            widget.getField('CDCCORBOLP').readOnly   = true;
            if (!insertOrEdit){
                widget.getField('CDBANCBOLP').setValue('');
                widget.getField('CDAGENBOLP').setValue('');
                widget.getField('CDCCORBOLP').setValue('');
            }
        }else{
            if (idbaixautilp != 'P'){
                widget.getField('DSLINHBARPAG').readOnly = true;
                widget.getField('CDBARRAPAG').readOnly   = true;
                widget.getField('CDCCORBOLP').readOnly   = false;
                if (!insertOrEdit){
                    widget.getField('DSLINHBARPAG').setValue('');
                    widget.getField('CDBARRAPAG').setValue('');
                }
            }else{
                widget.getField('DSLINHBARPAG').readOnly = true;
                widget.getField('CDBARRAPAG').readOnly   = true;
                widget.getField('CDCCORBOLP').readOnly   = true;
                if (!insertOrEdit){
                    widget.getField('DSLINHBARPAG').setValue('');
                    widget.getField('CDBARRAPAG').setValue('');
                }
            }
        }
        
        // PIX
        if(['F', 'Z'].includes(idbaixautilp)){
            widget.getField('IDCHAVEPIX').readOnly = false;
            widget.getField('CHAVEPIX').readOnly = false;
            widget.getField('CODEQRPIX').readOnly = false;
            
            widget.fieldGroups.forEach(function(item){ 
                if(item.name == 'dadosPix_pag')
                    item.opened = true;
            });
            
            /** Busca Chave Pix Padrão do Fornecedor */
            var filter = [
                {
                    "name": "CDFORNECED",
                    "operator": "=",
                    "value": widget.currentRow.CDFORNECED
                },
                {
                    "name": "IDCHAVEPIXPREF",
                    "operator": "=",
                    "value": 'S'
                }
            ];
            
            General.callRestEngine('fin#/crud/chavepix', "FilterData", filter).then(function(pixPrincipal){
                if(pixPrincipal && pixPrincipal.dataset && pixPrincipal.dataset.chavepix[0]){
                    widget.currentRow.IDCHAVEPIX = pixPrincipal.dataset.chavepix[0].IDCHAVEPIX; 
                    widget.currentRow.CHAVEPIX   = pixPrincipal.dataset.chavepix[0].CDCHAVEPIX;
                    widget.currentRow.CODEQRPIX  = pixPrincipal.dataset.chavepix[0].CODEQRPIX;
                    widget.currentRow.DSCHAVEPIX = pixPrincipal.dataset.chavepix[0].DSCHAVEPIX;
                    templateManager.updateTemplate();
                }
            });
            
        }else{
            widget.getField('IDCHAVEPIX').readOnly = true;
            widget.getField('CHAVEPIX').readOnly   = true;
            widget.getField('CODEQRPIX').readOnly  = true;
            
            widget.fieldGroups.forEach(function(item){ 
                if(item.name == 'dadosPix_pag')
                    item.opened = false;
            });
            
            if (!insertOrEdit){
                widget.getField('IDCHAVEPIX').setValue('');
                widget.getField('CHAVEPIX').setValue('');
                widget.getField('CODEQRPIX').setValue('');
                widget.getField('DSCHAVEPIX').setValue('');
            }
        }
        
        //Adicionado validação caso o Tipo de baixa seja Boleto Bancário o código de barras seja obrigatório
        if(['B'].includes(idbaixautilp)){
            cdBarraPag.validations = {
              "required": {
                  "message": "Campo obrigatório"
              }
          };
        } else {
          cdBarraPag.validations = {};
        }
        
        /* Adicionado validação caso o Tipo de baixa seja:
            * Credito em Conta - C
            * Documento de Crédito(Doc) - D
            * Transferencia via CIP(Ted-CIP) - T
            * Transferencia via STR(Ted-STR) - S
            O campo do favorecido é colocado como obrigatório
        */
        if(['D', 'C', 'T', 'S'].includes(idbaixautilp)){
            cdContaFavorecido.validations = {
                "required": {
                    "message": "Campo obrigatório"
                }
            };
            
            if (!insertOrEdit){
                /** Busca Conta Favorecido Padrão */
                var filterCcorforn = [
                    {
                        "name": "CDFORNECED",
                        "operator": "=",
                        "value": widget.currentRow.CDFORNECED
                    },
                    {
                        "name": "IDCCORFORNPREF",
                        "operator": "=",
                        "value": 'S'
                    }
                ];
                
                General.callRestEngine('fin#/crud/ccorforn', "FilterData", filterCcorforn).then(function(ccorforn){
                    ccorforn = ccorforn.dataset.ccorforn;
                    
                    if(ccorforn.length > 0){
                        widget.currentRow.CDCCORBOLP = ccorforn[0].CDCCORFORN;
                        widget.currentRow.CDBANCBOLP = ccorforn[0].CDBANCFORN;
                        widget.currentRow.CDAGENBOLP = ccorforn[0].CDAGENFORN;
                    }
                });
            }
        } else {
            cdContaFavorecido.validations = {};
            
            if (!insertOrEdit){
                widget.getField('CDBANCBOLP').setValue('');
                widget.getField('CDAGENBOLP').setValue('');
                widget.getField('CDCCORBOLP').setValue('');
            }
        }
    };

    /**
     * Habilita/Desabilita campos de acordo com Tipo de Baixa
     * @param insertOrEdit
     */
    self.changeTipoBaixaAntecipacao = function(widget, insertOrEdit) {
        var idbaixautilp = widget.getField('IDBAIXAUTILP').value();

        if(['B', 'R', 'P', 'G', 'I', 'H', 'J', 'K', 'N', 'Q', 'U', 'V', 'X'].includes(idbaixautilp)){
            widget.getField('CDCCORANTECIPA').readOnly = true;
        }else{
            widget.getField('CDCCORANTECIPA').readOnly = false;
        }

        if(['B', 'R', 'H', 'J', 'K', 'N', 'Q', 'U', 'V', 'X', 'I', 'G'].includes(idbaixautilp)){
            widget.getField('DSLINHBARANTECI').readOnly = false;
            widget.getField('CDBARRAANTECIPA').readOnly   = false;
            widget.getField('CDCCORANTECIPA').readOnly   = true;
            if (!insertOrEdit){
                widget.getField('CDBANCANTECIPA').setValue('');
                widget.getField('CDAGENANTECIPA').setValue('');
                widget.getField('CDCCORANTECIPA').setValue('');
            }
        }else{
            if (idbaixautilp != 'P'){
                widget.getField('DSLINHBARANTECI').readOnly = true;
                widget.getField('CDBARRAANTECIPA').readOnly   = true;
                widget.getField('CDCCORANTECIPA').readOnly   = false;
                if (!insertOrEdit){
                    widget.getField('DSLINHBARANTECI').setValue('');
                    widget.getField('CDBARRAANTECIPA').setValue('');
                }
            }else{
                widget.getField('DSLINHBARANTECI').readOnly = true;
                widget.getField('CDBARRAANTECIPA').readOnly   = true;
                widget.getField('CDCCORANTECIPA').readOnly   = true;
                if (!insertOrEdit){
                    widget.getField('DSLINHBARANTECI').setValue('');
                    widget.getField('CDBARRAANTECIPA').setValue('');
                }
            }
        }
    };

    /**
     * Cálcula Valor para Percentual
     * @param row
     */
    self.calcValueToPercent = function(valor, total, percentual){
        valor = parseFloat(valor.replace(',','.'));
        total  = parseFloat(total);

        percentual = (valor * 100)/total;
    };

    /**
     * Cálcula Percentual para Valor
     * @param row
     */
    self.calcPercentToValue = function(percentual, total, valor){
        percentual  = parseFloat(percentual.replace(',','.'));
        total  = parseFloat(total);

        valor = (percentual * total)/100;
    };

    /**
     * Deleta Titulos a Pagar
     */
    self.deletaTituloPagar = function(args){
        var widget = args.owner.widget;
            
        if (widget.currentRow.IDSISTEMA != 'PAG') {
            ScreenService.showMessage('Operação bloqueada. Título não lançado manualmente pelo sistema de pagamento, não pode ser excluído.');
            return;
        }
                
        if((widget.currentRow.IDSTATBPAG == 'B') || (widget.currentRow.IDSTATBPAG == 'P')) {
            ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
            return;
        }
        
        if(widget.currentRow.IDSITUCNABP != '00') {
            ScreenService.showMessage('Operação bloqueada. Título enviado ao banco, via CNAB, não pode ser alterado.');
            return;
        }
        
        if(widget.currentRow.IDASSOCBOLPAG == 'S') {
            ScreenService.showMessage('Operação bloqueada. Título associado não pode ser excluído.');
            return;
        }
        
        if(widget.currentRow.IDBLOQNFFINCP == 'B') {
            ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser excluído.');
            return;
        }

        ScreenService.showCustomDialog('O que deseja excluir?', 'question', 'question', [{
            label: 'Vencimento',
            code: self.deletaVencTituloPagar
        }, {
            label: 'Documento',
            code: self.deletaDocTituloPagar
        }, {
            label: 'Cancelar',
            code: ''
        }]);
    };

    /**
     * Deleta Vencimento Titulos a Pagar
     */
    self.deletaVencTituloPagar = function(){

        ScreenService.confirmMessage('Deseja realmente excluir o Vencimento?', 'question', function() {

            var widget = templateManager.container.getWidget('TitulosAPagarGrid');
            
            var route = 'fin#/crud/boletpagar';
            var filter = [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": widget.currentRow.NRORG
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.currentRow.CDFILIAL
                },
                {
                    "name": "NRLANBOLPAG",
                    "operator": "=",
                    "value": widget.currentRow.NRLANBOLPAG
                }
            ];
            General.callRestEngine(route, 'FilterData', filter).then(function(boleto) {
                var boletpagar = boleto.dataset.boletpagar[0];
                
                if((boletpagar.IDSTATBPAG == 'B') || (boletpagar.IDSTATBPAG == 'P')) {
                    ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
                    return;
                }

                if(boletpagar.NRPARCBOLPAG != '00'){
                    ScreenService.showMessage('Operação bloqueada. Título parcelado deve ser excluído na aba Parcelamento.');
                    return;
                }
    
                Pag00001_TitulosAPagar_Service.deletaVencTituloPagar(widget.currentRow).then(function () {
                    ScreenService.showMessage('Registro excluído com sucesso.', 'checked');
                    ScreenService.goBack();
                    widget.reload();
                }, function (error) {
                    if (contabilizacaoController.checkErrosContabilizacao(error)) {
                        ScreenService.showMessage(error.data.error);
                    }
                });
                
            });

        });

    };

    /**
     * Deleta Documento Titulos a Pagar
     */
    self.deletaDocTituloPagar = function(){

        ScreenService.confirmMessage('Deseja realmente excluir o Documento?', 'question', function() {

            var widget = templateManager.container.getWidget('TitulosAPagarGrid');
            
             var route = 'fin#/crud/boletpagar';
            var filter = [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": widget.currentRow.NRORG
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.currentRow.CDFILIAL
                },
                {
                    "name": "NRLANBOLPAG",
                    "operator": "=",
                    "value": widget.currentRow.NRLANBOLPAG
                }
            ];
            General.callRestEngine(route, 'FilterData', filter).then(function(boleto) {
                var boletpagar = boleto.dataset.boletpagar[0];
                
                if((boletpagar.IDSTATBPAG == 'B') || (boletpagar.IDSTATBPAG == 'P')) {
                    ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
                    return;
                }
    
                Pag00001_TitulosAPagar_Service.deletaDocTituloPagar(widget.currentRow).then(function () {
                    ScreenService.showMessage('Registro excluído com sucesso.', 'checked');
                    ScreenService.goBack();
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
                
            });

        });

    };

    /**
     * Prorrogar Títulos a Pagar
     * @param widget
     */
    self.prorrogarTitulo = function(widget){
        var checkedrows = widget.getCheckedRows();

        if(checkedrows.length > 0) {

            for(var i in checkedrows) {
                if((checkedrows[i].IDSTATBPAG == 'B') || (checkedrows[i].IDSTATBPAG == 'P')){
                    ScreenService.showMessage('Operação bloqueada. Título(s) baixado(s) ou com baixa(s) planejada(s) não pode(m) ser alterado(s).');
                    return;
                }
                if(checkedrows[i].IDSITUCNABP != '00') {
                    ScreenService.showMessage('Operação bloqueada. Título(s) enviado(s), via CNAB, não pode(m) ser alterado(s).');
                    return;
                }
                if(checkedrows[i].IDSTATUS == 'V') {
                    ScreenService.showMessage('Operação bloqueada. Título previsto não pode ser alterado.');
                    return;
                }
                if(checkedrows[i].IDBLOQNFFINCP == 'B') {
                    ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
                    return;
                }
            }

            var widgetProrrogar = templateManager.container.getWidget('ProrrogarForm');
            widgetProrrogar.isVisible = true;
            ScreenService.openPopup(widgetProrrogar);
            widgetProrrogar.getField('IDTPPROR').setValue('F');
            self.alteraTipoProrrogacao();

        }else ScreenService.showMessage('Marque o(s) título(s) para prorrogação.');
    };

    /**
     * Confirmar Prorrogacao Títulos a Pagar
     * @param args
     */
    self.confirmaProrrogacaoTitulo = function(args){
        var widget = args.owner.widget;

        if(widget.isValid()) {

            var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');

            var params = {
                nrorg       : getLocalVar('NRORG'),
                dtvenbolpag : widget.currentRow.DTVENBOLPAG,
                cdmotipror  : widget.currentRow.CDMOTIPROR,
                idtppror    : widget.currentRow.IDTPPROR,
                nrdiasvenc  : widget.currentRow.NRDIASVENC,
                cdreducont  :widget.currentRow.CDREDUCONT

            };

            var checkedrows = [
                params,
                widgetTitulos.getCheckedRows()
            ];

            Pag00001_TitulosAPagar_Service.prorrogaTituloAPagar(checkedrows).then(function () {
                ScreenService.showMessage('Título(s) prorrogado(s) com sucesso.', 'checked');
                widgetTitulos.unSelectAll();
                self.unsetStripeDataFooter();

                widget.currentRow.DTVENBOLPAG  = '';
                widget.currentRow.DSMOTIPROR   = '';

                ScreenService.closePopup(widget);
                ScreenService.closePopup();

                widget.isVisible = false;

                widgetTitulos.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };

    /**
     * Cancela Prorrogação Titulo a Pagar
     * @param args
     */
    self.cancelaProrrogacaoTitulo = function(args){
        var widget = args.owner.widget;

        widget.currentRow.DTVENBOLPAG  = '';
        widget.currentRow.DSMOTIPROR   = '';

        widget.isVisible = false;

        ScreenService.closePopup(widget);
    };

    /**
     * Remessa Titulo a Pagar
     * @param widget
     */
    self.remessaTitulo = function(widget){
        var checkedrows = widget.getCheckedRows();

        if(checkedrows.length > 0) {
            var tpbaixaerror = false;

            for(var i in checkedrows) {
                if((checkedrows[i].IDSTATBPAG == 'B') || (checkedrows[i].IDSTATBPAG == 'P')){
                    ScreenService.showMessage('Operação bloqueada. Título(s) baixado(s) ou com baixa(s) planejada(s) não pode(m) ser alterado(s).');
                    return;
                }
                if(checkedrows[i].IDSITUCNABP != '00') {
                    ScreenService.showMessage('Operação bloqueada. Título(s) enviado(s), via CNAB, não pode(m) ser alterado(s).');
                    return;
                }
                if(checkedrows[i].IDSTATUS == 'V') {
                    ScreenService.showMessage('Operação bloqueada. Título previsto não pode ser alterado.');
                    return;
                }
                if(checkedrows[i].IDBLOQNFFINCP == 'B') {
                    ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
                    return;
                }
                if(!checkedrows[i].CDTPBAIXAPAG) {
                    ScreenService.showMessage('Operação bloqueada. Título(s) não possui(em) tipo de baixa.');
                    return;
                }
                if(!checkedrows[i].CDREDUCONT) {
                    ScreenService.showMessage('Operação bloqueada. Título(s) não possui(em) conta de pagamento.');
                    return;
                }
                if(!(['D','C','B','T','S','O', 'E', 'F', 'G', 'P', 'R', 'I', 'H', 'J', 'K', 'N', 'Q', 'U', 'V', 'X'].includes(checkedrows[i].IDBAIXAUTILP)))
                    tpbaixaerror = true;
            }

            if(tpbaixaerror) {
                ScreenService.confirmMessage('O(s) título(s) marcado(s), que não possui(em) tipo(s) de baixa(s) para remessa, será(ão) desconsiderado(s). Deseja prosseguir com o processo?', 'question', function () {
                    var widgetRemessa = templateManager.container.getWidget('RemessaForm');
                    widgetRemessa.isVisible = true;
                    ScreenService.openPopup(widgetRemessa);
                    self.buscaPadraoRemessaTitulo(widgetRemessa);
                });
            }else{
                var widgetRemessa = templateManager.container.getWidget('RemessaForm');
                widgetRemessa.isVisible = true;
                ScreenService.openPopup(widgetRemessa);
                self.buscaPadraoRemessaTitulo(widgetRemessa);
            }


        }else ScreenService.showMessage('Marque o(s) título(s) para geração da remessa.');
    };

    /**
     * Busca Padrão Remessa Titulo a Pagar
     */
    self.buscaPadraoRemessaTitulo = function (widget){
        var nrremessapag  = 0;
        var vrremessapag  = 0;
        var widgetTitulos       = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetTitulosFilter = widgetTitulos.appliedFilter;

        var cdempresa     = widgetTitulosFilter.FILTER_ROW.CDEMPRESA||null;
        var checkedrows   = widgetTitulos.getCheckedRows();

        for(var i in checkedrows) {
            vrremessapag += self.formataValor(checkedrows[i].VRFINALBPAG);
            nrremessapag += 1;
        }

        widget.currentRow = {};

        widget.getField('CDEMPRESA').setValue(cdempresa);
        widget.getField('CDOPERADOR').setValue(getLocalVar('CDOPERADOR'));
        widget.getField('DTCNABPAG').setValue(moment().format('DD/MM/YYYY'));
        widget.getField('IDPRENEGOCIADO').setValue('');
        widget.getField('IDOPECNABPAG').setValue('I');
        widget.getField('VRTOTALCNABPAG').setValue(vrremessapag);
        widget.getField('QTBOLCNABPAG').setValue(nrremessapag);
        widget.getField('DSARQCNABPAG').setValue('/tmp/');
        widget.getField('DSCONTCORR').setValue('');
        widget.getField('IDTPREMCNABPAG').setValue('');
        widget.getField('IDAGENREMCNABPAG').setValue('');
        widget.getField('NMFILIAL').setValue('');
        widget.getField('IDTPREMCNABPAG').readOnly = true;
        widget.getField('IDAGENREMCNABPAG').readOnly = true;
        widget.getField('IDPRENEGOCIADO').readOnly = true;
        widget.getField('IDTPREMCNABPAG').validations.required = true;
        delete widget.getField('IDTPREMCNABPAG').validations.required;

        templateManager.updateTemplate();
    };

    /**
     * Alteração Conta Corrente Remessa
     */
    self.alteraContCorrRem = function (widget){
        widget = widget.owner.field.widget;
        var cdbanccnab = widget.getField('CDBANCCNAB').value();
        
        // Bradesco
        if(cdbanccnab == '237') {
            widget.getField('IDTPREMCNABPAG').readOnly = false;
            widget.getField('IDTPREMCNABPAG').validations.required = true;
            widget.getField('IDTPREMCNABPAG').setValue('1');
            widget.getField('IDAGENREMCNABPAG').readOnly = false;
            widget.getField('IDAGENREMCNABPAG').validations.required = true;
            widget.getField('IDAGENREMCNABPAG').setValue('');
        }else{
            widget.getField('IDTPREMCNABPAG').readOnly = true;
            delete widget.getField('IDTPREMCNABPAG').validations.required;
            widget.getField('IDTPREMCNABPAG').setValue('');
            widget.getField('IDAGENREMCNABPAG').readOnly = true;
            delete widget.getField('IDAGENREMCNABPAG').validations.required;
            widget.getField('IDAGENREMCNABPAG').setValue('');
        }
        
        // Santander
        if(cdbanccnab == '033') {
            widget.getField('IDPRENEGOCIADO').readOnly = false;
            widget.getField('IDPRENEGOCIADO').validations.required = true;
            widget.getField('IDPRENEGOCIADO').setValue('N');
        }else{
            widget.getField('IDPRENEGOCIADO').readOnly = true;
            delete widget.getField('IDPRENEGOCIADO').validations.required;
            widget.getField('IDPRENEGOCIADO').setValue('');
        }
    };

    /**
     * Confirmar Remessa Titulo a Pagar
     * @param args
     */
    self.confirmaRemessaTitulo = function(args){
        var widget = args.owner.widget;
        var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');
        widget.currentRow.CDREDUCONTCOBR = widget.currentRow.CDREDUCONTCOBR||null;

        var currentRow = {
            nrorg           : getLocalVar('NRORG')   ,
            cdfilial        : getLocalVar('CDFILIAL'),
            remessaboleto   : widget.currentRow      ,
            boletosmarcados : widgetTitulos.getCheckedRows()
        };

        if(widget.isValid()) {
            Pag00001_TitulosAPagar_Service.remessaTituloPagar(currentRow).then(function (dsarqcnabpag) {
                var arquivo = dsarqcnabpag.dataset.remessaTituloPagar.dsarqcnabpag;

                ScreenService.showMessage('Remessa gerada com sucesso.');

                widget.currentRow.CDEMPRESA        = '';
                widget.currentRow.NRCNABPAG        = '';
                widget.currentRow.CDOPERADOR       = '';
                widget.currentRow.DTCNABPAG        = '';
                widget.currentRow.IDOPECNABPAG     = '';
                widget.currentRow.NMOPECNABPAG     = '';
                widget.currentRow.CDBANCCNAB       = '';
                widget.currentRow.CDREDUCONT       = '';
                widget.currentRow.DSCONTCORR       = '';
                widget.currentRow.CDREDUCONTCOBR   = '';
                widget.currentRow.DSREDUCONTCOBR   = '';
                widget.currentRow.IDTPREMCNABPAG   = '';
                widget.currentRow.NMTIPCNABPAG     = '';
                widget.currentRow.QTBOLCNABPAG     = '';
                widget.currentRow.VRTOTALCNABPAG   = '';
                widget.currentRow.IDAGENREMCNABPAG = '';
                widget.currentRow.CDFILIAL         = '';
                widget.currentRow.NMFILIAL         = '';

                ScreenService.closePopup(widget);
                ScreenService.closePopup();
                widget.isVisible = false;
                
                widgetTitulos.unSelectAll();
                self.unsetStripeDataFooter();

                self.downloadRemessaTitulo(arquivo);

                widgetTitulos.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };

    /**
     * Download Remessa Titulo a Pagar
     */
    self.downloadRemessaTitulo = function(arquivo) {
        window.open(window.serviceUrls.filter(function(x){return x.package == 'fin';})[0].baseUrl+"/donwloadArquivo?requestType=DataSet&dataset[0][DSARQUIVO]="+arquivo);
    };

    /**
     * Exclusão Remessa Titulo a Pagar
     */
    self.exclusaoRemessaTitulo = function(){
        var checkedrows = templateManager.container.getWidget('TitulosAPagarGrid').getCheckedRows();

        if(checkedrows.length > 0) {
            for(var i in checkedrows) {
                if((checkedrows[i].IDSTATBPAG == 'B') || (checkedrows[i].IDSTATBPAG == 'P')) {
                    ScreenService.showMessage('Operação bloqueada. Título(s) baixado(s) ou com baixa(s) planejada(s) não pode(m) ser alterado(s).');
                    return;
                }
                if(checkedrows[i].IDSITUCNABP == '00') {
                    ScreenService.showMessage('Operação bloqueada. Título(s) não enviado(s), via CNAB, não possui(em) remessa(s).');
                    return;
                }
            }

            ScreenService.showCustomDialog('O que deseja cancelar?', 'question', 'question', [{
                label: 'Remessa',
                code: self.excluiRemessaPag
            }, {
                label: 'Título',
                code: self.excluiTituloRemessaPag
            }, {
                label: 'Cancelar',
                code: ''
            }]);

        }else ScreenService.showMessage('Marque o(s) título(s) para exclusão da remessa.');
    };

    /**
     * Exclui Titulo da Remessa Pagar
     */
    self.excluiTituloRemessaPag = function(){
        var widget      = templateManager.container.getWidget('TitulosAPagarGrid');

        var paramsRem = {
            nrorg     : getLocalVar('NRORG'),
            cdfilial  : getLocalVar('CDFILIAL'),
            cdoperador: getLocalVar('CDOPERADOR')
        };

        var checkedrows = [paramsRem, widget.getCheckedRows()];

        ScreenService.confirmMessage('Deseja realmente cancelar o(s) título(s) da(s) remessa(s)?', 'question', function () {
            Pag00001_TitulosAPagar_Service.excluiTituloPagRemessa(checkedrows).then(function () {
                ScreenService.showMessage('Título(s) excluído(s) da(s) remessa(s) com sucesso.', 'checked');
                ScreenService.closePopup();
                
                widget.unSelectAll();
                self.unsetStripeDataFooter();
                
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });

    };

    /**
     * Exclui Remessa Pagar
     */
    self.excluiRemessaPag = function(){
        var widget      = templateManager.container.getWidget('TitulosAPagarGrid');

        var paramsRem = {
            nrorg     : getLocalVar('NRORG'),
            cdfilial  : getLocalVar('CDFILIAL'),
            cdoperador: getLocalVar('CDOPERADOR')
        };
        var checkedrows = [paramsRem, widget.getCheckedRows()];

        ScreenService.confirmMessage('Deseja realmente cancelar a(s) remessa(s)?', 'question', function () {
            Pag00001_TitulosAPagar_Service.excluiRemessaPag(checkedrows).then(function () {
                ScreenService.showMessage('Remessa(s) excluída(s) com sucesso.');
                ScreenService.closePopup();
                
                widget.unSelectAll();
                self.unsetStripeDataFooter();
                
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    /**
     * Baixa Titulo a Pagar
     * @param widget
     */
    self.baixaTitulo = function(widget){
        var checkedrows = widget.getCheckedRows();
        if(checkedrows.length > 0) {
            if (self.statusTituloPermiteRealizarBaixa(checkedrows)){
                var boletosBaixaPlanejada = checkedrows.filter(function(boleto){
                    return boleto.IDSTATBPAG == 'P';
                });
                var boletosEmAberto = checkedrows.filter(function(boleto){
                    return (boleto.IDSTATBPAG == 'A' && idhabibole_geral == 'N') || (boleto.IDSTATBPAG == 'A' && idhabibole_geral == 'S' && boleto.IDHABIBPAG == 'S');
                });
                if(boletosBaixaPlanejada.length > 0) {
                    ScreenService.confirmMessage('Existe(m) título(s) marcado(s) com baixa(s) planejada(s).Deseja transfomá-la(s) em baixa(s) real(is)?', 'question', function () {
                        self.baixarTitulosMarcadosOuTitulosBaixa();
                    }, function (){
                        if(boletosEmAberto.length > 0) {
                            self.efetivarBaixaTitulosAbertos(boletosEmAberto);
                        }else{
                            ScreenService.closePopup();
                        }
                    });
                }else{
                    self.efetivarBaixaTitulosAbertos(boletosEmAberto);
                }
            }
        }else{
            ScreenService.showMessage('Marque o(s) título(s) para baixá-lo(s).');
        }
    };

    /**
     * Efetiva Baixa
     * @param baixa
     * @returns {*}
     */
    self.efetivaBaixa = function(baixa){
        var deferred = ZHPromise.defer();

        var currentRow = {
            nrorg: getLocalVar('NRORG'),
            cdfilial: getLocalVar('CDFILIAL'),
            baixaboleto: baixa,
            boletosmarcados: baixa.BOLETOS,
            cheque: null
        };

        Pag00001_TitulosAPagar_Service.transformaBaixaPlanejado(currentRow).then(function () {
            deferred.resolve();
        }, function (error) {
            ScreenService.showMessage(error.data.error);
            deferred.reject();
        });

        return deferred.promise;
    };

    /**
     * Efetiva Baixa
     * @param baixa
     * @returns {*}
     */
    self.efetivaBaixaTitulo = function(baixa){
        var deferred = ZHPromise.defer();

        var currentRow = {
            nrorg: getLocalVar('NRORG'),
            cdfilial: getLocalVar('CDFILIAL'),
            baixaboleto: baixa,
            boletosmarcados: baixa.BOLETOS
        };

        Pag00001_TitulosAPagar_Service.transformaTituloPlanejado(currentRow).then(function () {
            deferred.resolve();
        }, function (error) {
            ScreenService.showMessage(error.data.error);
            deferred.reject();
        });

        return deferred.promise;
    };

    /**
     * Efetiva Titulos Marcados
     */
    self.efetivaTitulosMarcados = function(){
        var widget = templateManager.container.getWidget('TitulosAPagarGrid');
        var boletosBaixaPlanejada = widget.getCheckedRows().filter(function(boleto){
            return boleto.IDSTATBPAG == 'P';
        });
        var boletosEmAberto = widget.getCheckedRows().filter(function(boleto){
            return boleto.IDSTATBPAG == 'A';
        });
        var baixatitulo = self.preparaDataSourceBoletosPlanejados(boletosBaixaPlanejada, 'E');
        baixatitulo.forEach(function(baixa){
            self.efetivaBaixaTitulo(baixa).then(function(){
                if(boletosEmAberto.length > 0) {
                    self.efetivarBaixaTitulosAbertos(boletosEmAberto);
                }else{
                    ScreenService.closePopup();
                    widget.reload().then(function(){
                        ScreenService.showMessage('Título(s) transformado(s) em baixa(s) real(is) com sucesso.');
                    });
                    widget.unSelectAll();
                    self.unsetStripeDataFooter();
                }
            });
        });
    };

    /**
     * Efetiva Titulos da Baixa
     */
    self.efetivaTitulosDaBaixa = function(){
        var route = 'fin#/crud/boletpagar';
        var widget = templateManager.container.getWidget('TitulosAPagarGrid');

        var boletosBaixaPlanejada = widget.getCheckedRows().filter(function(boleto){
            return boleto.IDSTATBPAG == 'P';
        });
        var boletosEmAberto = widget.getCheckedRows().filter(function(boleto){
            return boleto.IDSTATBPAG == 'A';
        });

        var baixatitulo = self.preparaDataSourceBoletosPlanejados(boletosBaixaPlanejada, 'E');
        baixatitulo.forEach(function(baixa){
            var filter = [
                {
                    "name": "CDFILIBAIPAG",
                    "operator": "=",
                    "value": baixa.BOLETOS[0].CDFILIBAIPAG
                },
                {
                    "name": "NRBAIXAPAG",
                    "operator": "=",
                    "value": baixa.NRBAIXAPAG
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": baixa.BOLETOS[0].NRORG
                }
            ];

            General.callRestEngine(route, 'FilterData', filter).then(function(boletos) {
                baixa.BOLETOS = boletos.dataset.boletpagar;
                self.efetivaBaixa(baixa).then(function(){
                    if(boletosEmAberto.length > 0) {
                        self.efetivarBaixaTitulosAbertos(boletosEmAberto);
                    }else{
                        ScreenService.closePopup();
                        widget.reload().then(function(){
                            ScreenService.showMessage('Título(s) transformado(s) em baixa(s) real(is) com sucesso.');
                        });
                        widget.unSelectAll();
                        self.unsetStripeDataFooter();
                    }
                });
            });
        });
    };

    /**
     * Baixa Titulos Marcados ou Titulos Baixados
     */
    self.baixarTitulosMarcadosOuTitulosBaixa = function(){
        ScreenService.showCustomDialog('Transformar em Real?', 'question', 'question', [{
            label: 'Baixa',
            code: self.efetivaTitulosDaBaixa
        }, {
            label: 'Títulos',
            code: self.efetivaTitulosMarcados
        }, {
            label: 'Cancelar',
            code: self.verificaTituloEmAberto
        }]);
    };

    /**
     * Baixa Titulo a Pagar
     */
    self.verificaTituloEmAberto = function(){
        var widget = templateManager.container.getWidget('TitulosAPagarGrid');
        var checkedrows = widget.getCheckedRows();

        var boletosEmAberto = checkedrows.filter(function(boleto){
            return boleto.IDSTATBPAG == 'A';
        });

        if(boletosEmAberto.length > 0)
            self.efetivarBaixaTitulosAbertos(boletosEmAberto);
        else ScreenService.closePopup();
    };

    /**
     * Titulos Baixados
     * @param boletoMarcado
     * @param indice
     * @param array
     * @returns {boolean}
     */
    function titulosBaixados(boletoMarcado, indice, array){
        return boletoMarcado.IDSTATBPAG != "B";
    }

    /**
     * Titulos Previstos
     * @param boletoMarcado
     * @param indice
     * @param array
     * @returns {boolean}
     */
    function titulosPrevistos(boletoMarcado, indice, array){
        return boletoMarcado.IDSTATUS != "V";
    }
    
    /**
     * Titulos Bloqueado
     * @param boletoMarcado
     * @param indice
     * @param array
     * @returns {boolean}
     */
    function titulosBloqueados(boletoMarcado, indice, array){
        return boletoMarcado.IDBLOQNFFINCP != "B";
    }

    /**
     * Titulos Aberto e Planejados
     * @param boletoMarcado
     * @param indice
     * @param array
     * @returns {boolean}
     */
    function titulosAbertosEPlanejados(boletoMarcado, indice, array){
        return ((boletoMarcado.IDSTATBPAG == "A") || (boletoMarcado.IDSTATBPAG == "P"));
    }
    
    self.efetivarBaixaTitulosAbertos = function(boletosEmAberto){
        //ScreenService.confirmMessage('Deseja realmente realizar baixa do(s) título(s) "Em Aberto" marcados?', 'question', function () {
            var widgetBaixa = templateManager.container.getWidget('NewBaixaTabbed');
            var widgetTitulosBaixa = templateManager.container.getWidget('NewTitulosBaixaGrid');
            
            ScreenService.closePopup();
            
            widgetBaixa.isVisible = true;
            self.widgetEmEdicao("NewTitulosBaixaGrid", true);

            ScreenService.openSwipe(widgetBaixa);
            
            self.buscaPadraoBaixaTitulo(widgetBaixa, widgetTitulosBaixa, boletosEmAberto);
            self.dataSourceAjusteTituloBaixo();
        //});
    };
    
    self.widgetEmEdicao = function(widget_name, editing){
        var widget = templateManager.container.getWidget(widget_name);
        widget.editing = editing;
        templateManager.updateTemplate();
    };
    
    self.dataSourceAjusteTituloBaixo = function(){
        var widgetTitulosAPagar   = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetAjusteTituloBaixa = templateManager.container.getWidget('AjusteTituloBaixaGrid');
        
        var route = 'fin_contaPagar#/buscaTodosAjustesBoletos';
        
        General.callRestEngine(route, 'DataSet', widgetTitulosAPagar.getCheckedRows()).then(function (ajustesboletos) {
            var dadosDeTodosAjustes = ajustesboletos.dataset.buscaTodosAjustesBoletos;
            
            localStorageEngine.setDataSource('fin_contaPagar#/ajbolpag_tipoajpagar', dadosDeTodosAjustes);
            
            widgetAjusteTituloBaixa.reload();
        });
    };
    
    self.buscaPadraoBaixaTitulo = function (widgetBaixa, widgetTitulosBaixa, titulosEmAberto){
        var deferred = ZHPromise.defer();
        
        var vrbaixapag  = 0;
        var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid').getCheckedRows();

        for(var i in widgetTitulos)
            vrbaixapag += parseFloat(widgetTitulos[i].VRFINALBPAG);

        widgetBaixa.getField('CDEMPRESA').setValue(templateManager.container.getWidget('TitulosAPagarGrid').appliedFilter.FILTER_ROW.CDEMPRESA||null);
        widgetBaixa.getField('CDOPERADOR').setValue(getLocalVar('CDOPERADOR'));
        widgetBaixa.getField('DTLANCBAIXAP').setValue(moment().format('DD/MM/YYYY'));
        widgetBaixa.getField('DTBAIXAPAG').setValue(moment().format('DD/MM/YYYY'));
        widgetBaixa.getField('IDUNICABAIXA').setValue('S');
        widgetBaixa.getField('IDSTATUSBPAG').setValue('E');
        widgetBaixa.getField('DSCONTCORR').setValue('');
        widgetBaixa.getField('CDBANCO').setValue('');
        widgetBaixa.getField('CDAGENCIA').setValue('');
        widgetBaixa.getField('CDCONTCORR').setValue('');
        widgetBaixa.getField('NMTPBAIXAPAG').setValue('');
        widgetBaixa.getField('DSBAIXAPAG').setValue('');
        widgetBaixa.getField('VRBAIXAPAG').setValue(vrbaixapag.toFixed(2));
        
        var nrorg   = null;
        var emissaomax = null;
        var emissaoatu = null;
        var entrsaidmax = null;
        var entrsaidatu = null;
        var nrtitulo  = [];
        
        titulosEmAberto.forEach(function (data) {
            nrorg = data.NRORG;
            
            emissaoatu = moment(data.DTEMISSAO, "DD/MM/YYYY HH:mm:ss");
            emissaomax = emissaomax ? emissaoatu > emissaomax ? emissaoatu : emissaomax : emissaoatu;
            
            entrsaidatu = moment(data.DTENTRSAID, "DD/MM/YYYY HH:mm:ss");
            entrsaidmax = entrsaidmax ? entrsaidatu > entrsaidmax ? entrsaidatu : entrsaidmax : entrsaidatu;
            
            nrtitulo.push(data.CDFILIAL+data.NRLANBOLPAG);
        });
        
        widgetBaixa.getField('DTEMISSAO').setValue(emissaomax.format('DD/MM/YYYY'));
        widgetBaixa.getField('DTENTRSAID').setValue(entrsaidmax.format('DD/MM/YYYY'));
        
        var filter = [
            {
                name: "NRORG", 
                operator: "=", 
                value: nrorg
            },
            {
                name: "NRTITULO", 
                operator: "IN", 
                value: nrtitulo
            }
        ];
        
        widgetTitulosBaixa.dataSourceFilter = filter;
        widgetTitulosBaixa.reload().then(function () {
              widgetTitulosBaixa.dataSource.selectAll();  
        });

        
        deferred.resolve();
        return deferred.promise;
    };

    /**
     * Prepara Data Source Boletos Planejados
     * @param boletosBaixaPlanejada
     * @param statusBaixaReal
     * @returns {Array}
     */
    self.preparaDataSourceBoletosPlanejados = function(boletosBaixaPlanejada, statusBaixaReal){
        var baixaTitulo = [];
        boletosBaixaPlanejada.forEach(function(boletoMarcado){
            var baixa = baixaTitulo.filter(function(baixa){
                return baixa.NRBAIXAPAG == boletoMarcado.NRBAIXAPAG;
            });
            if (baixa.length > 0){
                baixa[0].BOLETOS.push(boletoMarcado);
            }else{
                baixaTitulo[baixaTitulo.length] = {
                    'NRBAIXAPAG': boletoMarcado.NRBAIXAPAG,
                    'CDEMPRESA': boletoMarcado.CDEMPRESA,
                    'CDOPERADOR': boletoMarcado.CDOPERADOR,
                    'CDTPBAIXAPAG': boletoMarcado.CDTPBAIXAPAG,
                    'DTBAIXAPAG': boletoMarcado.DTBAIXAPAG,
                    'IDBAIXAUTILP': boletoMarcado.IDBAIXAUTILP,
                    'DTLANCBAIXAP': moment().format('DD/MM/YYYY'),
                    'IDSTATUSBPAG': statusBaixaReal,
                    'CDREDUCONT': boletoMarcado.CDREDUCONTBAIXA,
                    'DSBAIXAPAG': boletoMarcado.DSBAIXAPAG,
                    'NRCHEQUE': boletoMarcado.NRCHEQUE,
                    'BOLETOS': [boletoMarcado]
                };
            }
        });
        return baixaTitulo;
    };

    /**
     * Status Titulo Permite Realização da Baixa
     * @param checkedrows
     * @returns {boolean}
     */
    self.statusTituloPermiteRealizarBaixa = function(checkedrows){
        if(!checkedrows.every(titulosBaixados)) {
            ScreenService.showMessage('Operação bloqueada. Título(s) baixado(s) não pode(m) ser alterado(s).');
            return false;
        }
        if(!checkedrows.every(titulosPrevistos)) {
            ScreenService.showMessage('Operação bloqueada. Título previsto não pode ser alterado.');
            return false;
        }
        if(!checkedrows.every(titulosBloqueados)) {
            ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
            return false;
        }
        if(!checkedrows.every(titulosAbertosEPlanejados)) {
            ScreenService.showMessage('Operação bloqueada. Marque somente título(s) com status "Em Aberto" ou "Planejado".');
            return false;
        }
        return true;
    };

    /**
     * Habilita/Desabilita campos de acordo com Tipo de Baixa
     */
    self.changeTipoBaixaForm = function() {
        var widget = templateManager.container.getWidget('NewBaixaTabbed');

        var idbaixautilp = widget.getField('IDBAIXAUTILP').value();

        if((idbaixautilp == 'M') || (idbaixautilp == 'A')) {
            widget.getField('NRCHEQUE').readOnly  = false;
            widget.getField('NRCHEQUE').validations.required = true;
            widget.getField('DSNOMCHEQ').readOnly = false;
            widget.getField('DSCHEQUE').readOnly  = false;
        }else{
            widget.getField('NRCHEQUE').readOnly  = true;
            delete widget.getField('NRCHEQUE').validations.required;
            widget.getField('DSNOMCHEQ').readOnly = true;
            widget.getField('DSCHEQUE').readOnly  = true;

            widget.getField('NRCHEQUE').setValue('');
            widget.getField('DSNOMCHEQ').setValue('');
            widget.getField('DSCHEQUE').setValue('');
        }
        
        if(widget.getField('NMTPBAIXAPAG').value()){
            var widgetNewTitulosBaixaGrid = templateManager.container.getWidget('NewTitulosBaixaGrid');
            
            if((idbaixautilp != 'M') && (idbaixautilp != 'A')) {
                ScreenService.showCustomDialog('Deseja aplicar o Tipo de Baixa selecionado para:', 'question', 'question', [{
                    label: 'Todos os Títulos',
                    code: self.aplicarTipoBaixaTitulos
                }, {
                    label: 'Somente Títulos sem Tipo de Baixa pré-cadastrado',
                    code: self.aplicarTipoBaixaTitulosSemTipoBaixa
                }, {
                    label: 'Cancelar',
                    code: self.cancelarTipoBaixaTitulo
                }]);
            }else self.aplicarTipoBaixaTitulos();
        }
    };
    
    /**
     * Aplica Tipo de Baixa
     */
    self.cancelarTipoBaixaTitulo = function() {
        var widget = templateManager.container.getWidget('NewBaixaTabbed');
        
        widget.currentRow.CDTPCTPAGAR  = '';
        widget.currentRow.NMTPBAIXAPAG = '';
    };
    
    /**
     * Aplica Tipo de Baixa
     */
    self.aplicarTipoBaixaTitulos = function() {
        var widget = templateManager.container.getWidget('NewBaixaTabbed');
        var widgetNewTitulosBaixaGrid = templateManager.container.getWidget('NewTitulosBaixaGrid');
        
        widgetNewTitulosBaixaGrid.dataSource.data.forEach(function(titulo){
            titulo.CDTPBAIXAPAG = widget.currentRow.CDTPBAIXAPAG;
            titulo.NMTPBAIXAPAG = widget.currentRow.NMTPBAIXAPAG;
        });
    };
    
    /**
     * Aplica Tipo de Baixa somente para Títulos sem Tipo de Baixa pré-cadastrado
     */
    self.aplicarTipoBaixaTitulosSemTipoBaixa = function() {
        var widget = templateManager.container.getWidget('NewBaixaTabbed');
        var widgetNewTitulosBaixaGrid = templateManager.container.getWidget('NewTitulosBaixaGrid');
        
        widgetNewTitulosBaixaGrid.dataSource.data.forEach(function(titulo){
            if(!titulo.CDTPBAIXAPAG){
                titulo.CDTPBAIXAPAG = widget.currentRow.CDTPBAIXAPAG;
                titulo.NMTPBAIXAPAG = widget.currentRow.NMTPBAIXAPAG;
            }
        });
    };

    /**
     * Confirmar Baixa Titulo a Pagar
     * @param args
     */
    self.confirmaBaixaTitulo = function(args){
        var widget = templateManager.container.getWidget('NewBaixaTabbed');
        var widgetNewTitulos = templateManager.container.getWidget('NewTitulosBaixaGrid');
        var checkedrows      = widgetNewTitulos.getCheckedRows();
        var boletostotais    = widgetNewTitulos.dataSource.data;

        if(widget.isValid()) {
            if(checkedrows.length > 0){
                var dtemissao  = moment(widget.currentRow.DTEMISSAO, "DD/MM/YYYY HH:mm:ss");
                var dtentrsaid = moment(widget.currentRow.DTENTRSAID, "DD/MM/YYYY HH:mm:ss");
                var dtbaixapag = moment(widget.currentRow.DTBAIXAPAG, "DD/MM/YYYY HH:mm:ss");
                
                if(dtbaixapag < dtemissao){
                    ScreenService.showMessage('Operação bloqueada. Data da baixa inferior a data de emissão do(s) título(s).');
                    return;
                }
                
                General.callRestEngine('fin#/crud/paramgeral', 'FilterData', []).then(function(paramgeral){
                    paramgeral = paramgeral.dataset.paramgeral[0];
                    
                    if((dtbaixapag < dtentrsaid) && (paramgeral.IDDTBINFDTE == 'N')){
                        ScreenService.showMessage('Operação bloqueada. Data da baixa inferior a data de entrada do(s) título(s).');
                        return;
                    }
                
                    localStorageEngine.getDataSource('fin_contaPagar#/ajbolpag_tipoajpagar').then(
                        function (datasource_aju) {
                            
                            var widgetTitulos    = templateManager.container.getWidget('TitulosAPagarGrid');
                            var cdempresa        = widgetTitulos.appliedFilter.FILTER_ROW.CDEMPRESA;
                            
                            self.buscaEmpresa(cdempresa).then(function (response_empresa){
                                var empresa = response_empresa.dataset.empresa[0];
                                
                                var currentRow = {
                                    nrorg           : getLocalVar('NRORG')   ,
                                    cdfilial        : getLocalVar('CDFILIAL'),
                                    baixaboleto     : widget.currentRow      ,
                                    boletosmarcados : checkedrows            ,
                                    ajustesboletos  : datasource_aju         ,
                                    boletostotais   : boletostotais
                                };
                
                                if(empresa.IDCTBBAIXAEMPR == 'S' && widget.currentRow.IDCTBLBXPAG == 'S'){
                                    Pag00001_TitulosAPagar_Service.buscaContOpeCtbl(widgetTitulos.appliedFilter.FILTER_ROW.CDEMPRESA).then(function (response) {
                                        var contopectbl  = response.dataset.contopectbl[0];
                    
                                        if(!contopectbl){
                                            ScreenService.showMessage('Operação bloqueada. Período contábil financeiro não parametrizado.');
                                            return;
                                        }
                                        
                                        var dtinicctbl  = contopectbl.DTINICCTBL;
                                        var dtfinacctbl = contopectbl.DTFINACCTBL;
                    
                                        if(dtinicctbl && dtfinacctbl) {
                                            if ((moment(dtinicctbl, 'DD/MM/YYYY')) > (moment(widget.currentRow.DTBAIXAPAG, 'DD/MM/YYYY')) ||
                                                (moment(dtfinacctbl, 'DD/MM/YYYY')) < (moment(widget.currentRow.DTBAIXAPAG, 'DD/MM/YYYY'))) {
                                                ScreenService.showMessage('Operação bloqueada. Data da baixa fora do período contábil financeiro.');
                                                return;
                                            }
                                        }
                    
                                        self.confirmaBaixaTituloSave(currentRow, widget, widgetTitulos);
                                    }, function (error) {
                                        if (contabilizacaoController.checkErrosContabilizacao(error)) {
                                            ScreenService.showMessage(error.data.error);
                                        }
                                    });
                                }else self.confirmaBaixaTituloSave(currentRow, widget, widgetTitulos);
                            });
                        }
                    );
                });
            }else ScreenService.showMessage('Operação bloqueada. Selecione o(s) título(s) para realizar a baixa.');
        }
    };

    /**
     * Confirma Baixa Titulo a Pagar Salvamento
     * @param widget
     * @param widgetTitulos
     * @param checkedrows
     * @param boletosmarcados
     */
    self.confirmaBaixaTituloSave = function(currentRow, widget, widgetTitulos){

        localStorage.setItem('baixaPagRow',JSON.stringify(currentRow));
        localStorage.setItem('TIPOBAIXA','PAG');
        
        Pag00001_TitulosAPagar_Service.baixaTituloPagar(currentRow).then(function () {

            if( widget.currentRow.IDBAIXAUTILP == 'A') {
                ScreenService.confirmMessage('Cheque inicial '+widget.currentRow.NRCHEQUE+'. Confirmar emissão do cheque?', 'question', function () {
                    Pag00001_TitulosAPagar_Service.buscaMunicipio(getLocalVar('CDFILIAL')).then(function (response) {

                        var report = 'ModeloCheque';
                        var routes = 'fin_contaPagar#/' + report;
                        var row = {
                            P_TESTE   : 'N',
                            P_STLOCAL : response.dataset.municipio_endefili[0].NMMUNICIPIO,
                            P_CODREDU : widget.currentRow.CDREDUCONT,
                            P_NUMERO  : widget.currentRow.NRCHEQUE
                        };

                        General.openReport(routes, report, row);

                        ScreenService.showMessage('Título(s) baixado(s) com sucesso.');

                        widget.currentRow.DTBAIXAPAG = '';
                        widget.currentRow.IDSTATUSBPAG = '';
                        widget.currentRow.NMSTATUSBPAG = '';
                        widget.currentRow.CDREDUCONT = '';
                        widget.currentRow.DSCONTCORR = '';
                        widget.currentRow.CDTPBAIXAPAG = '';
                        widget.currentRow.NMTPBAIXAPAG = '';
                        widget.currentRow.VRBAIXAPAG = '';
                        widget.currentRow.DSBAIXAPAG = '';
                        widget.currentRow.NRCHEQUE = '';
                        widget.currentRow.DSNOMCHEQ = '';
                        widget.currentRow.DSCHEQUE = '';
        
                        ScreenService.closeSwipe(widget);
                        ScreenService.closeSwipe();
                        widget.isVisible = false;
                        widgetTitulos.reload();
                        
                        widgetTitulos.dataSource.unSelectAll();
                        self.unsetStripeDataFooter();
                    }, function (error) {
                        ScreenService.showMessage(error.data.error);
                    });
                }, function(){
                    ScreenService.showMessage('Título(s) baixado(s) com sucesso.');

                    widget.currentRow.DTBAIXAPAG = '';
                    widget.currentRow.IDSTATUSBPAG = '';
                    widget.currentRow.NMSTATUSBPAG = '';
                    widget.currentRow.CDREDUCONT = '';
                    widget.currentRow.DSCONTCORR = '';
                    widget.currentRow.CDTPBAIXAPAG = '';
                    widget.currentRow.NMTPBAIXAPAG = '';
                    widget.currentRow.VRBAIXAPAG = '';
                    widget.currentRow.DSBAIXAPAG = '';
                    widget.currentRow.NRCHEQUE = '';
                    widget.currentRow.DSNOMCHEQ = '';
                    widget.currentRow.DSCHEQUE = '';
    
                    ScreenService.closeSwipe(widget);
                    ScreenService.closeSwipe();
                    widget.isVisible = false;
                    widgetTitulos.reload();
                    
                    widgetTitulos.dataSource.unSelectAll();
                    self.unsetStripeDataFooter();
                });
            }else{
                ScreenService.showMessage('Título(s) baixado(s) com sucesso.');

                widget.currentRow.DTBAIXAPAG = '';
                widget.currentRow.IDSTATUSBPAG = '';
                widget.currentRow.NMSTATUSBPAG = '';
                widget.currentRow.CDREDUCONT = '';
                widget.currentRow.DSCONTCORR = '';
                widget.currentRow.CDTPBAIXAPAG = '';
                widget.currentRow.NMTPBAIXAPAG = '';
                widget.currentRow.VRBAIXAPAG = '';
                widget.currentRow.DSBAIXAPAG = '';
                widget.currentRow.NRCHEQUE = '';
                widget.currentRow.DSNOMCHEQ = '';
                widget.currentRow.DSCHEQUE = '';

                ScreenService.closeSwipe(widget);
                ScreenService.closeSwipe();
                widget.isVisible = false;
                widgetTitulos.reload();
                
                widgetTitulos.dataSource.unSelectAll();
                self.unsetStripeDataFooter();
            }

        }, function (error) {
            if (contabilizacaoController.checkErrosContabilizacao(error)) {
                ScreenService.showMessage(error.data.error);
            }
        });
    };

    /**
     * Exclusão Baixa Titulo a Pagar
     */
    self.exclusaoBaixaTitulo = function(){
        var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');
        var titulos = widgetTitulos.getCheckedRows();

        if(titulos.length > 0) {
            
            var titulosBaixados = widgetTitulos.getCheckedRows().filter(function(titulo){
                return ((titulo.IDSTATBPAG == 'B') || (titulo.IDSTATBPAG == 'P'));
            });
            
            self.existeBaixaDevolucaoUtilizada(titulosBaixados)
                .then(function(){
                    Pag00001_TitulosAPagar_Service.buscaContOpeCtbl(widgetTitulos.appliedFilter.FILTER_ROW.CDEMPRESA).then(function (response) {
                        var contopectbl  = response.dataset.contopectbl[0];
                        var dtinicctbl  = contopectbl.DTINICCTBL;
                        var dtfinacctbl = contopectbl.DTFINACCTBL;

                        for(var i in titulosBaixados) {
                            if (!((titulosBaixados[i].IDSTATBPAG == 'B') || (titulosBaixados[i].IDSTATBPAG == 'P'))) {
                                ScreenService.showMessage('Operação bloqueada. Título(s) não está(ão) baixado(s).');
                                return;
                            }

                            if(dtinicctbl && dtfinacctbl) {
                                if ((moment(dtinicctbl, 'DD/MM/YYYY')) > (moment(titulosBaixados[i].DTBAIXAPAG, 'DD/MM/YYYY')) ||
                                    (moment(dtfinacctbl, 'DD/MM/YYYY')) < (moment(titulosBaixados[i].DTBAIXAPAG, 'DD/MM/YYYY'))) {
                                    ScreenService.showMessage('Operação bloqueada. Data da baixa fora do período financeiro.');
                                    return;
                                }
                            }
                        }

                        ScreenService.showCustomDialog('O que deseja cancelar?', 'question', 'question', [{
                            label: 'Baixa',
                            code: self.confirmaExclusaoBaixa
                        }, {
                            label: 'Título',
                            code: self.confirmaExclusaoTituloBaixa
                        }, {
                            label: 'Cancelar',
                            code: ''
                        }]);
                    }, function (error) {
                        ScreenService.showMessage(error.data.error);
                    });
                })
                .catch(function(error){
                    //ScreenService.showMessage(error.data.error);
                    ScreenService.closePopup();
                    ScreenService.showMessage('Operação bloqueada. Baixa referente à devolucao já utilizado, não pode ser excluída.');
                });
        }else ScreenService.showMessage('Operação bloaqueado. Marque o(s) título(s) para cancelamento de baixa.');
    };

    self.existeBaixaAdiantamentoUtilizado = function(checkedrows){
        
        var deferred = ZHPromise.defer();
        var route= 'fin_contaPagar#/crud/adiantapagar_contapagar';
        var nrbaixapag = checkedrows.map(function(row){return row.NRBAIXAPAG;}).join('_');
        var cdfilial = checkedrows.map(function(row){return row.CDFILIBAIPAG;}).join('_');
        var filter = [
          {
            'name':'P_NRBAIXAPAG', 
            'operator':'IN',
            'value':nrbaixapag 
          },
          {
            'name':'P_CDFILIAL', 
            'operator':'IN',
            'value':cdfilial
          }
        ];
        General.callRestEngine(route, 'FilterData', filter).then(function(adiantamentosUtilizados){
            var existeAdiantamento = adiantamentosUtilizados.dataset.adiantapagar_contapagar.length;
            if (existeAdiantamento == 0){
                deferred.resolve();
            }else {
                deferred.reject();
            }
        });
        return deferred.promise;
    };

    self.existeBaixaDevolucaoUtilizada = function(checkedrows){
        var deferred = ZHPromise.defer();
        var route= 'fin_contaPagar#/crud/devolucaopag_contapagar';
        var nrlanbolpag = checkedrows.map(function(row){return row.NRLANBOLPAG;});
        var cdfilial = checkedrows.map(function(row){return row.CDFILIAL;});
        var filter = [
            {'name':'NRLANBOLPAG', 'operator':'IN','value':nrlanbolpag},
            {'name':'CDFILIAL', 'operator':'IN','value':cdfilial}
        ];
        General.callRestEngine(route, 'FilterData', filter).then(function(devolucoesUtilizadas){
            var existeDevolucao = devolucoesUtilizadas.dataset.devolucaopag_contapagar.length;
            if (existeDevolucao == 0){
                deferred.resolve();
            }else {
                deferred.reject();
            }
        });
        return deferred.promise;
    };

    /**
     * Confirmar Exclusão Baixa Paga
     */
    self.confirmaExclusaoBaixa = function(){
        ScreenService.confirmMessage('Deseja realmente cancelar a(s) baixa(s)?', 'question', function() {
            var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');
            var cheque = false;
            
            var titulosBaixados = widgetTitulos.getCheckedRows().filter(function(titulo){
                return ((titulo.IDSTATBPAG == 'B') || (titulo.IDSTATBPAG == 'P'));
            });
            
            titulosBaixados.forEach(function(titulo){
                if ((titulo.NRCHEQUE) && (titulo.VRFINALBPAG == titulo.VRBAIXAPAG))
                    cheque = true;
            });

            if(!cheque) {
                var currentRow = {
                    nrorg           : getLocalVar('NRORG'),
                    cdfilial        : getLocalVar('CDFILIAL'),
                    boletosmarcados : titulosBaixados,
                    cheque          : null
                };

                Pag00001_TitulosAPagar_Service.excluiBaixaPagar(currentRow).then(function () {
                    ScreenService.showMessage('Baixa(s) excluída(s) com sucesso.');
                    ScreenService.closePopup();
                    
                    self.reloadTitulosAPagar();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            }else{
                var widgetCheque = templateManager.container.getWidget('ChequeForm');
                widgetCheque.isVisible = true;
                
                ScreenService.openPopup(widgetCheque);
            }
        });
    };

    /**
     * Recarrega Títulos a Pagar
     */
    self.reloadTitulosAPagar = function(){
        var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');
        
        widgetTitulos.reload();
        widgetTitulos.unSelectAll();
        self.unsetStripeDataFooter();
    };

    /**
     * Habilita/Desabilita campos de acordo com Tipo de Baixa
     */
    self.changeCheque = function() {
        var widget = templateManager.container.getWidget('ChequeForm');

        var idstcheque = widget.getField('IDSTCHEQUE').value();

        if(idstcheque == '0'){
            widget.getField('DSMOTICANC').readOnly = true;
            widget.getField('DSMOTICANC').setValue('');
        }else{
            widget.getField('DSMOTICANC').readOnly = false;
        }
    };

    /**
     * Confirma Cheque Exclusão Baixa
     * @param args
     */
    self.confirmaChequeExclusaoBaixa = function(args){
        var widgetCheque = args.owner.widget;
        var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');

        var currentRow = {
            nrorg: getLocalVar('NRORG'),
            cdfilial: getLocalVar('CDFILIAL'),
            boletosmarcados: widgetTitulos.getCheckedRows(),
            cheque: widgetCheque.currentRow
        };

        Pag00001_TitulosAPagar_Service.excluiBaixaPagar(currentRow).then(function () {
            ScreenService.showMessage('Baixa(s) excluída(s) com sucesso.');
            widgetTitulos.unSelectAll();
            self.unsetStripeDataFooter();

            widgetCheque.currentRow.IDSTCHEQUE    = '';
            widgetCheque.currentRow.CDMOTICANC     = '';
            widgetCheque.currentRow.DSMOTICANC     = '';

            ScreenService.closePopup(widgetCheque);
            ScreenService.closePopup();

            widgetCheque.isVisible = false;

            widgetTitulos.reload();
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    /**
     * Confirmar Exclusão Boleto Baixa Titulo a Pagar
     */
    self.confirmaExclusaoTituloBaixa = function(){
        ScreenService.confirmMessage('Deseja realmente cancelar o(s) título(s) da(s) baixa(s)?', 'question', function() {
            var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');
            var titulosChecked = widgetTitulos.getCheckedRows();

            titulosChecked = titulosChecked.filter(function(titulo){
                return ((titulo.IDSTATBPAG == 'B') || (titulo.IDSTATBPAG == 'P'));
            });

            var currentRow = {
                nrorg   : getLocalVar('NRORG'),
                cdfilial: getLocalVar('CDFILIAL'),
                boletosmarcados: titulosChecked
            };

            Pag00001_TitulosAPagar_Service.excluiTituloBaixaPagar(currentRow).then(function () {
                ScreenService.showMessage('Título(s) excluído(s) da(s) baixa(s) com sucesso.');
                widgetTitulos.unSelectAll();
                self.unsetStripeDataFooter();
                ScreenService.closePopup();
                widgetTitulos.reload();
            }, function (error) {
                if (contabilizacaoController.checkErrosContabilizacao(error)) {
                    ScreenService.showMessage(error.data.error);
                }
            });
        });
    };

    /**
     * Associar Títulos a Pagar
     * @param widget
     */
    self.associacaoTitulo = function(widget){
        var checkedrows = widget.getCheckedRows();
        var valortotal = 0;

        if(checkedrows.length > 1) {
            for(var i in checkedrows) {
                if((checkedrows[i].IDSTATBPAG == 'B') || (checkedrows[i].IDSTATBPAG == 'P')){
                    ScreenService.showMessage('Operação bloqueada. Título(s) baixado(s) ou com baixa(s) planejada(s) não pode(m) ser alterado(s).');
                    return;
                }
                if(checkedrows[i].IDSITUCNABP != '00') {
                    ScreenService.showMessage('Operação bloqueada. Título(s) enviado(s), via CNAB, não pode(m) ser alterado(s).');
                    return;
                }
                if(checkedrows[i].IDSTATUS == 'V') {
                    ScreenService.showMessage('Operação bloqueada. Título(s) previsto(s) não pode(m) ser alterado(s).');
                    return;
                }
                if(checkedrows[i].IDBLOQNFFINCP == 'B') {
                    ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
                    return;
                }

                valortotal += parseFloat(checkedrows[i].VRFINALBPAG);
            }

            Pag00001_TitulosAPagar_Service.validaAssociacaoTitulo(checkedrows).then(function () {
                var widgetAssociar = templateManager.container.getWidget('AssociarForm');
                widgetAssociar.isVisible = true;
                ScreenService.openPopup(widgetAssociar);
                widgetAssociar.getField('VRFINALBPAG').setValue(valortotal.toFixed(2));
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }else ScreenService.showMessage('Operação bloqueada. Marque no mínimo dois títulos para associação.');
    };

    /**
     * Confirmar Associacao Títulos a Pagar
     * @param args
     */
    self.confirmaAssociacaoTitulo = function(args){
        var widget        = args.owner.widget;
        var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');

        var params = {
            nrorg       : getLocalVar('NRORG')          ,
            cdfilial    : getLocalVar('CDFILIAL')       ,
            dtvenbolpag : widget.currentRow.DTVENBOLPAG ,
            cdreducont  : widget.currentRow.CDREDUCONT  ,
            cdtpbaixapag: widget.currentRow.CDTPBAIXAPAG
        };

        var checkedrows = [params, widgetTitulos.getCheckedRows()];

        if(widget.isValid()) {
            Pag00001_TitulosAPagar_Service.confirmaAssociacaoTitulo(checkedrows).then(function () {
                ScreenService.showMessage('Títulos associados com sucesso.');
                widgetTitulos.unSelectAll();
                self.unsetStripeDataFooter();

                widget.currentRow.DTVENBOLPAG  = '';
                widget.currentRow.DSCONTCORR   = '';
                widget.currentRow.NMTPBAIXAPAG = '';
                widget.isVisible = false;

                ScreenService.closePopup(widget);
                ScreenService.closePopup();

                widgetTitulos.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };

    /**
     * Cancela Associação Títulos a Pagar
     * @param widget
     */
    self.cancelaAssociacaoTitulo = function(widget){
        var checkedrows = widget.getCheckedRows();
        if(checkedrows.length > 0) {
            for(var i in checkedrows) {
                if((checkedrows[i].IDSTATBPAG == 'B') || (checkedrows[i].IDSTATBPAG == 'P')){
                    ScreenService.showMessage('Operação bloqueada. Título(s) baixado(s) ou com baixa(s) planejada(s) não pode(m) ser alterado(s).');
                    return;
                }
                if(checkedrows[i].IDSITUCNABP != '00') {
                    ScreenService.showMessage('Operação bloqueada. Título(s) enviado(s), via CNAB, não pode(m) ser alterado(s).');
                    return;
                }
            }

            ScreenService.confirmMessage('Deseja realmente desassociar o(s) título(s)?', 'question', function () {
                Pag00001_TitulosAPagar_Service.cancelaAssociacaoTitulo(checkedrows).then(function () {
                    ScreenService.showMessage('Títulos desassociados com sucesso.');
                    widget.unSelectAll();
                    self.unsetStripeDataFooter();
                    ScreenService.closePopup();
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            });
        }else ScreenService.showMessage('Marque o(s) título(s) para desassociação.');
    };

    /**
     * Atualiza Formulário
     */
    self.atualizaForm = function(widget_name) {
        var widget = templateManager.container.getWidget(widget_name);
        widget.currentRow = widget.dataSource.data[0]?widget.dataSource.data[0]:{};
        templateManager.updateTemplate();
    };

    self.atualizaFormCnab = function() {
        var widget = templateManager.container.getWidget('CnabForm');
        var dadosRemessa = widget.dataSource.data.filter(function(data){
            return data.IDTIPCNABPAG == 0;
        });
        var dadosRetorno = widget.dataSource.data.filter(function(data){
            return data.IDTIPCNABPAG == 1;
        });
        if (dadosRemessa.length > 0){
            widget.currentRow.CDEMPRESA = dadosRemessa[0].CDEMPRESA;
            widget.currentRow.NRCNABPAG = dadosRemessa[0].NRCNABPAG;
            widget.currentRow.CDOPERADOR = dadosRemessa[0].CDOPERADOR;
            widget.currentRow.NMOPERADOR = dadosRemessa[0].NMOPERADOR;
            widget.currentRow.DTCNABPAG = dadosRemessa[0].DTCNABPAG;
            widget.currentRow.IDOPECNABPAG = dadosRemessa[0].IDOPECNABPAG;
            widget.currentRow.NMOPECNABPAG = dadosRemessa[0].NMOPECNABPAG;
            widget.currentRow.CDREDUCONT = dadosRemessa[0].CDREDUCONT;
            widget.currentRow.CDBANCO = dadosRemessa[0].CDBANCO;
            widget.currentRow.DSCONTCORR = dadosRemessa[0].DSCONTCORR;
            widget.currentRow.IDTIPCNABPAG = dadosRemessa[0].IDTIPCNABPAG;
            widget.currentRow.NMTIPCNABPAG = dadosRemessa[0].NMTIPCNABPAG;
            widget.currentRow.QTBOLCNABPAG = dadosRemessa[0].QTBOLCNABPAG;
            widget.currentRow.VRTOTALCNABPAG = dadosRemessa[0].VRTOTALCNABPAG;
        }
        if (dadosRetorno.length > 0){
            widget.currentRow.NRCNABPAGRETORNO = dadosRetorno[0].NRCNABPAG;
            widget.currentRow.NMOPERADORRETORNO = dadosRetorno[0].NMOPERADOR;
            widget.currentRow.DTCNABPAGRETORNO = dadosRetorno[0].DTCNABPAG;
        }
        templateManager.updateTemplate();
    };
    
    self.habilitarTitulo = function(widget){
        var checkedRows = widget.getCheckedRows();
        
        ScreenService.confirmMessage('Deseja realmente habilitar o(s) título(s) marcado(s)?', 'question', function () {

            checkedRows = checkedRows.filter(function(data){
                return data.IDHABIBPAG != 'S';
            });
            
            var dataSet = [checkedRows, ['S']];
            
            General.callRestEngine('fin_contaPagar#/habilitaTituloAPagar', 'DataSet', dataSet).then(function () {
                ScreenService.showMessage('Registro(s) habilitado(s) com sucesso.');
                ScreenService.closePopup();
                widget.reload();
                widget.unSelectAll();
                self.unsetStripeDataFooter();
            }).catch(function(erro){
                ScreenService.showMessage(erro.data.error);
            });
                
        });
    };
    
    self.desabilitarTitulo = function(widget){
        var checkedRows = widget.getCheckedRows();
        
        ScreenService.confirmMessage('Deseja realmente desabilitar o(s) título(s) marcado(s)?', 'question', function () {

            checkedRows = checkedRows.filter(function(data){
                return data.IDHABIBPAG != 'N';
            });
            
            var dataSet = [checkedRows, ['N']];
            
            General.callRestEngine('fin_contaPagar#/habilitaTituloAPagar', 'DataSet', dataSet).then(function () {
                ScreenService.showMessage('Registro(s) desabilitado(s) com sucesso.');
                ScreenService.closePopup();
                widget.reload();
                widget.unSelectAll();
                self.unsetStripeDataFooter();
            }).catch(function(erro){
                ScreenService.showMessage(erro.data.error);
            });
                
        });
    };
    
    /** [Fim]Título a Pagar/Pagos */

    /** [Inicio]Ajuste Grid */

    /**
     * Novo Ajuste Boleto Pagar
     * @param args
     */
    self.novoAjusteBoleto = function(args){
        var widget = args.owner.widget;
        var widgetTitulosAPagar = templateManager.container.getWidget('TitulosAPagarGrid');

        if((widgetTitulosAPagar.currentRow.IDSTATBPAG == 'B') || (widgetTitulosAPagar.currentRow.IDSTATBPAG == 'P')){
            ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
            return;
        }
        if(widgetTitulosAPagar.currentRow.IDSTATUS == 'V') {
            ScreenService.showMessage('Operação bloqueada. Título previsto não pode ser alterado.');
            return;
        }
        if(widgetTitulosAPagar.currentRow.IDBLOQNFFINCP == 'B') {
            ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
            return;
        }

        if(!widgetTitulosAPagar.currentRow.NRCNABPAGREM){
            widget.newRow();
            widget.getField('VRATUABPAG').setValue(widgetTitulosAPagar.currentRow.VRFINALBPAG);
            widget.getField('VRAJBOLPAG').setValue(0);
            widget.getField('VRDESEBPAG').setValue(widgetTitulosAPagar.currentRow.VRFINALBPAG);
        }else{
            var paramsRem  = {nrorg: getLocalVar('NRORG'), cdfilial: getLocalVar('CDFILIAL'), cdoperador: getLocalVar('CDOPERADOR')};
            var currentRowRem = [paramsRem, [widgetTitulosAPagar.currentRow]];

            ScreenService.confirmMessage('O título está vinculado a uma remessa. Deseja removê-lo para prosseguir?', 'question', function () {
                Pag00001_TitulosAPagar_Service.excluiTituloPagRemessa(currentRowRem).then(function () {
                    widget.newRow();
                    widget.getField('VRATUABPAG').setValue(widgetTitulosAPagar.currentRow.VRFINALBPAG);
                    widget.getField('VRAJBOLPAG').setValue(0);
                    widget.getField('VRDESEBPAG').setValue(widgetTitulosAPagar.currentRow.VRFINALBPAG);
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            });

        }
    };

    /**
     * Salva Ajuste Boleto
     * @param args
     */
    self.salvaAjusteBoleto = function(args){
        var widget        = args.owner.widget;
        var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');

        if(widget.isValid()){
            
            var vrajbolpag = self.formataValor(widget.currentRow.VRAJBOLPAG);
            var vratuabpag = self.formataValor(widget.currentRow.VRATUABPAG);

            if(vrajbolpag <= 0){
                ScreenService.showMessage('Operação bloqueada. Valor do ajuste deve ser maior que zero.');
                return;
            }

            if((widget.currentRow.IDAJUCTPAG == 'D')&&(vrajbolpag > vratuabpag)){
                ScreenService.showMessage('Operação bloqueada. Valor do ajuste de desconto deve ser menor ou igual ao valor do título.');
                return;
            }


            Pag00001_TitulosAPagar_Service.salvaAjusteBoleto(widget.currentRow).then(function () {
                ScreenService.showMessage('Registro salvo com sucesso.', 'checked');
                ScreenService.goBack();

                // Valor de Ajuste do Título
                var idajuctpag  = widget.currentRow.IDAJUCTPAG;
                var vrajbolpag  = self.formataValor(widget.currentRow.VRAJBOLPAG);
                vrajbolpag      = (idajuctpag == 'A')?vrajbolpag:-(vrajbolpag);

                // Atualiza Valor Líquido do Título
                var vrfinalbpag = self.formataValor(widgetTitulos.currentRow.VRFINALBPAG);
                vrfinalbpag    += vrajbolpag;
                widgetTitulos.currentRow.VRFINALBPAG = vrfinalbpag;

                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };

    /**
     * Deleta Ajuste Boleto
     * @param args
     */
    self.deletaAjusteBoleto = function(args){
        var widgetTitulosAPagar = templateManager.container.getWidget('TitulosAPagarGrid');

        if((widgetTitulosAPagar.currentRow.IDSTATBPAG == 'B') || (widgetTitulosAPagar.currentRow.IDSTATBPAG == 'P')) {
            ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
            return;
        }
        if(widgetTitulosAPagar.currentRow.IDSTATUS == 'V') {
            ScreenService.showMessage('Operação bloqueada. Título previsto não pode ser alterado.');
            return;
        }
        if(widgetTitulosAPagar.currentRow.IDBLOQNFFINCP == 'B') {
            ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
            return;
        }

        if(!widgetTitulosAPagar.currentRow.NRCNABPAGREM){
            self.confirmaDeletaAjusteBoleto(args);
        }else{
            var paramsRem  = {nrorg: getLocalVar('NRORG'), cdfilial: getLocalVar('CDFILIAL'), cdoperador: getLocalVar('CDOPERADOR')};
            var currentRowRem = [paramsRem, [widgetTitulosAPagar.currentRow]];

            ScreenService.confirmMessage('O título está vinculado a uma remessa. Deseja removê-lo para prosseguir?', 'question', function () {
                Pag00001_TitulosAPagar_Service.excluiTituloPagRemessa(currentRowRem).then(function () {
                    self.confirmaDeletaAjusteBoleto(args);
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            });

        }

    };

    /**
     * Deleta Ajuste Boleto
     * @param args
     */
    self.confirmaDeletaAjusteBoleto = function(args){
        ScreenService.confirmMessage('Deseja realmente excluir o Ajuste?', 'question', function() {
            var widget = args.owner.widget;
            var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');

            if (widget.isValid()) {
                Pag00001_TitulosAPagar_Service.deletaAjusteBoleto(widget.currentRow).then(function () {
                    ScreenService.showMessage('Registro excluído com sucesso.', 'checked');
                    ScreenService.goBack();

                    // Valor de Ajuste do Título
                    var idajuctpag  = widget.currentRow.IDAJUCTPAG;
                    idajuctpag      = (idajuctpag == 'A')?'D':'A';
                    var vrajbolpag  = parseFloat(widget.currentRow.VRAJBOLPAG);
                    vrajbolpag      = (idajuctpag == 'A')?vrajbolpag:-(vrajbolpag);

                    // Atualiza Valor Líquido do Título
                    var vrfinalbpag = parseFloat(widgetTitulos.currentRow.VRFINALBPAG);
                    vrfinalbpag    += vrajbolpag;
                    widgetTitulos.currentRow.VRFINALBPAG = vrfinalbpag;

                    widget.reload();
                    widgetTitulos.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            }
        });
    };

	/**
     * Busca Ajuste Titulo a Pagar
     * @param cdfilial
     * @param nrlanbolpag
     */
    self.buscaAjusteTitulo = function(cdfilial, nrlanbolpag){
        return Pag00001_TitulosAPagar_Service.buscaAjusteTitulo(cdfilial, nrlanbolpag).then(function (ajbolpag) {
            return ajbolpag;
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    /**
     * Busca Conta a Pagar
     * @param cdfilial
     * @param nrlanctonf
     */
    self.buscaContaPagar = function(cdfilial, nrlanctonf){
        return Pag00001_TitulosAPagar_Service.buscaContaPagar(cdfilial, nrlanctonf).then(function (contapagar) {
            return contapagar;
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    /** [Fim]Ajuste Grid */

    /** [Inicio] Parcelamento Grid */

    /**
     * Valor Total Parcelamento Títulos a Pagar
     * @param args
     */
    var valorTotalParcelamento = function(args){
        var vrtotal = 0;
        for(var i in args.dataSource.data)
            vrtotal += args.dataSource.data[i].VRFINALBPAG?parseFloat(args.dataSource.data[i].VRFINALBPAG):0;
            
        return vrtotal;
    };

    /**
     * Nova Parcela Títulos a Pagar
     * @param args
     */
    self.novaParcela = function(args){
        var widget = args.owner.widget;
        var widgetTitulosAPagar = templateManager.container.getWidget('TitulosAPagarGrid');

        if((widgetTitulosAPagar.currentRow.IDSTATBPAG == 'B') || (widgetTitulosAPagar.currentRow.IDSTATBPAG == 'P')){
            ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
            return;
        }
        if(widgetTitulosAPagar.currentRow.IDSTATUS == 'V') {
            ScreenService.showMessage('Operação bloqueada. Título previsto não pode ser alterado.');
            return;
        }
        if(widgetTitulosAPagar.currentRow.IDBLOQNFFINCP == 'B') {
            ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
            return;
        }

        if(!widgetTitulosAPagar.currentRow.NRCNABPAGREM){
            self.confirmaNovaParcela(widget, widgetTitulosAPagar);
        }else{
            var paramsRem  = {nrorg: getLocalVar('NRORG'), cdfilial: getLocalVar('CDFILIAL'), cdoperador: getLocalVar('CDOPERADOR')};
            var currentRowRem = [paramsRem, [widgetTitulosAPagar.currentRow]];

            ScreenService.confirmMessage('O título está vinculado a uma remessa. Deseja removê-lo para prosseguir?', 'question', function () {
                Pag00001_TitulosAPagar_Service.excluiTituloPagRemessa(currentRowRem).then(function () {
                    self.confirmaNovaParcela(widget, widgetTitulosAPagar);
                    widgetTitulosAPagar.currentRow.IDSITUCNABP = '00';
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            });
        }
    };

    /**
     * Confirma Nova Parcela Títulos a Pagar
     * @param widget
     * @param widgetTitulosAPagar
     */
    self.confirmaNovaParcela = function(widget, widgetTitulosAPagar){
        self.buscaAjusteTitulo(widgetTitulosAPagar.currentRow.CDFILIAL, widgetTitulosAPagar.currentRow.NRLANBOLPAG).then(function (response_ajbolpag){
            var ajbolpag = response_ajbolpag.dataset.ajbolpag[0];
            if(!ajbolpag) {
                widget.currentRow = widget.dataSource.data[0];
                
                if (widget.dataSource.data[0].NRPARCBOLPAG == "00") {
                    widget.afterMoveRow();
                    widget.edit();
                    widget.currentRow.NRPARCBOLPAG = "01";
                    widget.currentRow.NRPARCBOLPAGVISU = "001";
                    widget.currentRow.__createdLocal = true;
                    widget.currentRow.__is_new       = false;
                    widget.getField('DTVENBOLPAG').readOnly = true;
                } else {
                    
                    var nrparcbolpag     = retornaNumeroParcela(widget.dataSource.data.length + 1);
                    var nrparcbolpagvisu = ("00" + (widget.dataSource.data.length + 1)).slice(-3);
                    var dtvenbolpag = widget.dataSource.data[widget.dataSource.data.length - 1].DTVENBOLPAG;
                    var vrtotalparc = valorTotalParcelamento(widget);
                    var vttotbolpag = widget.currentRow.VRTOTBOLPAG;

                    widget.newRow();

                    widget.currentRow.__is_new     = true;
                    widget.currentRow.NRPARCBOLPAG = nrparcbolpag;
                    widget.currentRow.NRPARCBOLPAGVISU = nrparcbolpagvisu;
                    widget.currentRow.DTVENBOLPAG  = dtvenbolpag;
                    widget.currentRow.VRFINALBPAG  = ((vttotbolpag - vrtotalparc) >= 0)?(vttotbolpag - vrtotalparc):0;
                    widget.getField('DTVENBOLPAG').readOnly = false;
                }
            }else ScreenService.showMessage('Operação bloqueada. Não é possível parcelar título com ajuste.');
        });
    };

    /**
     * Edita Parcela Títulos a Pagar
     * @param widget
     */
    self.editaParcela = function(widget){
        var dataLength = widget.dataSource.data.length;
        var indexRow   = widget.currentRow.__index + 1;

        if(widget.currentRow.NRPARCBOLPAG != '00')
            if (!widget.currentRow.__createdLocal) {
                if (dataLength != indexRow){
                    ScreenService.showMessage('Operação bloqueada. Somente é permitido a editar a última parcela do título.');
                }else General.edit(widget);
            }else{
                widget.currentRow.__is_new     = false;
                widget.getField('DTVENBOLPAG').readOnly = ((widget.currentRow.NRPARCBOLPAG == '01'));
                General.edit(widget);
            }
        else ScreenService.showMessage('Operação bloqueada. Não é possível editar a parcela original.');
    };

    /**
     * Deleta Parcela Títulos a Pagar
     * @param args
     */
    self.deletaParcelamento = function(args){
        var widget     = args.owner.widget;
        var dataLength = widget.dataSource.data.length;
        var indexRow   = widget.currentRow.__index + 1;

        if(dataLength > 1) {
            if (dataLength == indexRow) {
                if (!widget.currentRow.__createdLocal) {
                    ScreenService.confirmMessage('Deseja realmente excluir a parcela?', 'question', function () {
                        Pag00001_TitulosAPagar_Service.deletaParcelamentoTitulo(widget.dataSource.data).then(function () {
                            ScreenService.showMessage('Registro excluído com sucesso.', 'checked');
                            ScreenService.goBack();

                            widget.reload();
                            templateManager.container.getWidget('TitulosAPagarGrid').reload();
                        }, function (error) {
                            ScreenService.showMessage(error.data.error);
                        });
                    });
                } else{
                    ScreenService.confirmMessage('Deseja realmente excluir a parcela?', 'question', function () {
                        ScreenService.showMessage('Registro excluído com sucesso.', 'checked');
                        General.backOrCancel(args);
                    });
                }
            } else ScreenService.showMessage('Operação bloqueada. Somente é permitido a exclusão da última parcela do título.');
        }else{
            if(widget.currentRow.NRPARCBOLPAG == '01') {
                ScreenService.confirmMessage('Deseja realmente excluir a parcela?', 'question', function () {
                    ScreenService.showMessage('Registro excluído com sucesso.', 'checked');
                    ScreenService.goBack();

                    widget.reload();
                });
            }else ScreenService.showMessage('Operação bloqueada. Não é possível excluir a parcela original.');
        }
    };

    /**
     * Salva Parcela Títulos a Pagar
     * @param args
     */
    self.salvaParcela = function(args){
        if(args.owner.widget.isValid()) {
            var widget = args.owner.widget;
            
            widget.view();
            ScreenService.goBack();
            
            widget.getAction('finalizarParcela').isVisible = true;
            widget.getAction('parcelamentoAutomatico').isVisible = false;
            widget.getAction('cancelarParcela').isVisible = true;
            widget.getAction('back_list').isVisible = false;
            
            self.widgetEmEdicao('ParcelamentoGrid', true);
            self.desabilitaAbas('ParcelamentoGrid', true);
        }
    };
    
    /**
     * Desabilita Abas
     * @param widget
     */
    self.desabilitaAbas = function(widget_name, disable){
        var widget = templateManager.container.getWidget(widget_name);
        
        if(disable){
            General.changeWidgetAcessibility(widget.getParent().widgets, !disable);
            General.changeWidgetAcessibility([widget.getParent()], !disable);
            General.changeWidgetAcessibility([widget], disable);
        }else{
            General.changeWidgetAcessibility(widget.getParent().widgets, !disable);
            General.changeWidgetAcessibility([widget.getParent()], !disable);
        }
    };

    /**
     * Finaliza Parcelamento Títulos a Pagar
     * @param widget
     */
    self.finalizaParcelamento = function(widget){
        var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');
        
        self.validaParcelamentoManual(widgetTitulos, widget)
        .then(function(){
            Pag00001_TitulosAPagar_Service.finalizaParcelamentoTitulo(widget.dataSource.data).then(function () {
                ScreenService.showMessage('Registro(s) salvo(s) com sucesso.', 'checked');
                
                self.widgetEmEdicao('ParcelamentoGrid', false);
                self.desabilitaAbas('ParcelamentoGrid', false);
                
                widget.reload();
                widgetTitulos.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        })
        .catch(function(erro){
            if (erro){
                ScreenService.showMessage(erro);
            }
        });
    };
    
    /**
     * Cancela Parcelamento Títulos a Pagar
     * @param args
     */
    self.cancelaParcelamento = function(args){
        General.backOrCancel(args).then(function(){
            var widget = args.owner.widget;
            if(widget.currentRow.NRPARCBOLPAG == '01' && widget.dataSource.data.length == 1)
                widget.reload();
            self.widgetEmEdicao('ParcelamentoGrid', false);
            self.desabilitaAbas('ParcelamentoGrid', false);
        });
    };

    /**
     * Desabilita Ação Finalizar Parcela Títulos a Pagar
     * @param args
     */
    self.desabilitaFinalizacaoParcela = function(args){
        args.owner.getAction('finalizarParcela').isVisible = false;
        args.owner.getAction('parcelamentoAutomatico').isVisible = true;
        args.owner.getAction('cancelarParcela').isVisible = false;
        args.owner.getAction('back_list').isVisible = true;
        self.widgetEmEdicao('ParcelamentoGrid', false);
        self.desabilitaAbas('ParcelamentoGrid', false);
    };

    /** [Fim] Parcelamento Grid */

    /** [Início]Documento Form */

    /**
     * Atualiza Titulo a Pagar/Pagos
     * @param args
     */
    self.atualizaTituloAPagar = function(){
        var widgetTitulosAPagarGrid = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetDocumentosGrid    = templateManager.container.getWidget('DocumentosGrid');
        
        if(widgetDocumentosGrid.isValid()){
            if((moment(widgetDocumentosGrid.currentRow.DTEMISSAO, 'DD/MM/YYYY')) > (moment(widgetDocumentosGrid.currentRow.DTENTRSAID, 'DD/MM/YYYY'))){
                ScreenService.showMessage('Data de Emissão deve ser menor ou igual a Data de Entrada.');
                return;
            }
            
            if((moment(widgetDocumentosGrid.currentRow.DTEMISSAO, 'DD/MM/YYYY')) > (moment(widgetTitulosAPagarGrid.currentRow.DTVENBOLPAG, 'DD/MM/YYYY'))){
                ScreenService.showMessage('Data de Emissão deve ser menor ou igual a Data de Vencimento.');
                return;
            }
    
            if((widgetDocumentosGrid.currentRow.backupIdstatus   != widgetDocumentosGrid.currentRow.IDSTATUS) ||
                (widgetDocumentosGrid.currentRow.backupDtnotafisc != widgetDocumentosGrid.currentRow.DTENTRSAID)){
                Pag00001_TitulosAPagar_Service.buscaContOpeCtbl(widgetDocumentosGrid.currentRow.CDEMPRESA).then(function (response) {
                    var contopectbl  = response.dataset.contopectbl[0];
    
                    var dtinicctbl  = contopectbl.DTINICCTBL;
                    var dtfinacctbl = contopectbl.DTFINACCTBL;
    
                    if(dtinicctbl && dtfinacctbl) {
                        if ((moment(dtinicctbl, 'DD/MM/YYYY')) > (moment(widgetDocumentosGrid.currentRow.DTENTRSAID, 'DD/MM/YYYY')) ||
                            (moment(dtfinacctbl, 'DD/MM/YYYY')) < (moment(widgetDocumentosGrid.currentRow.DTENTRSAID, 'DD/MM/YYYY'))) {
                            ScreenService.showMessage('Operação bloqueada. Data de entrada fora do período financeiro.');
                            return;
                        }
                    }
    
                    Pag00001_TitulosAPagar_Service.atualizaTituloAPagar(widgetDocumentosGrid.currentRow).then(function () {
                        ScreenService.showMessage('Registro salvo com sucesso.', 'checked');
                        ScreenService.goBack();
    
                        widgetTitulosAPagarGrid.currentRow.IDSTATUS = widgetDocumentosGrid.currentRow.IDSTATUS;
    
                        widgetDocumentosGrid.reload();
                    }, function (error) {
                        if (contabilizacaoController.checkErrosContabilizacao(error))
                            ScreenService.showMessage(error.data.error);
                    });
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            }else{
                Pag00001_TitulosAPagar_Service.atualizaTituloAPagar(widgetDocumentosGrid.currentRow).then(function () {
                    ScreenService.showMessage('Registro salvo com sucesso.', 'checked');
                    ScreenService.goBack();
    
                    widgetTitulosAPagarGrid.currentRow.IDSTATUS = widgetDocumentosGrid.currentRow.IDSTATUS;
    
                    widgetDocumentosGrid.reload();
                }, function (error) {
                    if (contabilizacaoController.checkErrosContabilizacao(error))
                        ScreenService.showMessage(error.data.error);
                });
            }
        }
    };

    /**
     * Busca Parametrização Filial
     */
    self.changeFilial = function() {
        var widgetDocumentosForm = templateManager.container.getWidget('DocumentosForm');

        if(widgetDocumentosForm.getField('CDFILIRECE').value()){

            // Tamanho NF
            var nrtamnumnfutdfe = (widgetDocumentosForm.getField('NRTAMNUMNFUTDFE').value() > 0) ? widgetDocumentosForm.getField('NRTAMNUMNFUTDFE').value() : 9;
            widgetDocumentosForm.getField('NRNOTAFISC').maxlength = nrtamnumnfutdfe;

            // Gera Novo Código NF
            var currentRow = {
                NRORG      : getLocalVar('NRORG'),
                CDCONTADOR : 'NRNOTAFISCPAG'
            };
            Pag00001_TitulosAPagar_Service.geraNovoCodigo(currentRow).then(function (novocodigo) {
                var nrnotafisc = novocodigo.dataset.geraNovoCodigo.novocodigo.slice(-nrtamnumnfutdfe);
                widgetDocumentosForm.getField('NRNOTAFISC').setValue(nrnotafisc);
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });

            // Busca Padrão Serie NF
            Pag00001_TitulosAPagar_Service.buscaPadraoSerieNF(getLocalVar('CDFILIAL'), widgetDocumentosForm.currentRow.CDFILIRECE).then(function (response_serienf) {
                var serienf = response_serienf.dataset.notafiscal_serieentr[0];

                if(serienf != undefined){
                    widgetDocumentosForm.currentRow.CDSERIE = serienf.CDSERIEENTR;
                    widgetDocumentosForm.currentRow.DSSERIE = serienf.DSSERIEENTR;
                }else{
                    widgetDocumentosForm.currentRow.CDSERIE = null;
                    widgetDocumentosForm.currentRow.DSSERIE = null;
                }

                widgetDocumentosForm.redraw();
                widgetDocumentosForm.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });

        }else{
            widgetDocumentosForm.currentRow.CDSERIE = '';
            widgetDocumentosForm.currentRow.DSSERIE = '';
            widgetDocumentosForm.getField('NRNOTAFISC').setValue('');
        }
    };

    /**
     * Busca Parametrização Fornecedor
     * @param args
     */
    self.changeFornecedor = function(args) {
        var widgetDocumentosForm = args.owner.field.widget.container.getWidget('DocumentosForm');

        widgetDocumentosForm.getField('CDTPCTPAGAR').setValue('');
        widgetDocumentosForm.getField('DSTPCTPAGAR').setValue('');
        widgetDocumentosForm.getField('CDCLASSFINA').setValue('');
        widgetDocumentosForm.getField('DSCONTAPAG').setValue('');
        widgetDocumentosForm.getField('DSDEFACTPAG').setValue('');

        var cdforneced = widgetDocumentosForm.getField('CDFORNECED').value();

        if(cdforneced){

            Pag00001_TitulosAPagar_Service.buscaFornecedor(cdforneced).then(function (paramforneced) {
                var fornecedor  = paramforneced.dataset.fornecedor[0];
                var cdtpctpagar = fornecedor.CDTPCTPAGAR;

                if(cdtpctpagar){
                    Pag00001_TitulosAPagar_Service.buscaTipoctpagar(cdtpctpagar).then(function (paramtipoctpagar) {
                        var tipoctpagar = paramtipoctpagar.dataset.tipoctpagar[0];
                        widgetDocumentosForm.getField('CDTPCTPAGAR').setValue(tipoctpagar.CDTPCTPAGAR);
                        widgetDocumentosForm.getField('DSTPCTPAGAR').setValue(tipoctpagar.DSTPCTPAGAR);
                        widgetDocumentosForm.getField('CDCLASSFINA').setValue(tipoctpagar.CDCLASSFINA);
                        widgetDocumentosForm.getField('DSCONTAPAG' ).setValue(tipoctpagar.DSDEFACTPAG);
                    }, function (error) {
                        ScreenService.showMessage(error.data.error);
                    });
                }

            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });

        }
    };

    /**
     * Busca Parametrização Tipo de Conta
     * @param args
     * @param widget_name
     */
    self.changeTipoConta = function(args, widget_name) {
        var widgetDocumentos = templateManager.container.getWidget(widget_name);

        widgetDocumentos.currentRow.DSCONTAPAG = widgetDocumentos.currentRow.DSDEFACTPAG?widgetDocumentos.currentRow.DSDEFACTPAG:widgetDocumentos.currentRow.DSTPCTPAGAR;
        if(widget_name != 'DocumentosGrid')
            args.owner.field.widget.container.getWidget(widget_name).getField('DSCONTAPAG').reload();
    };

    /**
     * Gera Títulos a Pagar
     * @param widget
     */
    self.geraTituloAPagar = function(widget){
        var documentosForm = widget;
        var widgetTitulosAPagarGrid = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetParcelamentoDocGrid = templateManager.container.getWidget('ParcelamentoDocGrid');
        var widgetAnexoDocGrid = templateManager.container.getWidget('AnexoDocGrid');
        var gridRateio = templateManager.container.getWidget("RateioDocGrid");
        var rateioPadrao = gridRateio.dataSource.data;
        
        if(documentosForm.isValid()){
            if(widgetParcelamentoDocGrid.isValid()){
                var filter = [
                    {
                        "name": "CDFORNECED",
                        "operator": "=",
                        "value": documentosForm.currentRow.CDFORNECED
                    },
                    {
                        "name": "CDSERIEENTR",
                        "operator": "=",
                        "value": documentosForm.currentRow.CDSERIE
                    },
                    {
                        "name": "NRNOTAFISC",
                        "operator": "=",
                        "value": documentosForm.currentRow.NRNOTAFISC
                    },
                    {
                        "name": "IDENTRSAIDOP",
                        "operator": "=",
                        "value": 'E'
                    }
                ];
    
                General.callRestEngine('fin#/crud/notafiscal', 'FilterData', filter).then(function (notafiscal) {
                    var nota = notafiscal.dataset.notafiscal;
                    
                    if((nota.length > 0)){
                        ScreenService.showMessage('Operação bloqueada. Documento já lançado.');
                        return;
                    }
                
                    if (self.titulosPagarValidos(documentosForm, widgetParcelamentoDocGrid)){
        			    self.validaDataVencimento(widgetParcelamentoDocGrid)
        			    .then(function () {
                            self.validaPeriodoContabil(widgetTitulosAPagarGrid, documentosForm)
                            .then(function(){
                                var dataset = self.preparaDataSetTitulos(widgetParcelamentoDocGrid, documentosForm, widgetAnexoDocGrid);
                                dataset.push(rateioPadrao);
                                Pag00001_TitulosAPagar_Service.geraTituloAPagarDoc(dataset).then(function (nrlanbolpag) {
                                    nrlanbolpag = nrlanbolpag.dataset.geraTituloAPagarDoc.nrlanbolpag;
                                    ScreenService.showMessage('Registro salvo com sucesso.', 'checked');
                                    gridRateio.dataSource.data = [];
                                    ScreenService.closeSwipe();
                                    documentosForm.isVisible = false;
                                    self.forceActivate();
                                    widgetTitulosAPagarGrid.reload().then(function(){
                                        var data = widgetTitulosAPagarGrid.dataSource.data.filter(function(data){
                                        	return ((data.CDFILIAL+data.NRLANBOLPAG) == nrlanbolpag);
                                        });
                                        widgetTitulosAPagarGrid.currentRow = data[0]?data[0]:{};
                                    });
                                    self.forceActivate();
                                }, function (error) {
                                    if (contabilizacaoController.checkErrosContabilizacao(error))
                                        ScreenService.showMessage(error.data.error);
                                });
                            })
                            .catch(function (error) {
                                ScreenService.showMessage(error);
                            });
                        }).catch(function(erro){
                            if (erro){
                                ScreenService.showMessage(erro);
                            }
                        });
                    }
                }).catch(function(erro){
                    ScreenService.showMessage(erro.data.error);
                });
            }else{
                ScreenService.showMessage('Operação bloqueada. Preencha o(s) campo(s) de vencimento(s).');
            }
        }
    };
    
    self.preparaDataSetTitulos = function(widgetParcelamentoDocGrid, documentosForm, widgetAnexoDocGrid){
        var dataParc = widgetParcelamentoDocGrid.dataSource.data;
        dataParc.forEach(function (data){
            if(data.__leftActions != undefined)
                delete data.__leftActions;
            if(data.__rightActions != undefined)
                delete data.__rightActions;
        });
        documentosForm.currentRow.DTATUAVENPAG = widgetParcelamentoDocGrid.dataSource.data[0].DTVENBOLPAG;
        dataset = [
            documentosForm.currentRow,
            dataParc,
            widgetAnexoDocGrid.dataSource.data
        ];
        return dataset;
    };
    
    self.titulosPagarValidos = function(documentosForm, widgetParcelamentoDocGrid){
        var tituloValido = true;
        
        if((moment(documentosForm.currentRow.DTEMISSAO, 'DD/MM/YYYY') > 
            moment(documentosForm.currentRow.DTENTRSAID, 'DD/MM/YYYY')) && tituloValido){
            tituloValido = false;
            ScreenService.showMessage('Operação bloqueada. Data de emissão deve ser menor ou igual a data de entrada.');
        }
        
        if((moment(documentosForm.currentRow.DTEMISSAO, 'DD/MM/YYYY') > 
           moment(widgetParcelamentoDocGrid.dataSource.data[0].DTVENBOLPAG, 'DD/MM/YYYY')) && tituloValido){
            tituloValido = false;
            ScreenService.showMessage('Operação bloqueada. Data de emissão deve ser menor ou igual a data de vencimento.');
        }
        
        var vrtotparc = 0;
        widgetParcelamentoDocGrid.dataSource.data.forEach(function(data){
            vrtotparc += self.formataValor(data.VRFINALBPAG);
        });
        vrtotparc = self.formataValor(vrtotparc);
        if((self.formataValor(documentosForm.currentRow.VRNOTAFISC) != vrtotparc) && tituloValido){
            tituloValido = false;
            ScreenService.showMessage('Operação bloqueada. Valor do documento difere do somatório das parcelas.');
        }
        
        return tituloValido;
    };
    
    self.validaPeriodoContabil = function(widgetTitulosAPagarGrid, documentosForm){
        var deferred = ZHPromise.defer();
        var cdempresa = widgetTitulosAPagarGrid.appliedFilter.FILTER_ROW.CDEMPRESA;
        Pag00001_TitulosAPagar_Service.buscaContOpeCtbl(cdempresa)
        .then(function (response) {
            var contopectbl = response.dataset.contopectbl[0];
            if (!contopectbl){
                deferred.reject('Operação bloqueada. Não existe parametrização contábil para a empresa informada.');
            }else{
                var dtinicctbl  = contopectbl.DTINICCTBL;
                var dtfinacctbl = contopectbl.DTFINACCTBL;
                if ((moment(dtinicctbl, 'DD/MM/YYYY')) > (moment(documentosForm.currentRow.DTENTRSAID, 'DD/MM/YYYY')) ||
                    (moment(dtfinacctbl, 'DD/MM/YYYY')) < (moment(documentosForm.currentRow.DTENTRSAID, 'DD/MM/YYYY'))) {
                    deferred.reject('Operação bloqueada. Data do entrada fora do período financeiro.');
                }else{
                    deferred.resolve();
                }
            }
        })
        .catch(function (error) {
            deferred.reject(error.data.error);
        });
        return deferred.promise;
    };

    /**
     * Edita Documento Grid
     * @param widgetParcelamentoDocGrid
     */
    self.validaDataVencimento = function(widgetParcelamentoDocGrid){
        var deferred = ZHPromise.defer();
        var ultdata    = null;
        var datavalida = true;
    
        widgetParcelamentoDocGrid.dataSource.data.forEach(function(data){
            if(ultdata){
                if(ultdata > moment(data.DTVENBOLPAG, 'DD/MM/YYYY')){
                    datavalida = false;
                    deferred.reject('Operação bloqueada. Datas de vencimento das parcelas devem seguir uma sequencia crescente.');
                }else ultdata = moment(data.DTVENBOLPAG, 'DD/MM/YYYY');
            }else ultdata = moment(data.DTVENBOLPAG, 'DD/MM/YYYY');
        });
        
        if(datavalida)
            deferred.resolve(datavalida);
            
        return deferred.promise;
        
    };

    /**
     * Edita Documento Grid
     * @param args
     */
    self.editaDocumentoGrid = function(args){
        var widget = args.owner.widget;
        var widgetTitulosPagar   = templateManager.container.getWidget('TitulosAPagarGrid');

        if((widgetTitulosPagar.currentRow.IDSTATBPAG == 'B') || (widgetTitulosPagar.currentRow.IDSTATBPAG == 'P')){
            ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado o documento.');
            return;
        }
        if(widgetTitulosPagar.currentRow.IDBLOQNFFINCP == 'B') {
            ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
            return;
        }
        if(widgetTitulosPagar.currentRow.IDSITUCNABP != '00') {
            ScreenService.showMessage('Operação bloqueada. Título enviado via CNAB não pode ser alterado o documento.');
            return;
        }
        if(widgetTitulosPagar.currentRow.IDASSOCBOLPAG == 'S') {
            ScreenService.showMessage('Operação bloqueada. Título associado não pode ser alterado o documento.');
            return;
        }
        if(widgetTitulosPagar.currentRow.VRBOLPAG != widgetTitulosPagar.currentRow.VRFINALBPAG) {
            ScreenService.showMessage('Operação bloqueada. Título com ajuste não pode ser alterado o documento.');
            return;
        }
        if(widgetTitulosPagar.currentRow.NRPARCBOLPAG != '00') {
            ScreenService.showMessage('Operação bloqueada. Título com parcelamento não pode ser alterado o documento.');
            return;
        }

        General.edit(widget);

        widget.currentRow.backupIdstatus   = widget.currentRow.IDSTATUS;
        widget.currentRow.backupDtnotafisc = widget.currentRow.DTENTRSAID;
        
        self.changeStatusDocumentoForm();
        self.desabilitaCamposSistema();
    };
    

    /**
     * Habilita/Desabilita Valor de acordo com o Status do Documento
     */
    self.changeStatusDocumentoForm = function() {
        var widget = templateManager.container.getWidget('DocumentosGrid');
        
        if(widget.currentRow.IDSTATUS == 'V'){
            if(widget.currentRow.backupIdstatus != 'V')
                widget.currentRow.backupVRNOTAFISC  = widget.getField('VRNOTAFISC').value();
             widget.getField('VRNOTAFISC').readOnly = false;
        }else{ 
            if(widget.currentRow.backupVRNOTAFISC)
                widget.getField('VRNOTAFISC').setValue(widget.currentRow.backupVRNOTAFISC);
            widget.getField('VRNOTAFISC').readOnly = true;
        }
    };

    /**
     * Desabilita Campos de acordo com o Sistema
     */
    self.desabilitaCamposSistema = function(){
        var widget = templateManager.container.getWidget('DocumentosGrid');

        if(widget.currentRow.IDSISTEMA == 'PAG') {
            widget.getField('IDSTATUS').readOnly   = false;
            widget.getField('DTEMISSAO').readOnly  = false;
            widget.getField('DTENTRSAID').readOnly = false;
            if(widget.currentRow.IDSTATUS == 'V')
                 widget.getField('VRNOTAFISC').readOnly = false;
            else widget.getField('VRNOTAFISC').readOnly = true;
        }else{
            widget.getField('IDSTATUS').readOnly   = true;
            widget.getField('DTEMISSAO').readOnly  = true;
            widget.getField('DTENTRSAID').readOnly = true;
            widget.getField('VRNOTAFISC').readOnly = true;
        }
    };

    /** [Fim]Documento Form */

    /** [Inicio]Ajuste Conta Grid */

    /**
     * Deleta Ajuste Conta
     * @param args
     */
    self.deletaAjusteConta = function(args){
        var widgetAjusteConta    = args.owner.widget;
        var widgetTitulosPagar   = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetContaPagar     = templateManager.container.getWidget('ContaDocumentosGrid');

        if((widgetTitulosPagar.currentRow.IDSTATBPAG == 'B') || (widgetTitulosPagar.currentRow.IDSTATBPAG == 'P')){
            ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
            return;
        }
        if(widgetTitulosPagar.currentRow.IDSITUCNABP != '00') {
            ScreenService.showMessage('Operação bloqueada. Título enviado, via CNAB, não pode ser alterado.');
            return;
        }

        Pag00001_TitulosAPagar_Service.buscaContOpeCtbl(widgetTitulosPagar.currentRow.CDEMPRESA).then(function (response) {
            var contopectbl  = response.dataset.contopectbl[0];

            var dtinicctbl  = contopectbl.DTINICCTBL;
            var dtfinacctbl = contopectbl.DTFINACCTBL;

            if(dtinicctbl && dtfinacctbl) {
                if ((moment(dtinicctbl, 'DD/MM/YYYY')) > (moment(widgetAjusteConta.currentRow.DTAJUSTEPAG, 'DD/MM/YYYY')) ||
                    (moment(dtfinacctbl, 'DD/MM/YYYY')) < (moment(widgetAjusteConta.currentRow.DTAJUSTEPAG, 'DD/MM/YYYY'))) {
                    ScreenService.showMessage('Operação bloqueada. Data do ajuste fora do período financeiro.');
                    return;
                }
            }

            var currentRowAjusteConta    = widgetAjusteConta.currentRow;
            var currentRowTitulosPagar   = widgetTitulosPagar.currentRow;
            var currentRowContaPagar     = widgetContaPagar.currentRow;

            var currentRow = Object.assign(currentRowAjusteConta, currentRowTitulosPagar, currentRowContaPagar);

            ScreenService.confirmMessage('Deseja realmente excluir o Ajuste?', 'question', function() {
                Pag00001_TitulosAPagar_Service.deletaAjusteConta(currentRow).then(function () {
                    ScreenService.showMessage('Registro salvo com sucesso.');
                    ScreenService.goBack();
                    widgetAjusteConta.reload();
                    widgetTitulosPagar.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            });
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });

    };

    /** [Fim]Ajuste Conta Grid */

    /** [Inicio]Rateio Grid */

    /**
     * Valor Total Rateio Conta Pagar
     * @param args
     */
    var valorTotalRateioConta = function(args){
        var vrTotal = 0;
        for(var i in args.dataSource)
            vrTotal += parseFloat(args.dataSource[i].VRRATCCCTPAG);
        return vrTotal;
    };
    /*
    * @RateioDocGrid - caso tenha rateios cadastrados, os campos ficarao visiveis normalmente, podendo editar e caso nao tenha rateios, os campos ficarao desabilitados
    * e apenas o campo de padrao de rateio vai habilitar para que seja possivel colocar um rateio
    */
    this.habilitaCamposRateio = function(){
        var widgetRateio = templateManager.container.getWidget('RateioDocumentosGrid');
        
        //Campos do do detalhamento do grid Rateio
        var nmfiratctpag = widgetRateio.getField('NMFIRATCTPAG');
        var nmcentcust = widgetRateio.getField('NMCENTCUST');
        var cdcentcust = widgetRateio.getField('CDCENTCUST');
        var vrperateio = widgetRateio.getField('VRPERATEIO');
        var cdfiratctpag = widgetRateio.getField('CDFIRATCTPAG');
        var vrratccctpag = widgetRateio.getField('VRRATCCCTPAG');
        var nmrateio = widgetRateio.getField('NMRATEIO');
        
        //força habilitar os campos de inserir o rateio manual
        nmfiratctpag.readOnly = false;
        nmcentcust.readOnly = false;
        nmcentcust.reload();
        cdcentcust.readOnly = false;
        vrperateio.readOnly = false;
        cdfiratctpag.readOnly = false;
        vrratccctpag.readOnly = false;
        
        // Verifica se o campo padrão de rateio não esta preenchido, para desabilitar os demais campos, impedindo que o cliente gere erro quando ao inserir pelo campo rateio padrão e querer editar antes de salvar
        if(nmrateio.value() && nmrateio.value()!= ""){ 
            nmrateio.readOnly = false;
            nmcentcust.readOnly = true;
            nmfiratctpag.readOnly = true;
            cdcentcust.readOnly = true;
            vrperateio.readOnly = true;
            cdfiratctpag.readOnly = true;
            vrratccctpag.readOnly = true;
        }
        
    };
    /*
    * @RateioDocGrid - tornar o campo 'padrao de rateio' visivel na aba de rateio dentro de 'conta' caso nao tenha nenhum rateio lançado,
    * se ja tiver rateio lançado o campo não vai estar visivel
    */
    this.campoRateioVisivel = function(widget){
        var widgetRateio = templateManager.container.getWidget('RateioDocumentosGrid');
        var nmrateio = widget.getField('NMRATEIO');
        
        if(widgetRateio.dataSource.data.length === 0) {
            nmrateio.isVisible = true;
        }else{
            nmrateio.isVisible = false;
        }
    };
    /*
    * @RateioDocGrid - essa funcao vale para o campo 'padrao de rateio' que fica dentro da aba 'rateio', em 'conta', faz o ratemento de acordo com o padrão de rateio escolhido
    */
    self.rateioGrid = function(widget){
        var widgetContaDoc = templateManager.container.getWidget('ContaDocumentosGrid');
        var valor;
        var vrTotal = parseFloat(widgetContaDoc.getField("VRORIGPAG").value());
        var cdRateio = widget.getField("CDRATEIO").value();
        
        this.habilitaCamposRateio(); //Força os campos do rateio ficarem habilitados quando edita, exclui ou insere
        
        var filter = [{
            "name": "CDRATEIO",
            "operator": "=",
            "value": cdRateio
        }];
        
        widget.dataSource.data = []; //opção para remover o primeiro indice do grid de rateio antes de adicionar, evitando que ele adiciona linha a mais
        
            General.callRestEngine('fin#/crud/itemrateio_centcust_titulos','FilterData', filter).then(function(result){
            result.dataset.itemrateio_centcust_titulos.forEach(function(porcentagem){
                  valor = ((porcentagem.VRRATEIO / 100) * vrTotal);
                  //Nova forma de montar os dados no rateio da conta, foi necessário devido a erro ao excluir um rateio padrão adicionado.
                  widget.newRow();
                  widget.getField('NMFIRATCTPAG').setValue(porcentagem.NMFILIAL);
                  widget.getField('CDFIRATCTPAG').setValue(porcentagem.CDFILIAL);
                  widget.getField('NMCENTCUST').setValue(porcentagem.NMCENTCUST);
                  widget.getField('CDCENTCUST').setValue(porcentagem.CDCENTCUST);
                  widget.getField('VRPERATEIO').setValue(porcentagem.VRRATEIO);
                  widget.getField('VRRATCCCTPAG').setValue(valor);
            });
        });
    };
    /**
     * Novo Rateio Conta a Pagar
     * @param args
     */
    self.novoRateioConta = function(args){
        var widget  = args.owner.widget;
        this.campoRateioVisivel(widget);
        var widgetContaPagar = templateManager.container.getWidget('ContaDocumentosGrid');
        templateManager.container.getWidget('RateioDocumentosGrid').getField("NMRATEIO").reload();
        var widgetTitulos   = templateManager.container.getWidget('TitulosAPagarGrid');

        if((widgetTitulos.currentRow.IDSTATBPAG == 'B') || (widgetTitulos.currentRow.IDSTATBPAG == 'P')){
            ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
            return;
        }
        if(widgetTitulos.currentRow.IDSITUCNABP != '00') {
            ScreenService.showMessage('Operação bloqueada. Título enviado, via CNAB, não pode ser alterado.');
            return;
        }
        if(widgetTitulos.currentRow.IDSTATUS == 'V') {
            ScreenService.showMessage('Operação bloqueada. Título previsto não pode ser alterado.');
            return;
        }
        if(widgetTitulos.currentRow.IDBLOQNFFINCP == 'B') {
            ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
            return;
        }
        
        Pag00001_TitulosAPagar_Service.buscaContOpeCtbl(widgetTitulos.currentRow.CDEMPRESA).then(function (response) {
            var contopectbl  = response.dataset.contopectbl[0];

            var dtinicctbl  = contopectbl.DTINICCTBL;
            var dtfinacctbl = contopectbl.DTFINACCTBL;

            if(dtinicctbl && dtfinacctbl) {
                if ((moment(dtinicctbl, 'DD/MM/YYYY')) > (moment(widgetContaPagar.currentRow.DTENTRSAID, 'DD/MM/YYYY')) ||
                    (moment(dtfinacctbl, 'DD/MM/YYYY')) < (moment(widgetContaPagar.currentRow.DTENTRSAID, 'DD/MM/YYYY'))) {
                    ScreenService.showMessage('Operação bloqueada. Data do entrada fora do período financeiro.');
                    return;
                }
            }

            var vrTotalConta  = parseFloat(widgetContaPagar.currentRow.VRATUAPAG);
            var vrTotalRateio = parseFloat(valorTotalRateioConta(args));
            var vrPerateio    = ((vrTotalRateio * 100) / vrTotalConta);

            widget.newRow();

            vrTotalRateio = vrTotalConta - vrTotalRateio;
            widget.currentRow.VRRATCCCTPAG = (vrTotalRateio >= 0)?vrTotalRateio:0;
            widget.currentRow.VRPERATEIO   = ((vrPerateio >= 0)&&(vrPerateio <= 100))?((vrTotalRateio * 100) / vrTotalConta):0;
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    /**
     * Edita Rateio Títulos a Pagar
     * @param widget
     */
    self.editaRateio = function(widget){
        var widgetTitulos    = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetContaPagar = templateManager.container.getWidget('ContaDocumentosGrid');
        //@RateioDocGrid - deixar o campo 'padrao de rateio' apenas invisivel no detalhamento na aba de rateio quando vai editar um rateio
        templateManager.container.getWidget('RateioDocumentosGrid').getField('NMRATEIO').isVisible = false;
        this.habilitaCamposRateio();//Força os campos do rateio ficarem habilitados quando edita, exclui ou insere

        if((widgetTitulos.currentRow.IDSTATBPAG == 'B') || (widgetTitulos.currentRow.IDSTATBPAG == 'P')) {
            ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
            return;
        }
        if(widgetTitulos.currentRow.IDSITUCNABP != '00') {
            ScreenService.showMessage('Operação bloqueada. Título enviado, via CNAB, não pode ser alterado.');
            return;
        }
        if(widgetTitulos.currentRow.IDSTATUS == 'V') {
            ScreenService.showMessage('Operação bloqueada. Título previsto não pode ser alterado.');
            return;
        }
        if(widgetTitulos.currentRow.IDBLOQNFFINCP == 'B') {
            ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
            return;
        }

        Pag00001_TitulosAPagar_Service.buscaContOpeCtbl(widgetTitulos.currentRow.CDEMPRESA).then(function (response) {
            var contopectbl  = response.dataset.contopectbl[0];

            var dtinicctbl  = contopectbl.DTINICCTBL;
            var dtfinacctbl = contopectbl.DTFINACCTBL;

            if(dtinicctbl && dtfinacctbl) {
                if ((moment(dtinicctbl, 'DD/MM/YYYY')) > (moment(widgetContaPagar.currentRow.DTENTRSAID, 'DD/MM/YYYY')) ||
                    (moment(dtfinacctbl, 'DD/MM/YYYY')) < (moment(widgetContaPagar.currentRow.DTENTRSAID, 'DD/MM/YYYY'))) {
                    ScreenService.showMessage('Operação bloqueada. Data do entrada fora do período financeiro.');
                    return;
                }
            }

            widget.currentRow.__is_new = false;
            General.edit(widget);
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });


    };

    /**
     * Cálcula Percentual para Valor Rateio Conta a Pagar
     * @param row
     */
    self.calcPercValorRateio = function(row){
        var widgetConta = templateManager.container.getWidget('ContaDocumentosGrid');
        var vrperateio  = parseFloat(row.VRPERATEIO.replace(',','.'));
        var vratuapag   = parseFloat(widgetConta.currentRow.VRATUAPAG);

        row.VRRATCCCTPAG   = (vratuapag * vrperateio) / 100;
    };

    /**
     * Cálcula Valor para Percentual Rateio Conta a Pagar
     * @param row
     */
    self.calcValorPercRateio = function(row){
        var widgetConta   = templateManager.container.getWidget('ContaDocumentosGrid');
        var vrratccctpag  = parseFloat(row.VRRATCCCTPAG.replace(',','.'));
        var vratuapag     = parseFloat(widgetConta.currentRow.VRATUAPAG);

        row.VRPERATEIO   = (vrratccctpag * 100) / vratuapag;
    };

    /**
     * Deleta Rateio Conta a Pagar
     * @param args
     */
    self.deletaRateioConta = function(args){
        var widget = args.owner.widget;
        var widgetTitulos    = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetContaPagar = templateManager.container.getWidget('ContaDocumentosGrid');

        if((widgetTitulos.currentRow.IDSTATBPAG == 'B') || (widgetTitulos.currentRow.IDSTATBPAG == 'P')){
            ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
            return;
        }
        if(widgetTitulos.currentRow.IDSITUCNABP != '00') {
            ScreenService.showMessage('Operação bloqueada. Título enviado, via CNAB, não pode ser alterado.');
            return;
        }
        if(widgetTitulos.currentRow.IDSTATUS == 'V') {
            ScreenService.showMessage('Operação bloqueada. Título previsto não pode ser alterado.');
            return;
        }
        if(widgetTitulos.currentRow.IDBLOQNFFINCP == 'B') {
            ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
            return;
        }

        Pag00001_TitulosAPagar_Service.buscaContOpeCtbl(widgetTitulos.currentRow.CDEMPRESA).then(function (response) {
            var contopectbl  = response.dataset.contopectbl[0];

            var dtinicctbl  = contopectbl.DTINICCTBL;
            var dtfinacctbl = contopectbl.DTFINACCTBL;

            if(dtinicctbl && dtfinacctbl) {
                if ((moment(dtinicctbl, 'DD/MM/YYYY')) > (moment(widgetContaPagar.currentRow.DTENTRSAID, 'DD/MM/YYYY')) ||
                    (moment(dtfinacctbl, 'DD/MM/YYYY')) < (moment(widgetContaPagar.currentRow.DTENTRSAID, 'DD/MM/YYYY'))) {
                    ScreenService.showMessage('Operação bloqueada. Data do entrada fora do período financeiro.');
                    return;
                }
            }

            ScreenService.confirmMessage('Deseja realmente excluir?', 'question', function () {
                if(!widget.currentRow.__createdLocal) {
                    Pag00001_TitulosAPagar_Service.deletaRateioConta(widget.currentRow).then(function () {
                        ScreenService.showMessage('Registro excluído com sucesso.', 'checked');
                        ScreenService.goBack();

                        // Remover Linha
                        widget.dataSource.data.splice(widget.currentRow.__index, 1);

                        if((widget.dataSource.data.length == 0) || (widget.editing == false))
                            widget.reload();
                    }, function (error) {
                        ScreenService.showMessage(error.data.error);
                    });
                }else{
                    ScreenService.showMessage('Registro excluído com sucesso.', 'checked');
                    widget.currentRow.__is_new = true;
                    General.backOrCancel(args);

                    if(widget.dataSource.data.length == 0)
                        widget.reload();
                }
            });
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });



    };

    /**
     * Salva Rateio Conta a Pagar
     * @param args
     */
    self.salvaRateioConta = function(args){
        var widget = args.owner.widget;
        if(widget.isValid()) {
            widget.view();
            ScreenService.goBack();
            self.habilitaFinalizacaoRateioConta(widget);
        }
    };

    /**
     * Finaliza Rateio Conta a Pagar
     * @param args
     */
    self.finalizaRateioConta = function(args) {
        var widgetRateioConta = args.owner.widget;
        var widgetContaPagar  = templateManager.container.getWidget('ContaDocumentosGrid');

        var vrTotalRateio     = 0;
        var vrTotalConta      = parseFloat(widgetContaPagar.currentRow.VRATUAPAG);

        // Percorre Dados de Rateio
        for (var i = 0; i < widgetRateioConta.dataSource.data.length; i++){
            // Percorre Dados de Rateio
            for (var j = 0; j < widgetRateioConta.dataSource.data.length; j++) {
                // Verifica Existência de Dados Duplicados
                if ((widgetRateioConta.dataSource.data[i].CDCENTCUST   == widgetRateioConta.dataSource.data[j].CDCENTCUST) &&
                    (widgetRateioConta.dataSource.data[i].CDFIRATCTPAG == widgetRateioConta.dataSource.data[j].CDFIRATCTPAG) &&
                    (i != j)
                ){
                    ScreenService.showMessage('Operação bloqueada. Existem informações duplicadas de Centro de Custo.');
                    return;
                }
            }

            // Soma Valor Total Rateio
            vrTotalRateio += parseFloat(widgetRateioConta.dataSource.data[i].VRRATCCCTPAG);
        }

        // Verifica Valor Total dos Rateios
        if (vrTotalRateio.toFixed(2) != vrTotalConta.toFixed(2)) {
            ScreenService.showMessage("Total do(s) Rateio(s) difere do valor total do Título a Pagar em "+((vrTotalRateio-vrTotalConta).formatFloat())+".");
            return;
        }

        // Declaração de Variáveis
        var nrorg        = widgetContaPagar.currentRow.NRORG;
        var cdfilial     = widgetContaPagar.currentRow.CDFILIAL;
        var nrlanctonf   = widgetContaPagar.currentRow.NRLANCTONF;
        var nrseqvenpag  = widgetContaPagar.currentRow.NRSEQVENPAG;
        var nrparcelapag = widgetContaPagar.currentRow.NRPARCELAPAG;

        // Array Data Source
        var dataSet = [{
            nrorg       : nrorg,
            cdfilial    : cdfilial,
            nrlanctonf  : nrlanctonf,
            nrseqvenpag : nrseqvenpag,
            nrparcelapag: nrparcelapag
        }, widgetRateioConta.dataSource.data];

        // Finaliza Rateio Conta
        Pag00001_TitulosAPagar_Service.finalizaRateioConta(dataSet).then(function () {
            ScreenService.showMessage('Registro(s) salvo(s) com sucesso.', 'checked');
            widgetRateioConta.reload();
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    /**
     * Habilita Finalização Rateio Conta Pagar
     * @param widget
     */
    self.habilitaFinalizacaoRateioConta = function(widget){
        widget.getAction('finish').isVisible = true;
        widget.getAction('cancel').isVisible = true;
        widget.getAction('back_list').isVisible = false;
        widget.getParent().editing = true;

        var widgets = [
            templateManager.container.getWidget('ContaDocumentosGrid'),
            templateManager.container.getWidget('AjusteDocumentosGrid')
        ];

        General.changeWidgetAcessibility(widgets, false);
        templateManager.updateTemplate();
    };

    /**
     * Desabilita Finalização Rateio Conta Pagar
     * @param args
     */
    self.desabilitaFinalizacaoRateioConta = function(args){
        args.owner.getAction('finish').isVisible = false;
        args.owner.getAction('cancel').isVisible = false;
        args.owner.getAction('back_list').isVisible = true;
        args.owner.getParent().editing = false;

        var widgets = [
            templateManager.container.getWidget('ContaDocumentosGrid'),
            templateManager.container.getWidget('AjusteDocumentosGrid')
        ];

        General.changeWidgetAcessibility(widgets, true);
        templateManager.updateTemplate();
    };

    /** [Fim]Rateio Grid/Form */
    
    /** [Inicio]Anexo Grid/Form */
    
    self.importAnexoFile = function(args){
        //var anexoWidget = templateManager.container.getWidget('AnexoDocGrid');
        var importWidget = templateManager.container.getWidget('AnexoDocGridImportFile');
        importWidget.newRow();
        return ScreenService.openPopup(importWidget);
    };
    
    self.saveAnexoDocGrif = function(widget){
        widget.currentRow.NRORG = getLocalVar('NRORG');
        widget.currentRow.DTANEXOLANCBOL = moment().format('DD/MM/YYYY');
        
        Pag00001_TitulosAPagar_Service.saveAnexoDocGrif(widget.currentRow).then(function (sucess){
            ScreenService.closePopup();
            widget.getParent().reload();
        }, function(error){
            ScreenService.showMessage(error.dataset.error);
        });
    };
    
    self.deleteAnexoDocGrif = function(widget){
        Pag00001_TitulosAPagar_Service.deleteAnexoDocGrif(widget.getCheckedRows()).then(function (sucess){
            widget.reload();
        }, function(error){
            ScreenService.showMessage(error.dataset.error);
        });
    };
    
    self.verificaAnexos = function(widget){
        General.callRestEngine('fin_contaReceber#/deleteAnexoIncompletos', 'FilterData', []).then(function () {
            templateManager.container.getWidget('AnexoDocGrid').reload();
        }, function(error){
            ScreenService.showMessage(error.dataset.error);
        });
    };
    
    self.adicionaAnexoGrid = function(widget){
        var widgetTitulosAPagarGrid = templateManager.container.getWidget('TitulosAPagarGrid');
        widget.newRow();
        widget.currentRow.NRLANBOLPAG = widgetTitulosAPagarGrid.currentRow.NRLANBOLPAG;
        widget.currentRow.CDFILIAL = widgetTitulosAPagarGrid.currentRow.CDFILIAL;
        widget.currentRow.CDTELA = 'PAG00001';
        widget.currentRow.DTANEXOLANCBOL = moment().format('DD/MM/YYYY');
    };
    
    self.saveAnexoGrid = function(widget){
        widget.currentRow.NRORG = getLocalVar('NRORG');
        
        var row = Util.clone(widget.currentRow, ignoredKeys);
        
        Pag00001_TitulosAPagar_Service.salvaAnexoGrid(row).then(function (sucess){
            ScreenService.goBack();
            widget.reload();
        }, function(error){
            ScreenService.showMessage(error.dataset.error);
        });
    };
    
    self.deleteAnexoGrid = function(widget){
        ScreenService.confirmMessage('Deseja realmente excluir o(s) anexo(s)?', 'question', function() {
            
            var dataSet = [];
            if(widget.hasCheckedRows()){
                dataSet = widget.getCheckedRows();
                
                dataSet.forEach(function(data){
                	delete data.__rightActions;
                });
                
                Pag00001_TitulosAPagar_Service.deleteAnexoGrid(dataSet).then(
                    function (sucess){
                        widget.reload();
                    }, function(error){
                        ScreenService.showMessage(error.dataset.error);
                    }
                );
            } else{
                if (!widget.hasCheckedRows() && widget.currentRow.NRANEXOLANCBOL){
                    dataSet = [Util.clone(widget.currentRow, ignoredKeys)];
                    Pag00001_TitulosAPagar_Service.deleteAnexoGrid(dataSet).then(
                        function (sucess){
                            ScreenService.goBack();
                            ScreenService.showMessage('Registro excluído com sucesso.');
                            widget.reload();
                        }, function(error){
                            ScreenService.showMessage(error.dataset.error);
                        }
                    );
                }
            }
        });
    };
    
    self.downloadAnexoGrid = function(widget){
        var downloadRoute;
        var fileName;
        var serviceUrl;
        Pag00001_TitulosAPagar_Service.getFileServerUrl().then(
        function(sucess) {
            serviceUrl = sucess.dataset.sucess.fileName;
            if(widget.hasCheckedRows()){
                var rows = widget.getCheckedRows();
                rows.forEach(function(row){
                    downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fin';})[0].baseUrl + "/downloadArquivoAnexo?requestType=Row&row[DSARQUIVO]=";
                    fileName = row.NMPATHANEXO;
                    downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fin';})[0].baseUrl + "/downloadArquivoAnexoFileServer?requestType=Row&row[NMARQUIVO]=";
                    var rowDownload = {
                        'NMANEXOLANCBOL':row.NMANEXOLANCBOL, 
                        'PATH': serviceUrl+fileName
                    };
                    window.open(downloadRoute+rowDownload.NMANEXOLANCBOL+'&row[PATH]='+rowDownload.PATH);
                });
            } 
            else {
                var row = widget.currentRow;
                downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fin';})[0].baseUrl + "/downloadArquivoAnexo?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMPATHANEXO;
                downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fin';})[0].baseUrl + "/downloadArquivoAnexoFileServer?requestType=Row&row[NMARQUIVO]=";
                var rowDownload = {
                    'NMANEXOLANCBOL':row.NMANEXOLANCBOL, 
                    'PATH': serviceUrl+fileName
                };
                window.open(downloadRoute+rowDownload.NMANEXOLANCBOL+'&row[PATH]='+rowDownload.PATH);
            }
        });
    };
    
    /** [Fim]Anexo Grid */
    
    /**
     * Desabilita Widget Baixa
     */
    self.desabilitaWidgetSwipe = function(){
        ScreenService.closeSwipe();
        templateManager.container.getWidget('TitulosAPagarGrid').activate();
        templateManager.container.getWidget('NewBaixaTabbed').isVisible = false;
    };

    /**
     * Gera Codigo de Barras Itau
     */
    self.geraCodigoBarrasItau = function(representacaonumerica, codigodebarra){

        codigodebarra  = representacaonumerica.substr( 0,  4); // Banco(3) + Código da Moeda(1)
        codigodebarra += representacaonumerica.substr(32,  1); // Dígito Verificador do código de barras(1)
        codigodebarra += representacaonumerica.substr(-14   ); // Fator de Vencimento + Valor(14)
        codigodebarra += representacaonumerica.substr( 4,  3); // Código da Carteira
        codigodebarra += representacaonumerica.substr( 7,  2); // Nosso Numero
        codigodebarra += representacaonumerica.substr(10,  6); // Nosso Numero
        codigodebarra += representacaonumerica.substr(16,  1); // DAC do Nosso Numero
        codigodebarra += representacaonumerica.substr(17,  3); // Código da Agencia
        codigodebarra += representacaonumerica.substr(21,  1); // Código da Agencia
        codigodebarra += representacaonumerica.substr(22,  6); // Código da Conta Corrente
        codigodebarra += representacaonumerica.substr(28,  3); // Fixo Zero

        return codigodebarra;
    };

    /**
     * Gera Codigo de Barras HSBC
     */
    self.geraCodigoBarrasHsbc = function(representacaonumerica, codigodebarra){

        var carteira = representacaonumerica.substr( 30,  1);

        if (carteira == '1'){
            codigodebarra  = representacaonumerica.substr( 0,  4); // Banco(3) + Código da Moeda(1)
            codigodebarra += representacaonumerica.substr(32,  1); // Dígito Verificador do código de barras(1)
            codigodebarra += representacaonumerica.substr(-14   ); // Fator de Vencimento + Valor(14)
            codigodebarra += representacaonumerica.substr( 4,  5); // Nosso Numero + DAC do Nosso Numero
            codigodebarra += representacaonumerica.substr(10,  6); // Nosso Numero + DAC do Nosso Numero
            codigodebarra += representacaonumerica.substr(16,  4); // Código da Agencia
            codigodebarra += representacaonumerica.substr(21,  7); // Código da Conta Corrente
            codigodebarra += representacaonumerica.substr(28,  2); // Carteira
            codigodebarra += '1';                                  // Cod. do Aplicativo
        }else{
            codigodebarra  = representacaonumerica.substr( 0,  4); // Banco(3) + Código da Moeda(1)
            codigodebarra += representacaonumerica.substr(32,  1); // Dígito Verificador do código de barras(1)
            codigodebarra += representacaonumerica.substr(-14   ); // Fator de Vencimento + Valor(14)
            codigodebarra += representacaonumerica.substr( 4,  5); // Código do cedente
            codigodebarra += representacaonumerica.substr(10,  2); // Código do cedente
            codigodebarra += representacaonumerica.substr(12,  8); // Número Bancário ou Código do Documento (Nosso Número,sem os dígitos verificadores e o tipo identificador).
            codigodebarra += representacaonumerica.substr(21,  5); // Número Bancário ou Código do Documento (Nosso Número,sem os dígitos verificadores e o tipo identificador).
            codigodebarra += representacaonumerica.substr(26,  4); // Data de Vencimento no Formato Juliano.
            codigodebarra += '2';                                  // Código do Produto CNR, deve preencher o número 2
        }

        return codigodebarra;
    };

    /**
     * Gera Codigo de Barras Safra
     */
    self.geraCodigoBarrasSafra = function(representacaonumerica, codigodebarra){

        codigodebarra  = representacaonumerica.substr( 0,  4); // Banco(3) + Código da Moeda(1)
        codigodebarra += representacaonumerica.substr(32,  1); // Dígito Verificador do código de barras(1)
        codigodebarra += representacaonumerica.substr(-14   ); // Fator de Vencimento + Valor(14)
        codigodebarra += representacaonumerica.substr( 4,  1); // SISTEMA
        codigodebarra += representacaonumerica.substr( 5,  4); // Código da Agencia
        codigodebarra += representacaonumerica.substr(10, 10); // Código da Conta Corrente
        codigodebarra += representacaonumerica.substr(21, 10); // Nosso Numero + DAC do Nosso Numero

        return codigodebarra;
    };

    /**
     * Gera Codigo de Barras Unibanco
     */
    self.geraCodigoBarrasUnibanco = function(representacaonumerica, codigodebarra){

        codigodebarra  = representacaonumerica.substr( 0,  4); // Banco(3) + Código da Moeda(1)
        codigodebarra += representacaonumerica.substr(32,  1); // Dígito Verificador do código de barras(1)
        codigodebarra += representacaonumerica.substr(-14   ); // Fator de Vencimento + Valor(14)
        codigodebarra += representacaonumerica.substr( 4,  2); // Código da Transação
        codigodebarra += representacaonumerica.substr( 6,  3); // Data de Vencimento
        codigodebarra += representacaonumerica.substr(10,  3); // Data de Vencimento
        codigodebarra += representacaonumerica.substr(13,  5); // Código da Agencia
        codigodebarra += representacaonumerica.substr(18,  2); // Nosso Numero + DAC do Nosso Numero
        codigodebarra += representacaonumerica.substr(21, 10); // Nosso Numero + DAC do Nosso Numero

        return codigodebarra;
    };

    /**
     * Gera Codigo de Barras Caixa
     */
    self.geraCodigoBarrasCaixa = function(representacaonumerica, codigodebarra){

        codigodebarra  = representacaonumerica.substr( 0,  4); // Banco(3) + Código da Moeda(1)
        codigodebarra += representacaonumerica.substr(32,  1); // Dígito Verificador do código de barras(1)
        codigodebarra += representacaonumerica.substr(-14   ); // Fator de Vencimento + Valor(14)
        codigodebarra += representacaonumerica.substr( 4,  5);
        codigodebarra += representacaonumerica.substr(10, 10);
        codigodebarra += representacaonumerica.substr(21, 10);

        return codigodebarra;
    };

    /**
     * Gera Codigo de Barras Banrisul
     */
    self.geraCodigoBarrasBanrisul = function(representacaonumerica, codigodebarra){

        codigodebarra  = representacaonumerica.substr( 0,  4); // Banco(3) + Código da Moeda(1)
        codigodebarra += representacaonumerica.substr(32,  1); // Dígito Verificador do código de barras(1)
        codigodebarra += representacaonumerica.substr(-14   ); // Fator de Vencimento + Valor(14)
        codigodebarra += representacaonumerica.substr( 4,  2); // SISTEMA
        codigodebarra += representacaonumerica.substr( 6,  3); // Código da Agencia
        codigodebarra += representacaonumerica.substr(10,  1); // Código da Agencia
        codigodebarra += representacaonumerica.substr(11,  7); // Código da Conta Corrente
        codigodebarra += representacaonumerica.substr(18,  2); // Nosso Numero + Constante 40 + NC
        codigodebarra += representacaonumerica.substr(21, 10); // Nosso Numero + Constante 40 + NC

        return codigodebarra;
    };

    /**
     * Gera Codigo de Barras Sicoob
     */
    self.geraCodigoBarrasSicoob = function(representacaonumerica, codigodebarra){

        codigodebarra  = representacaonumerica.substr( 0,  4); // Banco(3) + Código da Moeda(1)
        codigodebarra += representacaonumerica.substr(32,  1); // Dígito Verificador do código de barras(1)
        codigodebarra += representacaonumerica.substr(-14   ); // Fator de Vencimento + Valor(14)
        codigodebarra += representacaonumerica.substr( 4,  1); // Código da carteira
        codigodebarra += representacaonumerica.substr( 5,  4); // Código da agência
        codigodebarra += representacaonumerica.substr(10, 10); // 12ª a 20ª posição do Campo Livre
        codigodebarra += representacaonumerica.substr(21, 10); // 22ª a 31ª posição do Campo Livre

        return codigodebarra;
    };

    /**
     * Gera Codigo de Barras Padrao
     */
    self.geraCodigoBarrasPadrao = function(representacaonumerica, codigodebarra){

        codigodebarra  = representacaonumerica.substr( 0,  4); // Banco(3) + Código da Moeda(1)
        codigodebarra += representacaonumerica.substr(32,  1); // Dígito Verificador do código de barras(1)
        codigodebarra += representacaonumerica.substr(-14   ); // Valor(14)
        codigodebarra += representacaonumerica.substr( 4,  5); // Campo Livre 1
        codigodebarra += representacaonumerica.substr(10, 10); // Campo Livre 2
        codigodebarra += representacaonumerica.substr(21, 10); // Campo Livre 3

        return codigodebarra;
    };

    /**
     * Gera Codigo de Barras 48 Dígitos
     */
    self.geraCodigoBarras48Digitos = function(representacaonumerica, codigodebarra){

        codigodebarra  = representacaonumerica.substr( 0, 11);
        codigodebarra += representacaonumerica.substr(12, 11);
        codigodebarra += representacaonumerica.substr(24, 11);
        codigodebarra += representacaonumerica.substr(36, 11);

        return codigodebarra;
    };

    /**
     * Valida Representação Numérica
     */
    self.validaRepresentacaoNumerica = function(widget_name, codbar_name, line_name, vrbol_name, vrliq_name){
        var deferred = ZHPromise.defer();
        
        var widget       = templateManager.container.getWidget(widget_name);
        var cdbarrapag   = widget.getField(codbar_name);
        
        var valorrepnum = '0000000000';
        var dslinhbarpag = widget.getField(line_name).value();
        var vrbolpag     = widget.getField(vrbol_name).value();
        var vrfinalbpag  = widget.getField(vrliq_name).value();

        if(dslinhbarpag) {
            dslinhbarpag = dslinhbarpag.replace(/\D/g, '');

            //Verifica se a linha digitável possui 48 dígitos, caso sim valida a linha para as contas de consumo
            if (dslinhbarpag.length > 48) {
                ScreenService.showMessage('Representação numérica inválida.');
                cdbarrapag.setValue('');
                deferred.reject();
                return deferred;
            }else if (dslinhbarpag.length < 48) {
                // Verifica o 1º campo da Linha Digitável
                if (self.Mod10(dslinhbarpag.substr(0, 9)) != dslinhbarpag.substr(9, 1)) {
                    ScreenService.showMessage('Primeiro campo inválido. Dígito verificador inconsistente.');
                    cdbarrapag.setValue('');
                    deferred.reject();
                    return deferred;
                }

                // Verifica o 2º campo da Linha Digitável
                if (self.Mod10(dslinhbarpag.substr(10, 10)) != dslinhbarpag.substr(20, 1)) {
                    ScreenService.showMessage('Segundo campo inválido. Dígito verificador inconsistente.');
                    cdbarrapag.setValue('');
                    deferred.reject();
                    return deferred;
                }

                // Verifica o 3º campo da Linha Digitável
                if (self.Mod10(dslinhbarpag.substr(21, 10)) != dslinhbarpag.substr(31, 1)) {
                    ScreenService.showMessage('Terceiro campo inválido. Dígito verificador inconsistente.');
                    cdbarrapag.setValue('');
                    deferred.reject();
                    return deferred;
                }
                // Representação Numérica Inválida
                if (!(dslinhbarpag.substr(0, 9).length) || !(dslinhbarpag.substr(10, 10).length) || !(dslinhbarpag.substr(21, 10).length)) {
                    ScreenService.showMessage('Representação numérica inválida.');
                    cdbarrapag.setValue('');
                    deferred.reject();
                    return deferred;
                }

                // Valor do Título Representação Numérica
                valorrepnum = dslinhbarpag.substr(-10);
            }else{
                // Valor do Título Representação Numérica
                valorrepnum = dslinhbarpag.substr(4,7) + dslinhbarpag.substr(12,4);
            }

            // Valida Valor Representação Numérica
            self.validaValorRepNumerica(valorrepnum, vrfinalbpag, vrbolpag).then(function () {
                // Gera Código de Barras Título
                self.geraCodigoBarras(widget, dslinhbarpag, cdbarrapag);
                deferred.resolve();
                return deferred;
            }).catch(function(){
                deferred.reject();
                return deferred;
            });

        }else cdbarrapag.setValue('');

        deferred.resolve();
        return deferred;
    };

    /**
     * Valida Valor Representação Numérica Título a Pagar
     * @param valorrepnum
     * @param vrfinalbpag
     * @param vrbolpag
     * @returns {*|Deferred}
     */
    self.validaValorRepNumerica = function(valorrepnum, vrfinalbpag, vrbolpag){
        var deferred = ZHPromise.defer();

        if (valorrepnum != '0000000000') {
            // Valor da Representação Numérica
            valorrepnum = ((parseInt(valorrepnum)) / 100).toFixed(2);
            vrfinalbpag = parseFloat(vrfinalbpag).toFixed(2);
            vrbolpag    = parseFloat(vrbolpag).toFixed(2);

            // Verifica se o Valor da Representação Numérica está diferente do Valor do Título no Sitema
            if ((valorrepnum != vrfinalbpag) && (valorrepnum != vrbolpag)) {
                ScreenService.showMessage('Operação bloqueada. O valor informado no código de barras (' + valorrepnum + ') para o título é diferente do valor final (' + vrfinalbpag + ') e valor original (' + vrbolpag + ') do título no sistema.');
                deferred.reject();
            } else deferred.resolve();
        }else{
            deferred.resolve();
        }

        return deferred;
    };

    /**
     * Modulo 10
     * @param codigo
     * @returns {string}
     * @constructor
     */
    self.Mod10 = function(codigo){

        var result = '';

        if (codigo.length > 0){

            var base   = 2;
            var soma   = 0;
            var carac  = 0;
            var aux    = 0;

            for (var i = (codigo.length - 1); i >= 0; i--){

                carac = parseInt(codigo[i]);

                if ((carac * base) > 9){

                    // Se o Nº tiver dois dígitos ou mais, eles são somados separadamente.
                    aux = carac * base;

                    for (var j = 0; j < aux.toString().length; j++)
                        soma = soma + parseInt(aux.toString()[j]);

                }else soma += (carac * base);

                base = base - 1;

                if (base < 1)
                    base = 2;
            }

            // Calcula um multiplo de 10 maior que a soma
            var mult = 10;

            while (mult < soma)
                mult = mult + 10;

            result = mult - soma;

            if (result == 10)
                result = '0';
        }

        return result;
    };

    /**
     * Modulo Concessionario
     * @param codigo
     * @returns {string}
     * @constructor
     */
    self.Mod10_Concessionaria = function(codigo){

        var result = '';

        if (codigo.length > 0){

            var base   = 2;
            var soma   = 0;
            var carac  = 0;

            for (var i = (codigo.length - 1); i >= 0; i--){

                carac = codigo[i];

                if ((carac * base) > 9)
                    soma  = soma + ((carac * base) - 10) + 1;
                else soma += (carac * base);

                if (base == 2)
                    base -= 1;
                else base += 1;
            }

            var resto = soma % 10;

            result = 10 - resto;

            if ((resto) == 0)
                result = '0';
        }

        return result;
    };

    /**
     * Modulo 11 B9
     * @param codigo
     * @param banco
     * @constructor
     * @return {string}
     */
    self.Mod11_B9 = function(codigo, banco){

        var result = '';

        if (codigo.length > 0) {
            var soma = 0;
            var base = 2;
            var carac = 0;

            var barraaux = codigo;

            if (codigo.length >= 44)
            // Retira o dígito verificador do código de barras
                barraaux = codigodebarra.substr(0, 4) + codigodebarra.substr(5, (codigo.length - 5));

            for (var i = (barraaux.length - 1); i >= 0; i--) {

                carac = codigo[i];

                soma += (carac * base);

                // Incrementa a base até chegar a 9
                base += 1;

                if (base > 9)
                    base = 2;
            }

            var dv = 11 - (soma % 11);
            var resto = (soma % 11);

            // BANESTES E NOSSA CAIXA
            if ((banco == '021') || (banco == '151')) { // Banestes e Nossa Caixa
                if ((resto == 0) || (resto == 1) || (resto > 9))
                    result = '1';
                else result = dv;
            } else {
                // MERCANTIL
                if (banco == '389') { // Mercantil
                    if ((resto == 0) || (resto == 1)) {
                        if (codigo.length >= 44)
                            result = '1'; // Dac do Código de barras
                        else result = '0'; // Dac do Nosso numero
                    } else result = dv;
                } else {
                    if (banco == '422') {
                        if (resto == 0)
                            result = '1';
                        else if (resto == 1)
                            result = '0';
                        else result = dv;
                    }
                    // SICREDI
                    else if (banco == '748') {
                        if ((resto == 0) || (resto == 1))
                            result = '0';
                        else result = dv;
                    } else if (banco == 'TRIBUTO') {
                        if ((resto == 1) || (resto == 0))
                            result = '0';
                        else if (resto == 10)
                            result = '1';
                        else result = dv;
                    }
                    // DEMAIS BANCOS
                    else {
                        /*
                         *Esta regra se aplica para o DV do CdBarra da caixa federal,
                         *mas não para o Nosso Número da caixa. Este é retornado na função MOD11_DV
                         */
                        if ((dv == 0) || (dv == 1) || (dv > 9))
                            result = '1';
                        else result = dv;
                    }
                }
            }
        }

        return result;
    };

    /**
     * Gera Codigo de Barras
     */
    self.geraCodigoBarras = function(widget, representacaonumerica, cdbarrapag){

        var codigodebarra = null;
        var banco = representacaonumerica.substr(0, 3);

        if (representacaonumerica.length != 48){
            switch(banco) {
                // BANCO ITAU
                case '341':
                    codigodebarra = self.geraCodigoBarrasItau(representacaonumerica, codigodebarra);
                    break;
                // BANCO HSBC
                case '399':
                    codigodebarra = self.geraCodigoBarrasHsbc(representacaonumerica, codigodebarra);
                    break;
                // BANCO SAFRA
                case '422':
                    codigodebarra = self.geraCodigoBarrasSafra(representacaonumerica, codigodebarra);
                    break;
                // BANCO UNIBANCO
                case '409':
                    codigodebarra = self.geraCodigoBarrasUnibanco(representacaonumerica, codigodebarra);
                    break;
                // BANCO CAIXA
                case '104':
                    codigodebarra = self.geraCodigoBarrasCaixa(representacaonumerica, codigodebarra);
                    break;
                // BANCO BANRISUL
                case '041':
                    codigodebarra = self.geraCodigoBarrasBanrisul(representacaonumerica, codigodebarra);
                    break;
                // BANCO SICOOB
                case '756':
                    codigodebarra = self.geraCodigoBarrasSicoob(representacaonumerica, codigodebarra);
                    break;
                //BANCO PADRAO
                default:
                    codigodebarra = self.geraCodigoBarrasPadrao(representacaonumerica, codigodebarra);
            }
        }else codigodebarra = self.geraCodigoBarras48Digitos(representacaonumerica, codigodebarra);

        cdbarrapag.setValue(codigodebarra);
    };

    /**
     * Valida Código de Barras
     */
    self.validaCodigoBarras = function(widget_name, codbar_name, line_name, vrbol_name, vrliq_name) {
        var deferred = ZHPromise.defer();
        
        var widget        = templateManager.container.getWidget(widget_name);
        var codigodebarra = widget.getField(codbar_name).value();
        var dslinhbarpag  = widget.getField(line_name);
        
        var barra         = '';
        var valorcodbar   = '0000000000';
        
        var vrbolpag     = widget.getField(vrbol_name).value();
        var vrfinalbpag  = widget.getField(vrliq_name).value();

        if (codigodebarra) {

            if (codigodebarra.length != 44) {
                ScreenService.showMessage('Código de barras deve ter 44 posições.');
                deferred.reject();
                return deferred;
            }

            if (codigodebarra.substr(0, 1) == '8') {
                var barraconc = codigodebarra.substr(0, 3) + codigodebarra.substr(4, 40);
                if ((codigodebarra.substr(2, 1) == '6') || (codigodebarra.substr(2, 1) == '7')) {
                    if (self.Mod10_Concessionaria(barraconc) != codigodebarra.substr(3, 1)) {
                        ScreenService.showMessage('Código de barras inválido. Dígito verificador inconsistente.');
                        deferred.reject();
                        return deferred;
                    }
                } else {
                    if (self.Mod11_B9(barraconc, 'TRIBUTO') != codigodebarra.substr(3, 1)) {
                        ScreenService.showMessage('Código de barras inválido. Dígito verificador inconsistente.');
                        deferred.reject();
                        return deferred;
                    }
                }

                // Valor do Título Código de Barras
                valorcodbar = codigodebarra.trim().substr(5, 10);
            } else {
                barra = codigodebarra.substr(0, 4) + codigodebarra.substr(5, 39);
                if (self.Mod11_B9(barra, codigodebarra.substr(0, 3)) != codigodebarra.substr(4, 1)) {
                    ScreenService.showMessage('Código de barras inválido. Dígito verificador inconsistente.');
                    deferred.reject();
                    return deferred;
                }

                // Valor do Título Código de Barras
                valorcodbar = codigodebarra.trim().substr(9, 10);
            }

            // Valida Valor do Código de Barras
            if (valorcodbar != '0000000000') {
                return self.validaValorCodigoBarras(valorcodbar, widget.currentRow.CDFORNECED, vrbolpag, vrfinalbpag).then(function () {
                    dslinhbarpag.setValue('');
                    deferred.resolve();
                    return deferred;
                }).catch(function () {
                    deferred.reject();
                    return deferred;
                });
            }else{
                deferred.resolve();
                return deferred;
            }

        }else {
            dslinhbarpag.setValue('');
            deferred.resolve();
            return deferred;
        }
    };

    /**
     * Valida Valor do Código de Barras
     * @param valorcodbar
     * @param cdforneced
     * @param vrfinalbpag
     * @param vrbolpag
     * @returns {*}
     */
    self.validaValorCodigoBarras = function(valorcodbar, cdforneced, vrfinalbpag, vrbolpag){
        var deferred = ZHPromise.defer();
        
        // Valor do código de barras
        valorcodbar = ((parseInt(valorcodbar))/100).toFixed(2);
        
        valorcodbar = self.formataValor(valorcodbar);
        vrfinalbpag = self.formataValor(vrfinalbpag);
        vrbolpag    = self.formataValor(vrbolpag);


        //Se o valor do código de barras está diferente do valor do boleto no sistema
        if ((valorcodbar != vrfinalbpag) && (valorcodbar != vrbolpag)){

            //Pesquisa se o Fornecedor do boleto possui Bonificação cadastrada.
            return Pag00001_TitulosAPagar_Service.buscaFornecedor(cdforneced).then(function (paramforneced) {
                var fornecedor  = paramforneced.dataset.fornecedor[0];

                //Se o fornecedor possui bonificação e o valor da mesma foi informada: Apenas alerta sobre a diferença.
                if ((fornecedor.IDTPDESCFORN == 'B') && (fornecedor.VRPEDESCFORN > 0)){
                    //Se marcar para não continuar a operação, então essa é abortada.
                    ScreenService.confirmMessage('Operação bloqueada. O valor informado no código de barras ('+valorcodbar+') para o título é diferente do valor final ('+vrfinalbpag+') e valor original ('+vrbolpag+') do título no sistema. Confirmar operação?', 'question', function(){
                        deferred.resolve();
                        return deferred;
                    }, function() {
                        deferred.reject();
                        return deferred;
                    });
                }else{
                    // Se não está marcado para possuir bonificação: Bloqueia Operação
                    ScreenService.showMessage('Operação bloqueada. O valor informado no código de barras ('+valorcodbar+') para o título é diferente do valor final ('+vrfinalbpag+') e valor original ('+vrbolpag+') do título no sistema.');
                    deferred.reject();
                    return deferred;
                }
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });

        }else{
            deferred.resolve();
            return deferred;
        }

    };
    
    self.setAdiantamentoDevolucaoFornecedor = function(){
        var widget = templateManager.container.getWidget('TitulosAPagarGrid');
        
        
        if (widget.dataSource.data.length > 0) {
            var fornecedor = widget.dataSource.data.map(u => u.CDFORNECED);
            
            fornecedor = fornecedor.filter((valor, indice, self) => {
              return self.indexOf(valor) === indice;
            });
            
            var filter = [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": widget.dataSource.data[0].NRORG
                },
                {
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": widget.dataSource.data[0].CDEMPRESA
                },
                {
                    "name": "CDFORNECED",
                    "operator": "=",
                    "value": fornecedor.join('_')
                }
            ];
                            
           General.callRestEngine('fin_contaPagar#/crud/adiantapagar_contapagar_notafiscal','FilterData', filter).then(function (result) {
                var fornecedorAdianta = result.dataset.adiantapagar_contapagar_notafiscal;
                
                fornecedorAdianta = fornecedorAdianta.map(u => u.CDFORNECED);
                    
                widget.dataSource.data.forEach(function(titulo){
                    if(fornecedorAdianta.includes(titulo.CDFORNECED)){
                          titulo.IDADIANTADISP = 'S';
                    }else titulo.IDADIANTADISP = 'N';
                });
            });
            
            General.callRestEngine('fin_contaPagar#/crud/notafiscal_tipooperac_contapagar','FilterData', filter).then(function (result) {
                var fornecedorDevolu  = result.dataset.notafiscal_tipooperac_contapagar;
                
                fornecedorDevolu = fornecedorDevolu.map(u => u.CDFORNECED);
                
                widget.dataSource.data.forEach(function(titulo){
                    if(fornecedorDevolu.includes(titulo.CDFORNECED)){
                          titulo.IDDEVOLUDISP = 'S';
                    }else titulo.IDDEVOLUDISP = 'N';
                });
            });
        }
    };
    
    /**
     * Valida Adiantamento Fornecedor
     */
    self.validaAdiantamentoDevolucaoFornecedor = function(){
        var widget = templateManager.container.getWidget('TitulosAPagarGrid');

        if((widget.getLastSelectedRow().IDSTATBPAG   == 'B') || (widget.getLastSelectedRow().IDSTATBPAG == 'P')) return;
        if(widget.getLastSelectedRow().IDSITUCNABP   != '00') return;
        if(widget.getLastSelectedRow().IDSTATUS      == 'V') return;
        if(widget.getLastSelectedRow().IDBLOQNFFINCP == 'B') return;
        if(widget.getLastSelectedRow().IDTPCTPAGAR   == '2') return;

        if (widget.getLastSelectedRow().IDADIANTADISP != 'N') {
            self.validaAdiantamentoFornecedor();
        }else if(widget.getLastSelectedRow().IDDEVOLUDISP != 'N'){
            self.validaDevolucaoFornecedor();
        }
    };

    /**
     * Valida Adiantamento Fornecedor
     */
    self.validaAdiantamentoFornecedor = function(){

        var widget = templateManager.container.getWidget('TitulosAPagarGrid');
        
        var route = 'fin_movimentacaoBancaria#/adiantapagar_adiantamentoPagar';
        
        var filter = [
            {
                "name": "CDEMPRESA",
                "operator": "=",
                "value": widget.getLastSelectedRow().CDEMPRESA
            },
            {
                "name": "CDFORNECED",
                "operator": "=",
                "value": widget.getLastSelectedRow().CDFORNECED
            },
            {
                "name": "NRINSJURFORN",
                "operator": "=",
                "value": widget.getLastSelectedRow().NRINSJURFORN
            }
        ];

        General.callRestEngine(route, 'FilterData', filter).then(function(adiantamento) {
            var vrfinalbpag = self.formataValor(widget.getLastSelectedRow().VRFINALBPAG.toString());
            if (adiantamento.dataset.adiantapagar_adiantamentoPagar.length > 0 && vrfinalbpag > 0) {
                ScreenService.confirmMessage('Atenção! Fornecedor possui crédito de adiantamento. Deseja utilizá-lo?', 'question', function() {
                    var adiantamentoPopup = templateManager.container.getWidget('AdiantamentoTabbed');

                    ScreenService.openPopup(adiantamentoPopup).then(function () {
                        adiantamentoPopup.currentRow.NMRAZSOCFORN = widget.getLastSelectedRow().NMRAZSOCFORN;
                        adiantamentoPopup.currentRow.CDAJUCTPAG   = '';
                        adiantamentoPopup.currentRow.DSAJUCTPAG   = '';
                        adiantamentoPopup.currentRow.TOTALTITULO   = vrfinalbpag;
                        adiantamentoPopup.widgets[0].reload();
                    });
                }, function(){
                    self.validaDevolucaoFornecedor();
                });
            }else self.validaDevolucaoFornecedor();
        });
    };

    /**
     * Valida Devolução Fornecedor
     */
    self.validaDevolucaoFornecedor = function(){
        var widget = templateManager.container.getWidget('TitulosAPagarGrid');

        if(widget.getLastSelectedRow().IDDEVOLUDISP != 'N'){

            self.buscaGeralPag().then(function(response_geralpag) {
    
                var geral_pag   = response_geralpag.dataset.geral_pag[0];
                var idutlnfdevol = geral_pag.IDUTLNFDEVOL;
    
                // Verifica Utilização de Devolução
                if(idutlnfdevol == 'S') {
                    var widget = templateManager.container.getWidget('TitulosAPagarGrid');
                    var vrfinalbpag = self.formataValor(widget.getLastSelectedRow().VRFINALBPAG.toString());
                    var routeDevolucao = 'fin_movimentacaoBancaria#/validaDevolucaoFornecedor';
                    General.callRestEngine(routeDevolucao, 'Row', widget.getLastSelectedRow()).then(function (devolucao) {
                        if (devolucao.dataset.DEVOLUCAO.length > 0 && vrfinalbpag > 0) {
                            ScreenService.confirmMessage('Atenção! Fornecedor possui nota fiscal de devolução. Deseja utilizá-la?', 'question', function () {
                                var devolucaoPopup = templateManager.container.getWidget('DevolucaoTabbed');
    
                                ScreenService.openPopup(devolucaoPopup).then(function () {
                                    devolucaoPopup.currentRow.NMRAZSOCFORN = widget.getLastSelectedRow().NMRAZSOCFORN;
                                    devolucaoPopup.currentRow.CDAJUCTPAG  = '';
                                    devolucaoPopup.currentRow.DSAJUCTPAG  = '';
                                    devolucaoPopup.currentRow.TOTALTITULO = vrfinalbpag;
                                    devolucaoPopup.widgets[0].reload();
                                });
                            });
                        }
                    });
                }
            });
        }
    };

    /**
     * Cancela Adiantamento Fornecedor
     * @param widget
     */
    self.cancelaAdiantamentoFornecedor = function(widget){

        var widgetAdiantamento = templateManager.container.getWidget('TitulosAPagarGrid');
        var routeDevolucao = 'fin_movimentacaoBancaria#/validaDevolucaoFornecedor';

        widget.widgets[0].dataSource.unSelectAll();
        ScreenService.closePopup();

        General.callRestEngine(routeDevolucao, 'Row', widgetAdiantamento.getLastSelectedRow()).then(function(devolucao) {
            if (devolucao.length > 0) {
                ScreenService.confirmMessage('Atenção! Cliente possui nota fiscal de devolução. Deseja utilizá-la?', 'question', function(){
                    var devolucaoPopup = templateManager.container.getWidget('devolucaoFornecedorTabbed');

                    ScreenService.openPopup(devolucaoPopup).then(function(){
                        devolucaoPopup.currentRow.NMRAZSOCFORN = widget.getLastSelectedRow().NMRAZSOCFORN;
                    });
                });
            }
        });
    };

    /**
     * Cancela Devolução Fornecedor
     * @param widget
     */
    self.cancelaDevolucaoFornecedor = function(widget){
        widget.widgets[0].dataSource.unSelectAll();
        ScreenService.closePopup();
    };

    /**
     * Seta Data Source Popup Fornecedor
     * @param popupFornecedor
     */
    self.setDataSourcePopupFornecedor = function(popupFornecedor){
        var widget = templateManager.container.getWidget('TitulosAPagarGrid');
        var lastSelectedRow = widget.getLastSelectedRow();
        popupFornecedor.dataSourceFilter.forEach(function(filtro){
            if (filtro.name.localeCompare('CDFORNECED') === 0){
                filtro.value = lastSelectedRow.CDFORNECED;
            }else if (filtro.name.localeCompare('CDEMPRESA') === 0) {
                filtro.value = lastSelectedRow.CDEMPRESA;
            }else if (filtro.name.localeCompare('NRINSJURFORN') === 0) {
                filtro.value = lastSelectedRow.NRINSJURFORN;
            }
        });
        popupFornecedor.reload();
    };

    /**
     * Seleciona Todos os Registros
     * @param widget
     */
    self.selecionaTodosRegistros = function(widget){
        self.atualizaValorAdiantaDev(widget).then(
            function() {},
            function(error){
                widget.unSelectAll();
                self.unsetStripeDataFooter();
            }
        );
    };

    /**
     * Atualiza Valor Adiantamento Devolução
     * @param widget
     * @returns {*}
     */
    self.atualizaValorAdiantaDev = function(widget) {
        var deferred = ZHPromise.defer();
        var tituloGrid = templateManager.container.getWidget('TitulosAPagarGrid');

        var totalDesconto = 0;
        var valorTitulo   = parseFloat(tituloGrid.getLastSelectedRow().VRFINALBPAG);

        widget.getCheckedRows().forEach(function (data) {
            totalDesconto += parseFloat(data.VRDESCONTO);
        });

        if (totalDesconto > valorTitulo){
            ScreenService.showMessage('Operação bloqueada. O valor a descontar não pode ser maior que o valor do título.');
            widget.getLastSelectedRow().__isSelected = false;
            deferred.reject();
        } else {
            deferred.resolve();
            widget.getParent().currentRow.TOTALDESCONTO = totalDesconto;
        }
        return deferred.promise;
    };

    /**
     * Calcula Total Adiantamento Disponível
     * @param widget
     */
    self.calculaTotalAdiantamentoDisponivel = function(widget){
        var totalDisponivel = 0;
        widget.dataSource.data.forEach(function(data){
            totalDisponivel += self.formataValor(data.VRTOTDISP);
        });
        widget.getParent().currentRow.TOTALADIANTAMENTO = totalDisponivel;
        widget.getParent().currentRow.TOTALDESCONTO = 0;
    };

    /**
     * Calcula Total Devolução Disponível
     * @param widget
     */
    self.calculaTotalDevolucaoDisponivel = function(widget){
        var totalDisponivel = 0;
        widget.dataSource.data.forEach(function(data){
            totalDisponivel += self.formataValor(data.VRTOTDISP);
        });
        widget.getParent().currentRow.TOTALDEVOLUCAO = totalDisponivel;
        widget.getParent().currentRow.TOTALDESCONTO = 0;
    };

    /**
     * Limita Valor Desconto
     * @param widget
     */
    self.limitaValorDesconto = function(widget){
        var superiorLancamento = false;

        var data   = widget.dataSource.data;
        var indice = widget.currentRow.__index;
        var widgetTitulo = templateManager.container.getWidget('TitulosAPagarGrid');

        var valorTitulo     = self.formataValor(widgetTitulo.getLastSelectedRow().VRFINALBPAG.toString());
        var valorDesconto   = self.formataValor(widget.currentRow.VRDESCONTO_inline.toString());
        var totalDisponivel = self.formataValor(widget.currentRow.VRTOTDISP.toString());
        var totalDesconto   = 0.00;

        for(var i = 0; i < data.length; i++){
            if (data[i].__isSelected){
                if (i != indice){
                    totalDesconto += self.formataValor(data[i].VRDESCONTO.toString());
                }else{
                    totalDesconto += self.formataValor(data[i].VRDESCONTO_inline.toString());
                }
            }
        }

        if (valorDesconto > totalDisponivel) {
            ScreenService.showMessage('Valor do desconto deve ser menor ou igual que o valor disponível.');
            widget.dataSource.data[indice].VRDESCONTO_inline = 0;
        }

         if ((valorDesconto > valorTitulo) || (totalDesconto > valorTitulo)) {
            totalDesconto -= self.formataValor(data[indice].VRDESCONTO_inline.toString());
            data[indice].VRDESCONTO_inline = 0;
            ScreenService.showMessage('Operação bloqueada. O valor a descontar não pode ser maior que o valor do lançamento.');
        }

        widget.getParent().currentRow.TOTALDESCONTO = totalDesconto;
    };

    /**
     * Confirma Adiantamento
     */
    self.confirmaAdiantamento = function(){
        var adiantamentoTabbed = templateManager.container.getWidget('AdiantamentoTabbed');
        var adiantamentoGrid   = templateManager.container.getWidget('AdiantamentoGrid');

        if(adiantamentoTabbed.isValid()) {
            if ((adiantamentoGrid.getCheckedRows().length <= 0) || (adiantamentoTabbed.currentRow.TOTALDESCONTO <= 0)) {
                ScreenService.showMessage('Operação bloqueada. Selecione o(s) registro(s) e informe o(s) valor(es) a ser(em) descontado(s).');
                return;
            }
            
            self.geraAdiantamentoFornecedor();
        }
    };

    /**
     * Confirma Adiantamento
     */
    self.confirmaDevolucao = function(){
        var devolucaoTabbed = templateManager.container.getWidget('DevolucaoTabbed');
        var devolucaoGrid   = templateManager.container.getWidget('DevolucaoGrid');

        if(devolucaoTabbed.isValid()) {
            if ((devolucaoGrid.getCheckedRows().length <= 0) || (devolucaoTabbed.currentRow.TOTALDESCONTO <= 0)) {
                ScreenService.showMessage('Operação bloqueada. Selecione o(s) registro(s) e informe o(s) valor(es) a ser(em) descontado(s).');
                return;
            }

            self.geraDevolucaoFornecedor();
        }
    };

    /**
     * Gera Adiantamento Fornecedor
     */
    self.geraAdiantamentoFornecedor = function(){

        var tituloGrid         = templateManager.container.getWidget('TitulosAPagarGrid');
        var adiantamentoTabbed = templateManager.container.getWidget('AdiantamentoTabbed');
        var adiantamentoGrid   = templateManager.container.getWidget('AdiantamentoGrid');

        var lastSelectedRowTituloGrid    = tituloGrid.getLastSelectedRow();
        var currentRowAdiantamentoTabbed = adiantamentoTabbed.currentRow;
        var checkedrowsAdiantamentoGrid  = adiantamentoGrid.getCheckedRows();

        var dataSet = [lastSelectedRowTituloGrid, currentRowAdiantamentoTabbed, checkedrowsAdiantamentoGrid];

        General.callRestEngine('fin_contaPagar#/geraAdiantamentoFornecedor', 'DataSet', dataSet).then(function (adiantamento) {
            ScreenService.showMessage('Registro salvo com sucesso.');
            ScreenService.closePopup();
            
            tituloGrid.unSelectAll();
            self.unsetStripeDataFooter();
            tituloGrid.reload();
        }).catch(function(erro){
            ScreenService.showMessage(erro.data.error);
            adiantamentoGrid.reload();
        });
    };

    /**
     * Gera Devolução Fornecedor
     */
    self.geraDevolucaoFornecedor = function(){
        var tituloGrid      = templateManager.container.getWidget('TitulosAPagarGrid');
        var devolucaoTabbed = templateManager.container.getWidget('DevolucaoTabbed');
        var devolucaoGrid   = templateManager.container.getWidget('DevolucaoGrid');

        var lastSelectedRowTituloGrid = tituloGrid.getLastSelectedRow();
        var currentRowDevolucaoTabbed = devolucaoTabbed.currentRow;
        var checkedrowsDevolucaoGrid  = devolucaoGrid.getCheckedRows();

        var dataSet = [lastSelectedRowTituloGrid, currentRowDevolucaoTabbed, checkedrowsDevolucaoGrid];

        General.callRestEngine('fin_contaPagar#/geraDevolucaoFornecedor', 'DataSet', dataSet).then(function () {
            ScreenService.showMessage('Registro salvo com sucesso.');
            ScreenService.closePopup();
            tituloGrid.reload();
        }).catch(function(erro){
            devolucaoGrid.reload();
            ScreenService.showMessage(erro.data.error);
        });
    };

    /**
     * Consulta Contabilização
     */
    self.consultaContabilizacao = function(){
        var widget = templateManager.container.getWidget('TitulosAPagarGrid');
        var checkedrows = widget.getCheckedRows();

        if(checkedrows.length > 0) {
            var contabil = [];
            var contctb = 0;

            for (var i = 0; i < checkedrows.length; i++){
                if (checkedrows[i].NRLANCTBDOC) {
                    contabil.push({});
                    contabil[contctb].CDEMPRESA  = checkedrows[i].CDEMPRESA;
                    contabil[contctb].NRLANCCONT = checkedrows[i].NRLANCTBDOC;
                    contctb++;
                }
            }
            if(contabil.length > 0) {
                contabilizacaoController.exibeContabilizacao(contabil);
            }else ScreenService.showMessage('Título(s) marcado(s) não possui(em) contabilização(ões).');
        }else ScreenService.showMessage('Marque o(s) título(s) para consulta da(s) contabilização(ões).');
    };

    /**
     * Habilita Action Títulos a Pagar
     */
    self.habilitaActionsTitulo = function(){
        var widget = templateManager.container.getWidget('TitulosAPagarGrid');
        var checkedrows = widget.getCheckedRows();
        var cont_assoc = 0;

        var actions = {
            associacao : false,
            desassociar : false,
            prorrogacao : false,
            remessa : false,
            borderoremessa : false,
            consremessa : false,
            cancremessa : false,
            baixa : false,
            cancbaixa : false,
            consctb : false,
            anteforn: false,
            habtitulo: false,
            destitulo: false,
            cancante: false,
            impretorno : true,
            cadauto : true,
            cadguiatrib : false,
            recibo : false
        };

        if(checkedrows.length > 0) {
            for (var i in checkedrows){

                actions = self.validaActionsSituacaoTitulo(checkedrows[i], actions);

                actions = self.validaActionsRemessaTitulo(checkedrows[i], actions);

                actions = self.validaActionsAssociacaoTitulo(checkedrows[i], actions);
                if(actions.associacao) {
                    cont_assoc++;
                    actions.associacao = cont_assoc > 1;
                }

                actions = self.validaActionsContabilizacaoTitulo(checkedrows[i], actions);

            }
        }

        widget.getAction('Associar').isVisible                = actions.associacao;
        widget.getAction('Desassociar').isVisible             = actions.desassociacao;
        widget.getAction('Prorrogar').isVisible               = actions.prorrogacao;
        widget.getAction('CadastrarGuiaTributo').isVisible    = actions.cadguiatrib;
        widget.getAction('Remessa').isVisible                 = actions.remessa;
        widget.getAction('BorderoRemessa').isVisible          = actions.borderoremessa;
        //widget.getAction('ConsultarRemessa').isVisible        = actions.consremessa;
        widget.getAction('CancelarRemessa').isVisible         = actions.cancremessa;
        widget.getAction('Recibo').isVisible                  = actions.recibo;
        widget.getAction('Baixar').isVisible                  = actions.baixa;
        widget.getAction('CancelarBaixa').isVisible           = actions.cancbaixa;
        widget.getAction('ConsultarCtbTitulo').isVisible      = actions.consctb;
        widget.getAction('AntecipacaoFornecedor').isVisible   = actions.anteforn;
        widget.getAction('HabilitarTitulo').isVisible         = actions.habtitulo;
        widget.getAction('DesabilitarTitulo').isVisible       = actions.destitulo;
        widget.getAction('CancelarAntecipacaoForn').isVisible = actions.cancante;
        widget.getAction('ImportarRetornoTitulo').isVisible   = actions.impretorno;
        widget.getAction('CadastramentoAutomatico').isVisible = actions.cadauto;
    };

    /**
     * Valida Actions Situacao Titulo
     */
    self.validaActionsSituacaoTitulo = function(checkedrows, actions){
        var listaIdbaixautil = ['I','G','H','U','V','K','X', 'J'];
        if (checkedrows.IDSTATBPAG == 'A') {
            actions.prorrogacao = true;
            actions.emissao     = true;
            actions.recibo =  false;
            //TO DO mais codigos de impostos
            if(listaIdbaixautil.includes(checkedrows.IDBAIXAUTILP))
                actions.cadguiatrib = true;
            if(idhabibole_geral == 'N')
                actions.baixa       = true;
            else{
                if (checkedrows.IDHABIBPAG == 'N')
                     actions.habtitulo   = true;
                else{ 
                    actions.destitulo   = true;
                    actions.baixa       = true;
                    actions.remessa     = false;
                    actions.habtitulo = false;
                }
            }
            if(!checkedrows.NRLANCANTECIPA)
                 actions.anteforn = true;
            else actions.cancante = true;
        }else if (checkedrows.IDSTATBPAG == 'P'){
            actions.baixa       = true;
            actions.cancbaixa   = true;
        }else if (checkedrows.IDSTATBPAG == 'B'){
            actions.cancbaixa   = true;
            actions.recibo = true;
        }
        if(checkedrows.IDSITUCNABP == '00'){
            actions.impretorno = false;
        }

        return actions;
    };

    /**
     * Valida Actions Remessa Titulo
     * @param checkedrows
     * @param actions
     * @returns {*}
     */
    self.validaActionsRemessaTitulo = function(checkedrows, actions){
        if (checkedrows.IDSITUCNABP == '00') {
            if(checkedrows.IDSTATBPAG == 'A')
                actions.remessa = true;
        }else if (checkedrows.IDSITUCNABP != '90'){
            actions.borderoremessa = true;
            actions.cancremessa = true;
            actions.consremessa = true;
        }else{ 
            actions.borderoremessa = true;
            actions.consremessa = true;
        }

        return actions;
    };

    /**
     * Valida Actions Associacao Titulo
     * @param checkedrows
     * @param actions
     * @returns {*}
     */
    self.validaActionsAssociacaoTitulo = function(checkedrows, actions){
        if(checkedrows.IDSTATBPAG == 'A')
            if (checkedrows.IDASSOCBOLPAG != 'S')
                actions.associacao = true;
            else actions.desassociacao = true;

        return actions;
    };

    /**
     * Valida Actions Contabilizacao Titulo
     * @param checkedrows
     * @param actions
     * @returns {*}
     */
    self.validaActionsContabilizacaoTitulo = function(checkedrows, actions){
        if (checkedrows.NRLANCTBDOC != null)
            actions.consctb = true;

        return actions;
    };








    /**
     * Simula Parcelamento Automatico
     * @param widget
     */
    self.simulaParcelamentoAutomatico = function(widget){
        if(widget.isValid()){
            var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');
            var widgetParcelamento = templateManager.container.getWidget('ParcelamentoGrid');
            var widgetParcelamentoAutomatico = templateManager.container.getWidget('ParcelamentoAutomaticoGrid');

            // Varíaveis dos Campos em Tela
            var nrparcelas  = widget.getField('NRPARCELAS').value();
            var dtprimvenc  = widget.getField('DTPRIMVENC').value();
            var cdmotiparc  = widget.getField('CDMOTIPARC').value();
            var dsmotiparc  = widget.getField('DSMOTIPARC').value();
            var vrfinalbpag = parseFloat(widget.getField('VRFINALBPAG').value()).toFixed(2);
            var idproxvenc  = widget.getField('IDPROXVENC').value();
            var nrdiasvenc  = widget.getField('NRDIASVENC').value();

            // Variavel do DataSource
            var datasource = [];
            var dtvencbolpag = moment(dtprimvenc, 'DD/MM/YYYY').format('DD/MM/YYYY');

            // Calculo de Valores das Parcelas
            var vrparcela = parseFloat(vrfinalbpag / nrparcelas).toFixed(2);
            var vrtotparc = vrparcela * nrparcelas;
            var vrultparc = ((vrtotparc != vrfinalbpag)?
                parseFloat((vrfinalbpag)-(vrtotparc)+parseFloat(vrparcela)).toFixed(2)
                : vrparcela);

            for(var i = 1; i <= nrparcelas; i++){
                datasource[i-1] = {
                    'NRORG'        : widgetTitulos.currentRow.NRORG,
                    'CDFILIAL'     : widgetTitulos.currentRow.CDFILIAL,
                    'NRLANBOLPAG'  : ((i == 1)?
                        widgetTitulos.currentRow.NRLANBOLPAG
                        :null),
                    'NRORIGBOLPAG' : widgetTitulos.currentRow.NRLANBOLPAG,
                    'NRPARCBOLPAG'     : retornaNumeroParcela(i),
                    'NRPARCBOLPAGVISU' : ("00"+ i.toString()).substr(-3),
                    'DTVENBOLPAG'  : dtvencbolpag,
                    'VRFINALBPAG'  : ((i != nrparcelas)?
                        vrparcela
                        : vrultparc),
                    'CDMOTIPARC'  : cdmotiparc,
                    'DSMOTIPARC'  : dsmotiparc
                };

                dtvencbolpag = ((idproxvenc == 'F')?
                    moment(dtvencbolpag, 'DD/MM/YYYY').add(1, 'months').format('DD/MM/YYYY')
                    : moment(dtvencbolpag, 'DD/MM/YYYY').add(nrdiasvenc, 'days').format('DD/MM/YYYY'));
            }

            if(datasource.length > 0) {
                var parcelamentoAutomaticoGrid = templateManager.container.getWidget('ParcelamentoAutomaticoGrid');
                parcelamentoAutomaticoGrid.dataSource.data = datasource;
                widgetParcelamentoAutomatico.getAction('finish').isVisible = true;
                templateManager.updateTemplate();
            }
        }
    };

    /**
     * Altera Campo Proximos Vencimentos
     * @param widget
     */
    self.alteraCampoProximosVencimentos = function(widget){
        var idproxvenc = widget.getField('IDPROXVENC').value();

        if(idproxvenc == 'F') {
            widget.getField('NRDIASVENC').readOnly = true;
            delete widget.getField('NRDIASVENC').validations.required;
            delete widget.getField('NRDIASVENC').validations.min;
            widget.getField('NRDIASVENC').setValue(0);
        }else{
            widget.getField('NRDIASVENC').readOnly = false;
            widget.getField('NRDIASVENC').validations.required = true;
            widget.getField('NRDIASVENC').validations.min = {"limit" : 0};
            widget.getField('NRDIASVENC').setValue(30);
        }
        
        templateManager.updateTemplate();
    };

    /**
     * Abre Parcelamento Automatico
     */
    self.abreParcelamentoAutomatico = function(){
        var widgetTitulosAPagar = templateManager.container.getWidget('TitulosAPagarGrid');
        
        self.buscaAjusteTitulo(widgetTitulosAPagar.currentRow.CDFILIAL, widgetTitulosAPagar.currentRow.NRLANBOLPAG).then(function (response_ajbolpag){
            var ajbolpag = response_ajbolpag.dataset.ajbolpag[0];
            if(!ajbolpag) {
                var widgetParcelamentoAutomatico = templateManager.container.getWidget('ParcelamentoAutomaticoForm');
                widgetParcelamentoAutomatico.isVisible = true;
                widgetParcelamentoAutomatico.editing = true;
                ScreenService.openSwipe(widgetParcelamentoAutomatico);
                self.buscaPadraoParcelamentoAutomatico(widgetParcelamentoAutomatico);
            }else ScreenService.showMessage('Operação bloqueada. Não é possível parcelar título com ajuste.');
        });
    };

    /**
     * Busca Padrão Parcelamento Automático
     */
    self.buscaPadraoParcelamentoAutomatico = function (widget){
        var widgetTitulos = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetParcelamento = templateManager.container.getWidget('ParcelamentoGrid');
        var widgetParcelamentoAutomaticoGrid = templateManager.container.getWidget('ParcelamentoAutomaticoGrid');

        widget.getField('NRPARCELAS').setValue(2);
        widget.getField('CDMOTIPARC').setValue('');
        widget.getField('DSMOTIPARC').setValue('');
        widget.getField('VRFINALBPAG').setValue(widgetParcelamento.dataSource.data[0].VRFINALBPAG);
        widget.getField('DTPRIMVENC').setValue(widgetParcelamento.dataSource.data[0].DTVENBOLPAG);
        widget.getField('IDPROXVENC').setValue('F');
        widget.getField('NRDIASVENC').setValue(0);

        widgetParcelamentoAutomaticoGrid.getAction('finish').isVisible = false;
        widgetParcelamentoAutomaticoGrid.dataSource.data = [];

        templateManager.updateTemplate();
    };

    /**
     * Finaliza Parcelamento Automático Títulos a Pagar/Pagos
     */
    self.finalizaParcelamentoAutomatico = function(){
        var widgetParcelamentoAutomaticoGrid = templateManager.container.getWidget('ParcelamentoAutomaticoGrid');
        var widgetParcelamentoAutomaticoForm = templateManager.container.getWidget('ParcelamentoAutomaticoForm');
        var widgetParcelamentoGrid           = templateManager.container.getWidget('ParcelamentoGrid');
        var widgetTitulosAPagarGrid          = templateManager.container.getWidget('TitulosAPagarGrid');

        for(var i in widgetParcelamentoAutomaticoGrid.dataSource.data) {
            if ($.currency.unmaskString(widgetParcelamentoAutomaticoGrid.dataSource.data[i].VRFINALBPAG) <= 0) {
                ScreenService.showMessage('Operação bloqueada. Existe(m) parcela(s) menor(es) ou igual(is) a zero.');
                return;
            }
        }

        Pag00001_TitulosAPagar_Service.finalizaParcelamentoTitulo(widgetParcelamentoAutomaticoGrid.dataSource.data).then(function () {
            ScreenService.showMessage('Registro salvo com sucesso.');

            for(var i in widgetParcelamentoAutomaticoGrid.dataSource.data)
                if(widgetParcelamentoAutomaticoGrid.dataSource.data[i].NRLANBOLPAG == widgetTitulosAPagarGrid.currentRow.NRLANBOLPAG)
                    widgetTitulosAPagarGrid.currentRow.VRFINALBPAG = widgetParcelamentoAutomaticoGrid.dataSource.data[i].VRFINALBPAG;
                    widgetTitulosAPagarGrid.currentRow.VRBOLPAG = widgetParcelamentoAutomaticoGrid.dataSource.data[i].VRFINALBPAG;

            ScreenService.closeSwipe();
            widgetParcelamentoAutomaticoForm.editing = false;
            widgetParcelamentoGrid.reload();
            widgetTitulosAPagarGrid.reload();
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    /**
     * Nova Parcela Títulos a Pagar
     * @param args
     */
    self.geraParcelamentoAutomatico = function(args){
        var widgetTitulosAPagar = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetParcelamento  = templateManager.container.getWidget('ParcelamentoGrid');

        if((widgetTitulosAPagar.currentRow.IDSTATBPAG == 'B') || (widgetTitulosAPagar.currentRow.IDSTATBPAG == 'P')){
            ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
            return;
        }
        if(widgetTitulosAPagar.currentRow.IDSTATUS == 'V') {
            ScreenService.showMessage('Operação bloqueada. Título previsto não pode ser alterado.');
            return;
        }
        if(widgetTitulosAPagar.currentRow.IDBLOQNFFINCP == 'B') {
            ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
            return;
        }
        if(widgetParcelamento.dataSource.data.length > 1) {
            ScreenService.showMessage('Operação bloqueada. Título parcelado não pode utilizar o parcelamento automático.');
            return;
        }

        if(!widgetTitulosAPagar.currentRow.NRCNABPAGREM){
            self.abreParcelamentoAutomatico();
        }else{
            var paramsRem  = {
                nrorg       : getLocalVar('NRORG'),
                cdfilial    : getLocalVar('CDFILIAL'),
                cdoperador  : getLocalVar('CDOPERADOR')
            };
            var currentRowRem = [paramsRem, [widgetTitulosAPagar.currentRow]];

            ScreenService.confirmMessage('O título está vinculado a uma remessa. Deseja removê-lo para prosseguir?', 'question', function () {
                Pag00001_TitulosAPagar_Service.excluiTituloPagRemessa(currentRowRem).then(function () {
                    self.abreParcelamentoAutomatico();
                    widgetTitulosAPagar.currentRow.IDSITUCNABP = '00';
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            });
        }
    };

    /**
     * Abre Cadastramento Automatico
     */
    self.abreCadastramentoAutomatico = function(){
        if(!templateManager.container.getWidget('TitulosAPagarGrid').appliedFilter.FILTER_ROW.CDEMPRESA) {
            ScreenService.showMessage('Operação bloqueada. Empresa não selecionada no filtro.');
            return;
        }

        var widgetTitulosAPagarGrid       = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetCadastramentoAutomatico = templateManager.container.getWidget('CadastramentoAutomaticoForm');
        widgetCadastramentoAutomatico.isVisible = true;
        ScreenService.openPopup(widgetCadastramentoAutomatico);
        self.buscaPadraoCadastramentoAutomatico(widgetTitulosAPagarGrid, widgetCadastramentoAutomatico);
    };

    /**
     * Busca Padrão Cadastramento Automático
     */
    self.buscaPadraoCadastramentoAutomatico = function (widgetTitulosAPagarGrid, widgetCadastramentoAutomatico){
        var checkedRows = widgetTitulosAPagarGrid.getCheckedRows();
        var lastChecked = checkedRows ? checkedRows[0] : null;

        var cdfilirece      = '';
        var nrtamnumnfutdfe = '';
        var cdempresarece   = '';
        var cdinscestarece  = '';
        var cdinscmunirece  = '';
        var nmfilialrece    = '';
        var cdforneced      = '';
        var nrinsjurforn    = '';
        var idtpijurforn    = '';
        var nmrazsocforn    = '';
        var cdtipooper      = '';
        var nmtipooper      = '';
        var cdserie         = '';
        var dsserie         = '';
        var vrbolpag        = '';
        var dtprimvenc      = moment().format('DD/MM/YYYY');
        var cdtpctpagar     = '';
        var dstpctpagar     = '';
        var dsdefactpag     = '';
        var dscontapag      = '';
        var cdclassfina     = '';

        if(lastChecked) {

            var parfilempr  = self.buscaParamfilialFilialEmprcntrfil(lastChecked.CDEMPRESA, lastChecked.CDFILIRECE);
            var tipooperac  = self.buscaTipooperac(lastChecked.CDTIPOOPER);
            var serieentr   = self.buscaSerieentr(lastChecked.CDSERIE);
            var tipoctpagar = self.buscaTipoctpagar(lastChecked.CDTPCTPAGAR);

            ZHPromise.all([parfilempr, tipooperac, serieentr, tipoctpagar]).then(function(response){
                parfilempr   = response[0].dataset.paramfilial_filial_emprcntrfilpag[0];
                tipooperac   = response[1].dataset.tipooperac[0];
                serieentr    = response[2].dataset.serieentr[0];
                tipoctpagar  = response[3].dataset.tipoctpagar[0];

                cdfilirece      = (parfilempr) ? parfilempr.CDFILIAL   : '';
                nmfilialrece    = (parfilempr) ? parfilempr.NMFILIEMIT : '';
                cdempresarece   = (parfilempr) ? parfilempr.CDEMPRESA  : '';
                cdinscestarece  = (parfilempr) ? parfilempr.CDINSCESTA : '';
                cdinscmunirece  = (parfilempr) ? parfilempr.CDINSCMUNI : '';
                nrtamnumnfutdfe = (parfilempr) ? parfilempr.NRTAMNUMNFUTDFE > 0 ? parfilempr.NRTAMNUMNFUTDFE : 9 : '';
                cdforneced      = lastChecked.CDFORNECED;
                nrinsjurforn    = lastChecked.NRINSJURFORN;
                idtpijurforn    = lastChecked.IDTPIJURFORN;
                nmrazsocforn    = lastChecked.NMRAZSOCFORN;
                nmtipooper      = (tipooperac) ? tipooperac.NMTIPOOPER : '';
                cdtipooper      = (tipooperac) ? tipooperac.CDTIPOOPER : '';
                dsserie         = (serieentr)  ? serieentr.DSSERIEENTR : '';
                cdserie         = (serieentr)  ? serieentr.CDSERIEENTR : '';
                vrbolpag        = lastChecked.VRBOLPAG;
                dtprimvenc      = lastChecked.DTVENBOLPAG;
                cdtpctpagar     = (tipoctpagar) ? tipoctpagar.CDTPCTPAGAR : '';
                dstpctpagar     = (tipoctpagar) ? tipoctpagar.DSTPCTPAGAR : '';
                dsdefactpag     = (tipoctpagar) ? tipoctpagar.DSDEFACTPAG : '';
                dscontapag      = (tipoctpagar) ? tipoctpagar.DSDEFACTPAG : '';
                cdclassfina     = (tipoctpagar) ? tipoctpagar.CDCLASSFINA : '';

                self.setaPadraoCadastramentoAutomatico(
                    widgetCadastramentoAutomatico, nrtamnumnfutdfe, cdempresarece, cdinscestarece, cdinscmunirece,
                    nmfilialrece, cdfilirece, cdforneced, nrinsjurforn, idtpijurforn, nmrazsocforn, nmtipooper,
                    cdtipooper, dsserie, cdserie, vrbolpag, dtprimvenc, dstpctpagar, cdtpctpagar, dsdefactpag,
                    dscontapag, cdclassfina
                );
            });
        }else{
            self.setaPadraoCadastramentoAutomatico(
                widgetCadastramentoAutomatico, nrtamnumnfutdfe, cdempresarece, cdinscestarece, cdinscmunirece,
                nmfilialrece, cdfilirece, cdforneced, nrinsjurforn, idtpijurforn, nmrazsocforn, nmtipooper,
                cdtipooper, dsserie, cdserie, vrbolpag, dtprimvenc, dstpctpagar, cdtpctpagar, dsdefactpag,
                dscontapag, cdclassfina
            );
        }


    };

    /**
     * Seta Padrão Cadastramento Automático
     */
    self.setaPadraoCadastramentoAutomatico = function (
        widgetCadastramentoAutomatico, nrtamnumnfutdfe, cdempresarece, cdinscestarece, cdinscmunirece,
        nmfilialrece, cdfilirece, cdforneced, nrinsjurforn, idtpijurforn, nmrazsocforn, nmtipooper,
        cdtipooper, dsserie, cdserie, vrbolpag, dtprimvenc, dstpctpagar, cdtpctpagar, dsdefactpag,
        dscontapag, cdclassfina
    ){
        widgetCadastramentoAutomatico.getField('NRORG').setValue(getLocalVar('NRORG'));
        widgetCadastramentoAutomatico.getField('CDFILIAL').setValue(getLocalVar('CDFILIAL'));
        widgetCadastramentoAutomatico.getField('CDOPERACTPG').setValue(getLocalVar('CDOPERADOR'));
        widgetCadastramentoAutomatico.getField('NRTITULOS').setValue(1);
        widgetCadastramentoAutomatico.getField('NRTAMNUMNFUTDFE').setValue(nrtamnumnfutdfe);
        widgetCadastramentoAutomatico.getField('CDEMPRESARECE').setValue(cdempresarece);
        widgetCadastramentoAutomatico.getField('CDINSCESTARECE').setValue(cdinscestarece);
        widgetCadastramentoAutomatico.getField('CDINSCMUNIRECE').setValue(cdinscmunirece);
        widgetCadastramentoAutomatico.getField('NMFILIALRECE').setValue([nmfilialrece]);
        widgetCadastramentoAutomatico.getField('NMFILIALRECE').reload();
        widgetCadastramentoAutomatico.getField('CDFILIRECE').setValue(cdfilirece);
        widgetCadastramentoAutomatico.getField('IDSTATUS').setValue('A');
        widgetCadastramentoAutomatico.getField('CDFORNECED').setValue(cdforneced);
        widgetCadastramentoAutomatico.getField('NRINSJURFORN').setValue(nrinsjurforn);
        widgetCadastramentoAutomatico.getField('IDTPIJURFORN').setValue(idtpijurforn);
        widgetCadastramentoAutomatico.getField('NMRAZSOCFORN').setValue(nmrazsocforn);
        widgetCadastramentoAutomatico.getField('NMTIPOOPER').setValue(nmtipooper);
        widgetCadastramentoAutomatico.getField('CDTIPOOPER').setValue(cdtipooper);
        widgetCadastramentoAutomatico.getField('DSSERIE').setValue(dsserie);
        widgetCadastramentoAutomatico.getField('CDSERIE').setValue(cdserie);
        widgetCadastramentoAutomatico.getField('VRNOTAFISC').setValue(vrbolpag);
        widgetCadastramentoAutomatico.getField('DTPRIMVENC').setValue(dtprimvenc);
        widgetCadastramentoAutomatico.getField('IDPROXVENC').setValue('F');
        widgetCadastramentoAutomatico.getField('NRDIASVENC').setValue(0);
        widgetCadastramentoAutomatico.getField('DSTPCTPAGAR').setValue(dstpctpagar);
        widgetCadastramentoAutomatico.getField('DSDEFACTPAG').setValue(dsdefactpag);
        widgetCadastramentoAutomatico.getField('DSCONTAPAG').setValue(dscontapag);
        widgetCadastramentoAutomatico.getField('CDTPCTPAGAR').setValue(cdtpctpagar);
        widgetCadastramentoAutomatico.getField('CDCLASSFINA').setValue(cdclassfina);

        templateManager.updateTemplate();
    };

    /**
     * Gera Cadastramento Automático Títulos a Pagar/Pagos
     */
    self.geraCadastramentoAutomatico = function(){
        var widgetTitulosAPagarGrid     = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetCadastramentoAutomatico = templateManager.container.getWidget('CadastramentoAutomaticoForm');

        if(widgetCadastramentoAutomatico.isValid()) {
            Pag00001_TitulosAPagar_Service.geraCadastramentoAutomatico(widgetCadastramentoAutomatico.currentRow).then(function () {
                ScreenService.showMessage('Registros salvos com sucesso.');
                ScreenService.closePopup(widgetCadastramentoAutomatico);
                ScreenService.closePopup();

                widgetCadastramentoAutomatico.isVisible = false;

                widgetTitulosAPagarGrid.unSelectAll();
                self.unsetStripeDataFooter();
                widgetTitulosAPagarGrid.activate();
                widgetTitulosAPagarGrid.reload();
            }, function (error) {
                if (contabilizacaoController.checkErrosContabilizacao(error)) {
                    ScreenService.showMessage(error.data.error);
                }
            });
        }
    };

    self.voltarTitulosPagar = function(){
        var titulos = templateManager.container.getWidget('TitulosAPagarGrid');
        ScreenService.goBack().then(function(){
            titulos.reload();
        });
    };

    /**
     * Abre Importação Retorno Título
     */
    self.abreImportacaoRetornoTitulo = function(){
        var widgetTitulosAPagar = templateManager.container.getWidget('TitulosAPagarGrid');
        /*widgetTitulosAPagar.appliedFilter.FILTER_ROW.CDEMPRESA;
        widgetTitulosAPagar.appliedFilter.FILTER_ROW.NMEMPRESA;*/

        var widgetImportacaoRetorno = templateManager.container.getWidget('ImportacaoRetornoForm');
        widgetImportacaoRetorno.isVisible = true;
        widgetImportacaoRetorno.editing = true;
        ScreenService.openSwipe(widgetImportacaoRetorno);
        ScreenService.closePopup(true);
        self.buscaPadraoImportacaoRetornoTitulo(widgetTitulosAPagar, widgetImportacaoRetorno);
    };

    /**
     * Busca Padrão Importação Retorno Título
     */
    self.buscaPadraoImportacaoRetornoTitulo = function(widgetTitulosAPagar, widgetImportacaoRetorno){
        widgetImportacaoRetorno.getField('CDEMPRESA').setValue(widgetTitulosAPagar.appliedFilter.FILTER_ROW.CDEMPRESA);
        widgetImportacaoRetorno.getField('NMEMPRESA').setValue(widgetTitulosAPagar.appliedFilter.FILTER_ROW.NMEMPRESA);
        widgetImportacaoRetorno.getField('NMBANCO').setValue('');
        widgetImportacaoRetorno.getField('DSARQCNABPAG').setValue('');
        widgetImportacaoRetorno.getField('DSARQCNABPAG').readOnly = true;

        self.deleteDataRetorno();

        templateManager.updateTemplate();
    };

    /**
     *
     * @param widgetImportacaoRetorno
     */
    self.validaVisualizacaoImportacao = function(widgetImportacaoRetorno){
        widgetImportacaoRetorno.getField('DSARQCNABPAG').setValue('');
        widgetImportacaoRetorno.getField('DSARQCNABPAG').readOnly = !widgetImportacaoRetorno.getField('NMBANCO').value();

        self.deleteDataRetorno();

        templateManager.updateTemplate();
    };

    /**
     * Prepara Arquivo de Retorno
     * @param widget
     */
    self.preparaArquivoRetorno = function(widget){
        var route = 'fin_contaPagar#/carregaRetorno';
        var arqRetorno = widget.currentRow.DSARQCNABPAG[0];
        var conteudoArquivo = arqRetorno.b64File.split(',')[1];
        var empresa = templateManager.container.getWidget('ImportacaoRetornoForm').currentRow.CDEMPRESA;
        var row = {
            'CDEMPRESA': empresa,
            'CDBANCO': widget.currentRow.CDBANCO,
            'CDBANCCNAB': widget.currentRow.CDBANCCNAB,
            'CNABRETORNO': conteudoArquivo
        };

        General.callRestEngine(route, 'Row', row)
            .then(function(response){
                self.setDataSourceRetorno(response.dataset.BOLETOS);
                self.setDataSourceOcorrencias(response.dataset.OCORRENCIAS);
                widget.widgets[0].SITUACAOCNAB = response.dataset.SITUACAOCNAB[0];
            }).catch(function(erro){
                widget.currentRow.DSARQCNABPAG = [];
                ScreenService.showMessage(erro.data.error);
            });
    };

    /**
     * Data Source Retorno
     * @param boletos
     */
    self.setDataSourceRetorno = function(boletos){
        var widgetBoletos = templateManager.container.getWidget('ImportacaoRetornoTituloGrid');
        widgetBoletos.dataSource.data = [];
        widgetBoletos.dataSource.data = boletos;
    };

    /**
     * Data Source Ocorrências
     * @param ocorrencias
     */
    self.setDataSourceOcorrencias = function(ocorrencias){
        var widgetOcorrencias = templateManager.container.getWidget('OcorrenciaImportacaoRetornoGrid');
        widgetOcorrencias.dataSource.data = [];
        widgetOcorrencias.ocorrencias = ocorrencias;
    };

    /**
     * Insere Retorno Título
     */
    self.insereRetornoTitulo = function(){
        var widgetTitulos     = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetBoletos     = templateManager.container.getWidget('ImportacaoRetornoTituloGrid');
        var widgetOcorrencias = templateManager.container.getWidget('OcorrenciaImportacaoRetornoGrid');

        if (widgetBoletos.getParent().isValid()){
            if (widgetBoletos.dataSource.data.length > 0) {
                if (self.validaSituacaoCnab(widgetBoletos)) {

                    var dataSet = [];
                    var route = 'fin_contaPagar#/insereRetorno';
                    var form = {
                        'DSARQCNABPAG': widgetBoletos.getParent().currentRow.DSARQCNABPAG[0].b64File.split(',')[0],
                        'NOMEARQUIVO': widgetBoletos.getParent().currentRow.DSARQCNABPAG[0].name,
                        'CDBANCCNAB': widgetBoletos.getParent().currentRow.CDBANCCNAB,
                        'CDBANCO': widgetBoletos.getParent().currentRow.CDBANCO,
                        'CDEMPRESA': widgetBoletos.getParent().currentRow.CDEMPRESA
                    };

                    dataSet.push(form);
                    dataSet.push(widgetBoletos.dataSource.data);
                    dataSet.push(widgetOcorrencias.ocorrencias);

                    General.callRestEngine(route, 'DataSet', dataSet)
                        .then(function () {
                            ScreenService.goBack().then(function () {
                                ScreenService.showMessage('Registro salvo com sucesso.', 'checked');
                                widgetBoletos.getParent().isVisible = false;
                                widgetTitulos.unSelectAll();
                                self.unsetStripeDataFooter();
                                widgetTitulos.activate();
                                widgetTitulos.reload();
                            });
                        }).catch(function (erro) {
                            ScreenService.showMessage(erro.data.error);
                        });

                } else ScreenService.showMessage('Registro(s) do arquivo de retorno possui(em) ocorrência(s) que não possibilita(m) o salvamento.');
            }else ScreenService.showMessage('Não existe(m) título(s) para importação.');
        }
    };

    /**
     * Valída Situação CNAB
     * @param boletos
     * @returns {boolean}
     */
    self.validaSituacaoCnab = function(boletos){
        var boletoValido = !boletos.dataSource.data.every(function(elem) {return elem.SITUACAOBOLETO == false;});
        return (boletos.SITUACAOCNAB && boletoValido) ? true : false;
    };

    /**
     * Deleta Data Retorno
     */
    self.deleteDataRetorno = function(){
        var widgetBoletos = templateManager.container.getWidget('ImportacaoRetornoTituloGrid');
        var widgetOcorrencias = templateManager.container.getWidget('OcorrenciaImportacaoRetornoGrid');
        widgetBoletos.dataSource.data = [];
        widgetOcorrencias.dataSource.data = [];
        widgetOcorrencias.ocorrencias = [];
    };

    /**
     * Abre Ocorrências
     * @param widget
     */
    self.abreOcorrencias = function(widget){
        var widgetOcorrencias = templateManager.container.getWidget('OcorrenciaImportacaoRetornoGrid');
        widgetOcorrencias.dataSource.data = widgetOcorrencias.ocorrencias.filter(function(ocorrencia){
            return (ocorrencia.CDLINHA == widget.currentRow.CDLINHA || ocorrencia.GERAL);
        });
        templateManager.container.getWidget('OcorrenciaImportacaoRetornoGrid').activate();
    };

    /**
     * Edita Conta Documento
     * @param args
     */
    self.editaContaDocumento = function(args){
        var widgetContaDocumentos = args.owner.widget;
        var widgetTitulosPagar    = templateManager.container.getWidget('TitulosAPagarGrid');

        if((widgetTitulosPagar.currentRow.IDSTATBPAG == 'B') || (widgetTitulosPagar.currentRow.IDSTATBPAG == 'P')){
            ScreenService.showMessage('Operação bloqueada. Título baixado ou com baixa planejada não pode ser alterado.');
            return;
        }
        if(widgetTitulosPagar.currentRow.IDSITUCNABP != '00') {
            ScreenService.showMessage('Operação bloqueada. Título enviado, via CNAB, não pode ser alterado.');
            return;
        }

        General.edit(widgetContaDocumentos);
        General.changeWidgetAcessibility(widgetContaDocumentos.widgets, true);
    };

    /**
     * Salca Conta Documento
     * @param args
     */
    self.salvaContaDocumento = function(args){
        var widgetContaDocumentosGrid = args.owner.widget;

        if(widgetContaDocumentosGrid.isValid()){
            Pag00001_TitulosAPagar_Service.salvaContaDocumento(widgetContaDocumentosGrid.currentRow).then(function () {
                ScreenService.showMessage('Registro salvo com sucesso.', 'checked');
                ScreenService.goBack();

                widgetContaDocumentosGrid.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };

    /**
     * Seta Data Souce Stripe
     * @param widget
     */
    self.setStripeData = function(widget) {
        var currentRow = widget.appliedFilter.FILTER_ROW;
        currentRow.DTVENBOLPAG = (currentRow.DTVENBOLPAG) ? currentRow.DTVENBOLPAG : {'start': '', 'end': ''};
        var stripeWidget = templateManager.container.getWidget("stripe");

        stripeWidget.currentRow = {};
        stripeWidget.currentRow.NMEMPRESA   = currentRow.CDEMPRESA + ' - ' + currentRow.NMEMPRESA;
        stripeWidget.currentRow.DTVENBOLPAG = 'De ' + currentRow.DTVENBOLPAG.start + ' até ' + currentRow.DTVENBOLPAG.end;
    };
    
    self.setStripeDataFooter = function(status) {
        var widget          = templateManager.container.getWidget("TitulosAPagarGrid");
        var stripeWidget    = templateManager.container.getWidget("stripeFooter");
        var lastSelectedRow = widget.getLastSelectedRow();
        var checkedRows     = widget.getCheckedRows();
        var dstitulo        = '';
        var totalOriginal   = 0;
        var totalAjuste     = 0;
        var totalLiquido    = 0;
        
        checkedRows.forEach(function(item){
            totalOriginal += self.formataValor(item.VRBOLPAG);
            totalLiquido  += self.formataValor(item.VRFINALBPAG);
        });
        
        totalAjuste = totalLiquido - totalOriginal;
        
        if(((Object.keys(lastSelectedRow).length === 0 && lastSelectedRow.constructor === Object) && (checkedRows.length > 1)) != true){ 
            
            var dsboletpag = lastSelectedRow.DSBOLETPAG?" - " +lastSelectedRow.DSBOLETPAG:'';
                stripeWidget.getField('DSTITULO').isVisible = true;
                dstitulo = moment(lastSelectedRow.DTVENBOLPAG, 'DD/MM/YYYY').format('DD/MM/YYYY') + "  -  " +
                                lastSelectedRow.NMRAZSOCFORN + "  -  " +
                                self.numberToReal(lastSelectedRow.VRFINALBPAG) +
                                dsboletpag;
        }
        
        stripeWidget.currentRow.DSTITULO  = dstitulo;
        if (status){
            stripeWidget.getField('DSTITULO').isVisible = false;
            stripeWidget.currentRow.DSTITULO = '';
        }
        stripeWidget.currentRow.NRTITUTOT = checkedRows.length;
        stripeWidget.currentRow.VRORIGTOT = self.numberToReal(totalOriginal);
        stripeWidget.currentRow.VRAJUSTOT = self.numberToReal(totalAjuste);
        stripeWidget.currentRow.VRLIQTOT  = self.numberToReal(totalLiquido);
    };
    
    self.unsetStripeDataFooter = function() {
        var widget        = templateManager.container.getWidget("TitulosAPagarGrid");
        var stripeWidget  = templateManager.container.getWidget("stripeFooter");
        var checkedrows   = widget.getCheckedRows();
        var dstitulo      = '';
        var totalOriginal = 0;
        var totalAjuste   = 0;
        var totalLiquido  = 0;
        
        if(checkedrows.length > 0){
            checkedrows.forEach(function(item){
                totalOriginal += self.formataValor(item.VRBOLPAG);
                totalLiquido  += self.formataValor(item.VRFINALBPAG);
            });
            totalAjuste = totalLiquido - totalOriginal;
        }
        
        stripeWidget.getField('DSTITULO').isVisible = false;
        stripeWidget.currentRow.NRTITUTOT = checkedrows.length;
        stripeWidget.currentRow.VRORIGTOT = self.numberToReal(totalOriginal);
        stripeWidget.currentRow.VRAJUSTOT = self.numberToReal(totalAjuste);
        stripeWidget.currentRow.VRLIQTOT  = self.numberToReal(totalLiquido);
    };
    
    /**
     * Formata Número - Ex. 1500 p/ 1.500,00
     */
    self.numberToReal = function(numero) {
        numero = parseFloat(numero).toFixed(2).split('.');
        numero[0] = numero[0].split(/(?=(?:...)*$)/).join('.');
        return numero.join(',');
    };

    /**
     * Cancela Título Retorno
     */
    self.cancelaTituloRetorno = function(){
        var route = 'fin_contaPagar#/cancelaTituloRetorno';
        var widgetCnabRetorno        = templateManager.container.getWidget('CnabRetornoForm');
        var widgetCnabRetornoTitulo  = templateManager.container.getWidget('CnabRetornoTituloForm');
        var checkedRowsCnabRetTitulo = widgetCnabRetornoTitulo.getCheckedRows();

        for (var i in checkedRowsCnabRetTitulo) {
            if (checkedRowsCnabRetTitulo[i].IDSITUCNABP == '90') {
                ScreenService.showMessage('Operação bloqueada. Título baixado via CNAB não pode ser cancelado do retorno.');
                return;
            }
        }

        ScreenService.confirmMessage('Deseja realmente cancelar o(s) título(s) do retorno?', 'question', function () {
            var dataset = {
                retorno : widgetCnabRetorno.currentRow,
                boletos : widgetCnabRetornoTitulo.getCheckedRows()
            };

            General.callRestEngine(route, 'DataSet', dataset)
                .then(function(){
                    ScreenService.showMessage('Título(s) cancelado(s) do retorno com sucesso.', 'checked');
                    widgetCnabRetornoTitulo.reload();
                })
                .catch(function(erro){
                    ScreenService.showMessage(erro.data.error);
                });
        });
    };

    /**
     * Abre Parcelamento Automatico
     */
    self.abreAntecipacaoFornecedor = function(){
        var widgetTitulosAPagarGrid = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetAntecipacaoFornecedor = templateManager.container.getWidget('AntecipacaoFornecedorForm');
        
        var checkedrows = widgetTitulosAPagarGrid.getCheckedRows();

        if(checkedrows.length > 0) {

            for(var i in checkedrows) {
                if(checkedrows[i].IDSTATUS == 'V') {
                    ScreenService.showMessage('Operação bloqueada. Título previsto não pode ser alterado.');
                    return;
                }
                if(checkedrows[i].IDBLOQNFFINCP == 'B') {
                    ScreenService.showMessage('Operação bloqueada. Título bloqueado pela nota fiscal não pode ser alterado.');
                    return;
                }
            }
        
            ScreenService.closePopup(true);
            widgetAntecipacaoFornecedor.isVisible = true;
            widgetAntecipacaoFornecedor.newRow();
            widgetAntecipacaoFornecedor.__isNew = true;
            ScreenService.openSwipe(widgetAntecipacaoFornecedor);
            self.buscaPadraoAntecipacaoFornecedor(widgetAntecipacaoFornecedor);
        }
    };

    /**
     * Busca Padrao Antecipação de Fornecedor
     */
    self.buscaPadraoAntecipacaoFornecedor = function(widget){
        var widgetTitulosAPagar      = templateManager.container.getWidget('TitulosAPagarGrid');
        var checkedRowsTitulosAPagar = widgetTitulosAPagar.getCheckedRows();

        var vrcontaantecipa = 0;
        var vrliquantecipa  = 0;

        for (var i in checkedRowsTitulosAPagar) {
            vrcontaantecipa += checkedRowsTitulosAPagar[i].VRATUAPAG;
            vrliquantecipa += checkedRowsTitulosAPagar[i].VRFINALBPAG;
        }

        widget.getField('NRORG').setValue(getLocalVar('NRORG'));
        widget.getField('CDFILIAL').setValue(getLocalVar('CDFILIAL'));
        widget.getField('CDEMPRESA').setValue(widgetTitulosAPagar.appliedFilter.FILTER_ROW.CDEMPRESA);
        widget.getField('VRCONTAANTECIPA').setValue(vrcontaantecipa);
        widget.getField('VRLIQUANTECIPA').setValue(vrliquantecipa);
        widget.getField('DTLANCANTECIPA').setValue(moment().format('DD/MM/YYYY'));
        widget.getField('DTVENCANTECIPA').setValue(moment().format('DD/MM/YYYY'));
        widget.getField('DTEMISANTECIPA').setValue(moment().format('DD/MM/YYYY'));
    };

    /**
     * Finaliza Antecipacao de Fornecedor
     * @param widget
     */
    self.finalizaAntecipacaoFornecedor = function(widget){
        var widgetTitulosAPagar = templateManager.container.getWidget('TitulosAPagarGrid');

        if(widget.isValid()){
            var titulosEmAberto = widgetTitulosAPagar.getCheckedRows().filter(function(titulo){
                return ((titulo.IDSTATBPAG == 'A') && (titulo.IDANTECIPAFORN == 'N'));
            });

            var dataSet = [widget.currentRow, titulosEmAberto];

            General.callRestEngine('fin_contaPagar#/finalizaAntecipacaoFornecedor', 'DataSet', dataSet).then(function () {
                ScreenService.showMessage('Título(s) antecipado(s) com sucesso.', 'checked');
                ScreenService.goBack();
                
                widget.isVisible = false;
                
                widgetTitulosAPagar.unSelectAll();
                self.unsetStripeDataFooter();
                widgetTitulosAPagar.activate();
                widgetTitulosAPagar.reload();
            }).catch(function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };

    /**
     * Cancela Antecipacao de Fornecedor
     */
    self.cancelaAntecipacaoFornecedor = function(){
        ScreenService.confirmMessage('Deseja realmente cancelar a(s) antecipação(ões)?', 'question', function() {
            var widgetTitulosAPagar = templateManager.container.getWidget('TitulosAPagarGrid');

            var titulosAntecipados = widgetTitulosAPagar.getCheckedRows().filter(function(titulo){
                return ((titulo.IDSTATBPAG == 'A') && (titulo.IDANTECIPAFORN == 'S'));
            });

            var dataSet = [titulosAntecipados];

            General.callRestEngine('fin_contaPagar#/cancelaAntecipacaoFornecedor', 'DataSet', dataSet).then(function () {
                ScreenService.showMessage('Antecipado(s) cancelada(s) com sucesso.', 'checked');
                ScreenService.closePopup();
                widgetTitulosAPagar.reload();
                
                widgetTitulosAPagar.unSelectAll();
                self.unsetStripeDataFooter();
            }).catch(function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    /**
     * Busca Padrão Filial
     * @param widget
     */
    self.buscaPadraoFilial = function(widget) {
        var route = 'fin_contaPagar#/validaFilialLogadaPorEmpresaFiltrada';
        
        widget.getField('NMFILIALRECE').reload();
        widget.getField('DSTPCTPAGAR').reload();
        
        General.callRestEngine(route, 'Row', {'CDEMPRESA': widget.currentRow.CDEMPRESA}).then(function(response_filial){
            if (response_filial.dataset.filial.length > 0){
                var filial   = response_filial.dataset.filial[0];
                widget.currentRow.CDFILIRECE      = filial.CDFILIAL;
                widget.currentRow.NMFILIALRECE    = filial.NMFILIAL;
                widget.currentRow.CDEMPRESARECE   = filial.CDEMPRESA;
                widget.currentRow.CDINSCESTARECE  = filial.CDINSCESTA;
                widget.currentRow.CDINSCMUNIRECE  = filial.CDINSCMUNI;
                widget.currentRow.NRTAMNUMNFUTDFE = filial.NRTAMNUMNFUTDFE;
                widget.currentRow.DSTPCTPAGAR     = null;
                
                self.changeFilial();
            }else{
                widget.currentRow.CDFILIRECE      = null;
                widget.currentRow.NMFILIALRECE    = null;
                widget.currentRow.CDEMPRESARECE   = null;
                widget.currentRow.CDINSCESTARECE  = null;
                widget.currentRow.CDINSCMUNIRECE  = null;
                widget.currentRow.NRTAMNUMNFUTDFE = null;
                widget.currentRow.NRNOTAFISC      = null;
                widget.currentRow.CDSERIE         = null;
                widget.currentRow.DSSERIE         = null;
                widget.currentRow.DSTPCTPAGAR     = null;
            }
        }).catch(function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    /**
     * Altera Ajuste Título
     * @param widget
     */
    self.alteraAjusteTitulo = function(widget){
        if(widget.currentRow.DSAJUCTPAG)
            self.alteraValorAjuste(widget);
    };

    /**
     * Altera Valor Desejavel Título
     * @param widget
     */
    self.alteraValorDesejavel = function(widget){
        var vrajbolpag = 0;
    
        if(widget.currentRow.IDAJUCTPAG == 'A') {
            if ((self.formataValor(widget.currentRow.VRDESEBPAG)) < (self.formataValor(widget.currentRow.VRATUABPAG))){
                vrajbolpag = 0;
                widget.currentRow.VRDESEBPAG = widget.currentRow.VRATUABPAG;
                ScreenService.showMessage('O valor desejável não pode ser menor que o valor atual');
            }
            else if (widget.currentRow.VRDESEBPAG == "") {
                vrajbolpag = 0;
                widget.currentRow.VRDESEBPAG = widget.currentRow.VRATUABPAG;
            } else if ((self.formataValor(widget.currentRow.VRDESEBPAG)) >= (self.formataValor(widget.currentRow.VRATUABPAG))) {
                vrajbolpag = ((self.formataValor(widget.currentRow.VRDESEBPAG) - self.formataValor(widget.currentRow.VRATUABPAG)));
            }
        }
        else if(widget.currentRow.IDAJUCTPAG == 'D') {
            if((self.formataValor(widget.currentRow.VRDESEBPAG)) <= (self.formataValor(widget.currentRow.VRATUABPAG))){
                vrajbolpag = (self.formataValor(widget.currentRow.VRATUABPAG) - self.formataValor(widget.currentRow.VRDESEBPAG));
            }
            else if(widget.currentRow.VRDESEBPAG && widget.currentRow.VRDESEBPAG != "") {
                vrajbolpag = 0;
                widget.currentRow.VRDESEBPAG = widget.currentRow.VRATUABPAG;
                ScreenService.showMessage('O valor desejável não pode ser maior que o valor atual');
            } else if(widget.currentRow.VRDESEBPAG == ""){
                widget.currentRow.VRDESEBPAG = widget.currentRow.VRATUABPAG;
            }
        }

        vrajbolpag = vrajbolpag > 0 ? vrajbolpag : 0;

        widget.currentRow.VRAJBOLPAG = parseFloat(vrajbolpag).toFixed(2);
    };
    
    /**
     * Altera Valor Desejavel Título
     * @param widget
     */
    self.alteraValorAjuste = function(widget){
        var vrdesebpag = widget.currentRow.VRATUABPAG;

        if(widget.currentRow.IDAJUCTPAG == 'A') {
            if(widget.currentRow.VRAJBOLPAG && widget.currentRow.VRAJBOLPAG != "") {
                vrdesebpag = (self.formataValor(widget.currentRow.VRATUABPAG) + self.formataValor(widget.currentRow.VRAJBOLPAG));
            } else {
                vrdesebpag = widget.currentRow.VRATUABPAG;
            } 
        }
        else if(widget.currentRow.IDAJUCTPAG == 'D') {
            if((self.formataValor(widget.currentRow.VRAJBOLPAG)) <= (self.formataValor(widget.currentRow.VRATUABPAG))){
                vrdesebpag = (self.formataValor(widget.currentRow.VRATUABPAG) - self.formataValor(widget.currentRow.VRAJBOLPAG));
            } 
            else if(widget.currentRow.VRAJBOLPAG && widget.currentRow.VRAJBOLPAG != "") {
                vrdesebpag = widget.currentRow.VRATUABPAG;
                widget.currentRow.VRAJBOLPAG = 0;
                ScreenService.showMessage('O valor do ajuste não pode ser maior que o valor atual');
            }
        }

        vrdesebpag = vrdesebpag > 0 ? vrdesebpag : 0;

        widget.currentRow.VRDESEBPAG = vrdesebpag.toFixed(2);
    };


    /**
     * Formata Valor
     * @param valor
     */
    self.formataValor = function(valor){
        if(typeof valor == 'string')
            if(valor.indexOf(',') >= 0)
                valor = valor.replace('.','').replace(',','.');
                
        valor = parseFloat(parseFloat(valor).toFixed(2));

        return valor;
    };

    /**
     * Formata Valor
     * @param valor
     */
    self.abreRateioContaUnica = function(){
        var widgetContaDocumentos  = templateManager.container.getWidget('ContaDocumentosGrid');

        if(widgetContaDocumentos.dataSource.data.length == 1){
            if(widgetContaDocumentos.currentRow.NRLANBOLPAG != widgetContaDocumentos.dataSource.data[0].NRLANBOLPAG){
                widgetContaDocumentos.currentRow = widgetContaDocumentos.dataSource.data[0]?widgetContaDocumentos.dataSource.data[0]:{};
                widgetContaDocumentos.afterMoveRow(widgetContaDocumentos);
                widgetContaDocumentos.view();
            }
        }

    };

    /**
     * Altera Descrição Títulos a Pagar
     */
    self.changeDsboletpag = function(change) {
    	var widgetTitulosAPagar = templateManager.container.getWidget('TitulosAPagarGrid');
    	widgetTitulosAPagar.currentRow.__changeDsboletpag = change;
    };









    /**
     * Busca Parametrização Tipo de Conta
     * @param args
     * @param widget_name
     */
    self.changeTipoContaDoc = function() {
        var widgetDocumentos = templateManager.container.getWidget('DocumentosForm');
        var widgetParcelamentoDoc = templateManager.container.getWidget('ParcelamentoDocGrid');

        var dscontapag = widgetDocumentos.currentRow.DSDEFACTPAG?widgetDocumentos.currentRow.DSDEFACTPAG:widgetDocumentos.currentRow.DSTPCTPAGAR;

        widgetParcelamentoDoc.dataSource.data.forEach(function(data){
            data.DSCONTAPAG = dscontapag;
        });

    };


    /**
     * Adicionar Parcela Títulos a Pagar
     * @param args
     */
    self.adicionarParcela = function(args){
        var widgetParcelamento = args.owner.widget;
        var widgetDocumentos   = args.owner.widget.getParent();
        
        if(widgetDocumentos.currentRow.VRNOTAFISC <= 0) {
            ScreenService.showMessage('Operação bloqueada. Informe o valor do documento.');
            return;
        }
        
        if(widgetDocumentos.currentRow.IDSTATUS == 'V') {
            ScreenService.showMessage('Operação bloqueada. Não é possível realizar parcelamento com o título de tipo previsto.');
            return;
        }
        
        widgetParcelamento.newRow();
        self.habDesCampos('DocumentosForm', true);
        
        if(widgetParcelamento.dataSource.data.length == 2){
            widgetParcelamento.dataSource.data[0].NRPARCBOLPAG = '01';
            widgetParcelamento.dataSource.data[0].NRPARCBOLPAGVISU = '001';
        }
        
        
        var nrparcbolpag     = retornaNumeroParcela(widgetParcelamento.dataSource.data.length);
        var nrparcbolpagvisu = ("00" + (widgetParcelamento.dataSource.data.length)).slice(-3);
        var dscontapag   = widgetParcelamento.dataSource.data[widgetParcelamento.dataSource.data.length - 2].DSCONTAPAG;
        var vrtotalparc  = valorTotalParcelamento(widgetParcelamento);
        var vttotbolpag  = widgetDocumentos.currentRow.VRNOTAFISC;
        var vrdifbolparc = self.formataValor(vttotbolpag - vrtotalparc);
        
        dscontapag = (!dscontapag)?(widgetDocumentos.currentRow.DSDEFACTPAG?widgetDocumentos.currentRow.DSDEFACTPAG:widgetDocumentos.currentRow.DSTPCTPAGAR):dscontapag;

        widgetParcelamento.currentRow.NRPARCBOLPAG = nrparcbolpag;
        widgetParcelamento.currentRow.NRPARCBOLPAGVISU = nrparcbolpagvisu;
        widgetParcelamento.currentRow.DSCONTAPAG   = dscontapag;
        widgetParcelamento.currentRow.IDEXCLUIR    = 'S';
        widgetParcelamento.currentRow.VRFINALBPAG  = (vrdifbolparc >= 0)?vrdifbolparc:0;
        
        widgetParcelamento.dataSource.data[widgetParcelamento.dataSource.data.length - 2].IDEXCLUIR = null;
        
    };
    
    
    
    /**
     * Confirma Nova Parcela Títulos a Pagar
     * @param widget
     * @param widgetTitulosAReceber
     */
    var retornaNumeroParcela = function(nrparcbolpag){
        
        nrparcbolpag = ("000" + nrparcbolpag).slice(-3);
        
        var unidade = nrparcbolpag.substr(-1, 1);
        var centena = nrparcbolpag.substr(-3, 1);
        
        if(centena != '0'){
            if(nrparcbolpag != '360'){
                var letras = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'X', 'W', 'Y', 'Z'];
            
                var posicao = parseInt(nrparcbolpag.substr(-3, 2)) - 10;
                nrparcbolpag = letras[posicao] + unidade;
            }else nrparcbolpag = 'AA';
        }
            
        return nrparcbolpag.slice(-2);
    };
    
    /**
     * Excluir Parcela Títulos a Pagar
     * @param widget
     */
    self.excluirParcela = function(widget){
        widget.list();
        self.habDesCampos('DocumentosForm', false);
        
        widget.dataSource.data.splice(widget.currentRow.__index, 1);
        
        widget.dataSource.data.forEach(function(data){
            if(data.hasOwnProperty('DSCONTAPAG_inline'))
                delete data.DSCONTAPAG_inline;
            if(data.hasOwnProperty('DTVENBOLPAG_inline'))
                delete data.DTVENBOLPAG_inline;
            if(data.hasOwnProperty('VRFINALBPAG_inline'))
                delete data.VRFINALBPAG_inline;
            if(data.hasOwnProperty('changed_DSCONTAPAG'))
                delete data.changed_DSCONTAPAG;
            if(data.hasOwnProperty('changed_VRFINALBPAG'))
                delete data.changed_VRFINALBPAG;
            if(data.hasOwnProperty('changed_DTVENBOLPAG'))
                delete data.changed_DTVENBOLPAG;
            if(data.hasOwnProperty('changed'))
                delete data.changed;
            if(data.hasOwnProperty('__is_new'))
                delete data.__is_new;
        });
        
        var vrtotalparc = 0;
        var vrnotafisc  = widget.getParent().currentRow.VRNOTAFISC;
        
        widget.dataSource.data.forEach(function(data){
            vrtotalparc += self.formataValor(data.VRFINALBPAG);
        });
        
        var vrdifparcnf = (vrnotafisc - vrtotalparc); 
        
        widget.dataSource.data[widget.currentRow.__index - 1].VRFINALBPAG = (vrdifparcnf > 0)?self.formataValor(widget.dataSource.data[widget.currentRow.__index - 1].VRFINALBPAG) + vrdifparcnf:widget.dataSource.data[widget.currentRow.__index - 1].VRFINALBPAG;
        
        if(widget.currentRow.__index == '1')
            widget.dataSource.data[widget.currentRow.__index - 1].NRPARCBOLPAG = "00";
        else widget.dataSource.data[widget.currentRow.__index - 1].IDEXCLUIR = 'S';
    };
    
        /**
     * Excluir Parcela Títulos a Pagar
     * @param widget
     */
    self.cancelarParcela = function(widget){
        widget.list();
        self.habDesCampos('DocumentosForm', false);
        
        widget.dataSource.data.forEach(function (data){
            if(data.__is_new == true)
                widget.dataSource.data.splice(data.__index, 1);
        });
        
        widget.dataSource.data.forEach(function(data){
            if(data.hasOwnProperty('DSCONTAPAG_inline'))
                delete data.DSCONTAPAG_inline;
            if(data.hasOwnProperty('DTVENBOLPAG_inline'))
                delete data.DTVENBOLPAG_inline;
            if(data.hasOwnProperty('VRFINALBPAG_inline'))
                delete data.VRFINALBPAG_inline;
                
            if(data.hasOwnProperty('changed_DSCONTAPAG')){
                data.DSCONTAPAG = data.changed_DSCONTAPAG;
                delete data.changed_DSCONTAPAG;
            }
            if(data.hasOwnProperty('changed_VRFINALBPAG')){
                data.VRFINALBPAG = data.changed_VRFINALBPAG;
                delete data.changed_VRFINALBPAG;
            }
            if(data.hasOwnProperty('changed_DTVENBOLPAG')){
                data.DTVENBOLPAG = data.changed_DTVENBOLPAG;
                delete data.changed_DTVENBOLPAG;
            }
            
            if(data.hasOwnProperty('changed'))
                delete data.changed;
            if(data.hasOwnProperty('__is_new'))
                delete data.__is_new;
        });
        
        if(widget.currentRow.__index == '1')
            widget.dataSource.data[widget.dataSource.data.length - 1].NRPARCBOLPAG = "00";
        else if (widget.currentRow.__index != '0')
            widget.dataSource.data[widget.dataSource.data.length - 1].IDEXCLUIR = 'S';
    };
    
    /**
     * Valida Campos Parcelamento Títulos a Pagar
     * @param widget
     */
    self.validaCamposParcelamento = function(widget){
        var deferred = ZHPromise.defer();
        widget.dataSource.data.forEach(function(data){
            if(!data.DTVENBOLPAG){
                ScreenService.showMessage('Operação bloqueada. Preencha o campo de vencimento.');
                deferred.reject();
            }
            if(data.VRFINALBPAG <= 0){
                ScreenService.showMessage('Operação bloqueada. Valor da parcela deve ser maior que zero.');
                deferred.reject();
            }
        });
        deferred.resolve();
        return deferred.promise;
    };
    
    /**
     * Excluir Parcela Títulos a Pagar
     * @param widget
     */
    self.salvarParcela = function(widget){
        self.validaCamposParcelamento(widget).then(function(){
            self.habDesCampos('DocumentosForm', false);
            widget.list();
            
            widget.dataSource.data.forEach(function(data){
                if(data.DSCONTAPAG_inline != undefined)
                    delete data.DSCONTAPAG_inline;
                if(data.DTVENBOLPAG_inline != undefined)
                    delete data.DTVENBOLPAG_inline;
                if(data.VRFINALBPAG_inline != undefined)
                    delete data.VRFINALBPAG_inline;
                if(data.changed_DSCONTAPAG != undefined)
                    delete data.changed_DSCONTAPAG;
                if(data.changed_VRFINALBPAG != undefined)
                    delete data.changed_VRFINALBPAG;
                if(data.changed_DTVENBOLPAG != undefined)
                    delete data.changed_DTVENBOLPAG;
                if(data.changed != undefined)
                    delete data.changed;
                if(data.__is_new != undefined)
                    delete data.__is_new;
            });
        });
    };

    /**
     * Excluir Parcela Títulos a Pagar/Pagos
     * @param widget
     */
    self.habDesCampos = function(widget_name, read_only){
        var widget = templateManager.container.getWidget(widget_name);
        
        widget.fields.forEach(function(field){
            field.readOnly = read_only;
        });
    };
    
    this.setaMascCnpjCpfFornecedor = function(widget) {
	    var data = widget.dataSource.data;
	    var inscFormatada;
	    data.forEach(function(value){
	        if(value.NRINSJURFORN.length === 14) inscFormatada = value.NRINSJURFORN.substr(0, 2) + '.' + value.NRINSJURFORN.substr(2, 3) + '.' + value.NRINSJURFORN.substr(5, 3) + '/' + value.NRINSJURFORN.substr(8, 4) + '-' + value.NRINSJURFORN.substr(12, 2);
          else if(value.NRINSJURFORN.length === 11) inscFormatada = value.NRINSJURFORN.substr(0, 3) + '.' + value.NRINSJURFORN.substr(3, 3) + '.' + value.NRINSJURFORN.substr(6, 3) + '-' + value.NRINSJURFORN.substr(9, 2);
          else inscFormatada = null;
          value.NRINSJURFORN = inscFormatada?inscFormatada:value.NRINSJURFORN;
	    });
	};
	
	this.changeHeaderValues = function(widget){
        var codigo; 
        var nmempresa = widget.owner.appliedFilter.FILTER_ROW.NMEMPRESA;
        widget.owner.dataSourceFilter.forEach(function(empresa){
           if(empresa.name == 'CDEMPRESA'){
               codigo = empresa.value;
           } 
        });
        
        var cdempresa = {
            'label' : "Empresa",
            'value' : "é igual a. ".concat(codigo).concat(' - ').concat(nmempresa)
        };
        
        var filter = widget.e.metadata.filter;
        var newFilter = [];
        newFilter.push(cdempresa);
        filter.forEach(function(x){
            if((x.value != "é igual a.") && (x.label != "Código Empresa")){
                newFilter.push(x);
            }
        });
        
        var correctFilter = [];
        var value;
        newFilter.forEach(function(aux){
            if(aux.value.match(/é igual a./)){
                value = aux.value.substr(11);
                aux.value = value;
                correctFilter.push(aux);
            }else if(aux.value.match(/está entre/)){
                value = aux.value.substr(11);
                aux.value = value;
                correctFilter.push(aux);
            }
        });
        
        widget.e.metadata.filter = correctFilter;    
        
    };
    
    /**
     * Desabilita PopUp
     * @param widget
     */
    self.desabilitaPopUp = function (widget_name){
        var widget = templateManager.container.getWidget(widget_name);
        widget.isVisible = false;
        ScreenService.closePopup(widget);
    };
    
    
    
    /**
     * Borderô Remessa Titulo a Pagar
     */
    self.borderoRemessa = function(){
        var widgetTitulosAPagar  = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetBorderoTabbed  = templateManager.container.getWidget('BorderoRemessaTabbed');
        var widgetBorderoGrid    = templateManager.container.getWidget('BorderoRemessaGrid');
        
        var titulosRemessa = widgetTitulosAPagar.getCheckedRows().filter(function(titulo){
            return (titulo.NRCNABPAGREM);
        });
        
        var cdempresa = titulosRemessa[0].CDEMPRESA;
        var remessas  = "_";
        
        titulosRemessa.forEach(function(value){
            remessas = remessas.concat(value.NRCNABPAGREM.concat('_'));
        });
        
        widgetBorderoGrid.dataSourceFilter[0].value = cdempresa;
        widgetBorderoGrid.dataSourceFilter[1].value = remessas;
        
        ScreenService.closePopup();
        widgetBorderoTabbed.isVisible = true;
        widgetBorderoTabbed.editing = true;
        ScreenService.openSwipe(widgetBorderoTabbed);
        widgetBorderoGrid.reload();
    };
    
    self.onChangeEmpresaFilter = function(widget){
        var cdempresa = widget.currentRow.CDEMPRESA;
        var cdtpctpagar = widget.getField('CDTPCTPAGAR');
        
        cdtpctpagar.setValue("");
        cdtpctpagar.dataSourceFilter[0].value = cdempresa;
        cdtpctpagar.reload();
    };
    
    /**
     * Cadastrar Guia de Tributo
     */
    self.cadastrarGuiaTributo = function(){
        
        var widgetTitulosAPagar = templateManager.container.getWidget('TitulosAPagarGrid');
        var checkedrows = widgetTitulosAPagar.getCheckedRows();

        var titulosGuiaTributo = checkedrows.filter(function(boleto){
            return ['B', 'R', 'P', 'G', 'I', 'H', 'J', 'K', 'N', 'Q', 'U', 'V', 'X'].includes(boleto.IDBAIXAUTILP);
        });
        
        if(checkedrows.length > 0) {
            var widgetCadastrarGuiaTributo = templateManager.container.getWidget('CadastrarGuiaTributoForm');
            widgetCadastrarGuiaTributo.isVisible = true;
            
            if(checkedrows.length >= 2){

                widgetCadastrarGuiaTributo.getField('CDRECEITAGUIA').setValue(null);
                widgetCadastrarGuiaTributo.getField('DTAPURACGUIA').setValue(null);
                widgetCadastrarGuiaTributo.getField('NRREFEGUIA').setValue(null);
                widgetCadastrarGuiaTributo.getField('VRPERCENTTTRIB').setValue(null);
                widgetCadastrarGuiaTributo.getField('VROUTRENTGUIA').setValue(null);

            } else{

                var param = {
                  "NRLANBOLPAG":  titulosGuiaTributo[0].NRLANBOLPAG
                };

                General.callRestEngine('fin_contaPagar#/verificaDadosGuiaTributo', 'Row', param).then(function(result){
                    var dadosGuia = result.dataset.dadosGuia;
                    widgetCadastrarGuiaTributo.getField('CDRECEITAGUIA').setValue(dadosGuia[0].CDRECEITAGUIA);
                    widgetCadastrarGuiaTributo.getField('DTAPURACGUIA').setValue(dadosGuia[0].DTAPURACGUIA);
                    widgetCadastrarGuiaTributo.getField('NRREFEGUIA').setValue(dadosGuia[0].NRREFEGUIA);
                    widgetCadastrarGuiaTributo.getField('VRPERCENTTTRIB').setValue(dadosGuia[0].VRPERCENTTRIB);
                    widgetCadastrarGuiaTributo.getField('VROUTRENTGUIA').setValue(dadosGuia[0].VROUTRENTGUIA);
                });
            }
            
            ScreenService.openPopup(widgetCadastrarGuiaTributo);

        }else ScreenService.showMessage('Operação bloqueada. Não há título(s) para cadastrar guia de tributo.');
        
    };
    
    /**
     * Confirmar Cadastro Guia de Tributo
     */
    self.confirmarCadastroGuiaTributo = function(){
        
        var widgetCadastrarGuiaTributo = templateManager.container.getWidget('CadastrarGuiaTributoForm');
        
        if(widgetCadastrarGuiaTributo.isValid()){
            
            var widgetTitulosAPagar = templateManager.container.getWidget('TitulosAPagarGrid');
            var checkedrows = widgetTitulosAPagar.getCheckedRows();
            var titulosGuiaTributo = checkedrows.filter(function(boleto){
                return ['G','H','I','U','V','K','J','X'].includes(boleto.IDBAIXAUTILP);
            });
            
            var route = 'fin_contaPagar#/cadastrarGuiaTributo';
            
            var dataset = [
                widgetCadastrarGuiaTributo.currentRow,
                titulosGuiaTributo
            ];
            
            General.callRestEngine(route, 'DataSet', dataset).then(function (success) {
                
                ScreenService.showMessage("Cadastro(s) de Guia de Tributo realizado com sucesso.");
                
                widgetCadastrarGuiaTributo.isVisible = false;
                ScreenService.closePopup(widgetCadastrarGuiaTributo);
                ScreenService.closePopup();
                
                widgetTitulosAPagar.unSelectAll();
                self.unsetStripeDataFooter();
                
                
            });
        }
        
    };
    
    /**
     * Cancelar Cadastro Guia de Tributo
     */
    self.cancelarCadastroGuiaTributo = function(){

        var widgetTitulosAPagar = templateManager.container.getWidget('TitulosAPagarGrid');
        var widgetCadastrarGuiaTributo = templateManager.container.getWidget('CadastrarGuiaTributoForm');
        widgetCadastrarGuiaTributo.isVisible = false;
        
        ScreenService.closePopup(widgetCadastrarGuiaTributo);
        ScreenService.closePopup();
        
    };

    /**
     * Novo Ajuste Titulo Baixa
     * @param widget
     */
    self.novoAjusteTituloBaixa = function(){
        var widgetTitulosBaixa      = templateManager.container.getWidget('NewTitulosBaixaGrid');
        var widgetAjusteTituloBaixa = templateManager.container.getWidget('AjusteTituloBaixaGrid');

        widgetAjusteTituloBaixa.newRow();
        widgetAjusteTituloBaixa.getField('NRORG').setValue(widgetTitulosBaixa.currentRow.NRORG);
        widgetAjusteTituloBaixa.getField('CDFILIAL').setValue(widgetTitulosBaixa.currentRow.CDFILIAL);
        widgetAjusteTituloBaixa.getField('NRLANBOLPAG').setValue(widgetTitulosBaixa.currentRow.NRLANBOLPAG);
        widgetAjusteTituloBaixa.getField('IDOPERACAO').setValue('I');
        widgetAjusteTituloBaixa.getField('IDORIGAJBPAG').setValue('2');
    };
    
    
    
    /**
     * Salva Ajuste Titulo Baixa
     * @param args
     */
    self.salvaAjusteTituloBaixa = function(){
        var widgetBaixa             = templateManager.container.getWidget('NewBaixaTabbed');
        var widgetTitulosBaixa      = templateManager.container.getWidget('NewTitulosBaixaGrid');
        var widgetAjusteTituloBaixa = templateManager.container.getWidget('AjusteTituloBaixaGrid');
        
        if(widgetAjusteTituloBaixa.isValid()){
            var currentRowAjuste = widgetAjusteTituloBaixa.currentRow;
            var dataAjuste = widgetAjusteTituloBaixa.dataSource.data;
            
            var cdajuctpag = dataAjuste.filter(function(filter) {
                return (filter.CDAJUCTPAG == currentRowAjuste.CDAJUCTPAG);
            });
            
            if(cdajuctpag.length == 2){
                ScreenService.showMessage('Operação bloqueado. Ajuste já cadastrado.');
                return;
            }
            
            localStorageEngine.getDataSource('fin_contaPagar#/ajbolpag_tipoajpagar').then(
                function (dataLocal) {
                    // Valor de Ajuste do Título
                    var idajuctpag  = widgetAjusteTituloBaixa.currentRow.IDAJUCTPAG;
                    idajuctpag      = (idajuctpag == 'A')?'A':'D';
                    var vrajbolpag  = parseFloat(widgetAjusteTituloBaixa.currentRow.VRAJBOLPAG);
                    vrajbolpag      = (idajuctpag == 'A')?vrajbolpag:-(vrajbolpag);
        
                    // Atualiza Valor Líquido do Título
                    var vrfinalbpag = parseFloat(widgetTitulosBaixa.currentRow.VRFINALBPAG);
                    vrfinalbpag    += vrajbolpag;
                    
                    if(vrfinalbpag < 0){
                        ScreenService.showMessage('Operação bloqueada. Valor do título não pode ficar negativo.');
                        return;
                    }
                    
                    widgetTitulosBaixa.currentRow.VRFINALBPAG = vrfinalbpag;
                    
                    // Atualiza Valor Pago do Título
                    var vrpago = parseFloat(widgetTitulosBaixa.currentRow.VRPAGO);
                    vrpago    += vrajbolpag;
                    
                    if(vrpago < 0){
                        ScreenService.showMessage('Operação bloqueada. Valor pago não pode ficar negativo.');
                        return;
                    }
                    
                    widgetTitulosBaixa.currentRow.VRPAGO = vrpago;
                    
                    /* Alterado com a marcação da baixa */
                    // Atuliza Valor da Baixa
                    //var vrbaixapag = parseFloat(widgetBaixa.currentRow.VRBAIXAPAG);
                    //vrbaixapag    += vrajbolpag;
                    //widgetBaixa.currentRow.VRBAIXAPAG = vrbaixapag;
                    
                    
                    dataLocal.push(currentRowAjuste);
                    localStorageEngine.setDataSource('fin_contaPagar#/ajbolpag_tipoajpagar', dataLocal);
                    
                    ScreenService.goBack();
                    ScreenService.showMessage('Registro salvo com sucesso.');
                    widgetTitulosBaixa.currentRow.__ajusteAtualizado = true;
                }
            );
            

        }
    };
    
    /**
     * Cencelar Ajuste Título Baixa
     * @param args
    */
    self.cancelarAjusteBoleto = function(args){
        General.backOrCancel(args);
    };
    
    /**
     * Exclui Ajuste Título Baixa
     * @param args
    */
    self.excluiAjusteTituloBaixa = function(args){
        var widget             = args.owner.widget;
        var widgetBaixa        = templateManager.container.getWidget('NewBaixaTabbed');
        var widgetTitulosBaixa = templateManager.container.getWidget('NewTitulosBaixaGrid');

        if(widget.currentRow.IDORIGAJBPAG == '4') {
            ScreenService.showMessage('Operação bloqueada. Ajuste originado de uma compensação não pode ser excluído.');
            return;
        }

        ScreenService.confirmMessage('Deseja realmente excluir o ajuste?', 'question', function() {
            
            localStorageEngine.getDataSource('fin_contaPagar#/ajbolpag_tipoajpagar').then(
                function (dataLocal) {
                    for(var i in dataLocal){
                        if((dataLocal[i].CDFILIAL    == widget.currentRow.CDFILIAL   ) && 
                           (dataLocal[i].NRLANBOLPAG == widget.currentRow.NRLANBOLPAG) && 
                           (dataLocal[i].CDAJUCTPAG  == widget.currentRow.CDAJUCTPAG )){
                            dataLocal[i].IDOPERACAO = 'E';
                            widget.currentRow.IDOPERACAO = 'E';
                        }
                    }
                    
                    
                    
                     // Valor de Ajuste do Título
                    var idajuctpag  = widget.currentRow.IDAJUCTPAG;
                    idajuctpag      = (idajuctpag == 'A')?'A':'D';
                    var vrajbolpag  = parseFloat(widget.currentRow.VRAJBOLPAG);
                    vrajbolpag      = (idajuctpag == 'A')?-(vrajbolpag):vrajbolpag;
        
                    // Atualiza Valor Líquido do Título
                    var vrfinalbpag = parseFloat(widgetTitulosBaixa.currentRow.VRFINALBPAG);
                    vrfinalbpag    += vrajbolpag;
                    
                    if(vrfinalbpag < 0){
                        ScreenService.showMessage('Operação bloqueada. Valor do título não pode ficar negativo.');
                        return;
                    }
                    
                    widgetTitulosBaixa.currentRow.VRFINALBPAG = vrfinalbpag;
                    
                    // Atualiza Valor Pago do Título
                    var vrpago = parseFloat(widgetTitulosBaixa.currentRow.VRPAGO);
                    vrpago    += vrajbolpag;
                    
                    if(vrpago < 0){
                        ScreenService.showMessage('Operação bloqueada. Valor pago não pode ficar negativo.');
                        return;
                    }
                    
                    widgetTitulosBaixa.currentRow.VRPAGO = vrpago;
                    
                    /* Alterado com a marcação da baixa */
                    // Atuliza Valor da Baixa
                    //var vrbaixapag = parseFloat(widgetBaixa.currentRow.VRBAIXAPAG);
                    //vrbaixapag    += vrajbolpag;
                    //widgetBaixa.currentRow.VRBAIXAPAG = vrbaixapag;
                    
                    localStorageEngine.setDataSource('fin_contaPagar#/ajbolpag_tipoajpagar', dataLocal).then(
                        function () {
                            templateManager.container.getWidget('AjusteTituloBaixaGrid').reload();
                        }
                    );
                    
                    ScreenService.goBack();
                    ScreenService.showMessage('Registro excluído com sucesso.');
                    widgetTitulosBaixa.currentRow.__ajusteAtualizado = true;
                }
            );
        });
    };

    /**
     * Altera Tipo de Prorrogação
     */
    self.alteraTipoProrrogacao = function(){
        var widgetProrrogar = templateManager.container.getWidget('ProrrogarForm');
        var idtppror        = widgetProrrogar.getField('IDTPPROR').value();

        if(idtppror == 'F') {
            widgetProrrogar.getField('DTVENBOLPAG').readOnly = false;
            widgetProrrogar.getField('DTVENBOLPAG').validations.required = true;
            widgetProrrogar.getField('DTVENBOLPAG').setValue('');
            
            widgetProrrogar.getField('NRDIASVENC').readOnly  = true;
            delete widgetProrrogar.getField('NRDIASVENC').validations.required;
            delete widgetProrrogar.getField('NRDIASVENC').validations.min;
            widgetProrrogar.getField('NRDIASVENC').clearValue();
        }else{
            widgetProrrogar.getField('DTVENBOLPAG').readOnly = true;
            delete widgetProrrogar.getField('DTVENBOLPAG').validations.required;
            widgetProrrogar.getField('DTVENBOLPAG').setValue('');
            
            widgetProrrogar.getField('NRDIASVENC').readOnly  = false;
            widgetProrrogar.getField('NRDIASVENC').validations.required = true;
            widgetProrrogar.getField('NRDIASVENC').validations.min = {"limit" : 0};
            widgetProrrogar.getField('NRDIASVENC').setValue(30);
        }
        
        templateManager.updateTemplate();
    };
    
    self.validaParcelamentoManual = function(widgetTitulosAPagar, parcelamento){
        var deferred = ZHPromise.defer();
        
        var currentRowTitulosAPagar = widgetTitulosAPagar.currentRow;
        var mensagemValor = false;
        var valortotparc = 0;
        var parcelamentoPermitido = true;
        var parcelas = parcelamento.dataSource.data;
        var totalTitulo = parcelas[0].VRTOTBOLPAG;
        
        for (var i = 0; i < parcelas.length && parcelamentoPermitido; i++){
            if ($.currency.unmaskString(parcelas[i].VRFINALBPAG) <= 0) {
                parcelamentoPermitido = false;
                deferred.reject('Operação bloqueada. Existe(m) parcela(s) menor(es) ou igual(is) a zero.');
            }
            valortotparc += self.formataValor(parcelas[i].VRFINALBPAG);
        }
        
        totalTitulo  = self.formataValor(totalTitulo);
        valortotparc = self.formataValor(valortotparc);

        if((totalTitulo != valortotparc) && (parcelamentoPermitido) ){
            if((currentRowTitulosAPagar.IDSISTEMA == 'PAG') && (currentRowTitulosAPagar.IDSTATBPAG == 'A') && (currentRowTitulosAPagar.IDASSOCBOLPAG == 'N')){
                var mensagemConfirma =
                    'Valor total das parcelas difere do valor total do título.<br/><br/>' +
                    'Valor total do Título: ' + parseFloat(totalTitulo).toFixed(2) + '<br/>' +
                    'Valor total das Parcelas: ' + parseFloat(valortotparc).toFixed(2) + '<br/><br/>' +
                    'Deseja alterar o valor do documento para prosseguir?';
                ScreenService.confirmMessage(mensagemConfirma, 'question',
                    function () {
                        if(parcelas.length < 2){
                            parcelas[0].NRPARCBOLPAG = '00';
                        }
                        deferred.resolve(parcelamentoPermitido);
                    },
                    function() {
                        parcelamentoPermitido = false;
                        deferred.reject(parcelamentoPermitido);
                    }
                );
            }else{
                
                
                parcelamentoPermitido = false;
                deferred.reject(
                    'Operação bloqueada. Valor total das parcelas difere do valor total do título.<br/><br/>' +
                    'Valor total do Título: ' + totalTitulo + '<br/>' +
                    'Valor total das Parcelas: ' + valortotparc
                );
            }
        }else if (parcelamentoPermitido){
            if(parcelas.length < 2){
                ScreenService.showMessage('Operação bloqueada. Continue o parcelamento para finalização.');
                return;
            }
            deferred.resolve(parcelamentoPermitido);
        }
        return deferred.promise;
    };
    
    self.setCdfornecedor = function (widget){
        widget.currentRow.CDFORNECED = widget.dataSourceFilter[0].value;
    };
    
    self.salvarCodigoPix = function(widget){
        var TitulosAPagarGrid = templateManager.container.getWidget('TitulosAPagarGrid');
        if(!widget.isValid()){
            ScreenService.showMessage("Preencha todos os campos obrigatórios!");   
        }else{
            widget.currentRow.CDFORNECED = TitulosAPagarGrid.currentRow.CDFORNECED;
            widget.currentRow.__is_new = true;
            widget.currentRow.CDCHAVEPIX = widget.currentRow.CDCHAVEPIX.trim();
            var chave = {}, CDCHAVEPIX = widget.currentRow.CDCHAVEPIX;
            
            switch (widget.currentRow.IDCHAVEPIX) {
                case '01':
                    chave.valid = CDCHAVEPIX.length > 8 && typeof(parseInt(CDCHAVEPIX)) === 'number';
                    if(!chave.valid){
                        chave.message = "Celular inválido.";
                    }   
                    break;
                case '02':
                    chave = ValidationEngine.mail(CDCHAVEPIX, {});
                    break;
                case '03':
                    if(CDCHAVEPIX.length == 11){
                        chave.valid = General.validateCPF(CDCHAVEPIX);
                    }else if(CDCHAVEPIX.length == 14){
                        chave.valid = General.validateCNPJ(CDCHAVEPIX);
                    }else{
                        chave.valid = false;
                    }
                    if(!chave.valid){
                        chave.message = "CPF/CNPJ inválido.";
                    }   
                    break;
                
                case '04':
                    var ckchex  = new RegExp('^[0-9a-fA-F-]+$');
                    chave.valid = ckchex.test(CDCHAVEPIX);
                    if(!chave.valid){
                        chave.message = "EVP inválido.";
                    }   
                    break;
                
                default:
                    chave.valid = false;
                    chave.message = "Tipo de Chave Pix inválido.";
            }
            if (widget.isValid() && chave.valid){
                ScreenService.openSwipe(widget).then(function(){
                    General.saveCrud(widget).then(function(row){
                        ScreenService.closePopup(true);
                        TitulosAPagarGrid.currentRow.CHAVEPIX = widget.currentRow.CDCHAVEPIX;
                        TitulosAPagarGrid.currentRow.DSCHAVEPIX = widget.currentRow.DSCHAVEPIX;
                        TitulosAPagarGrid.currentRow.IDCHAVEPIX = widget.currentRow.IDCHAVEPIX;
                        TitulosAPagarGrid.edit();
                        TitulosAPagarGrid.activate();
                        if(widget.relacionandoPix){
                            self.confirmaEditaTituloAPagar(TitulosAPagarGrid);
                        }
                    },
                    function(){
                        ScreenService.closeSwipe();
                        widget.activate();
                    });
                });
            }else{
                ScreenService.showMessage(chave.message||"Dados inválidos");
            }
        }
    };
    self.abrePopUpAddPIX = function(widget){
        widget.container = templateManager.container;
        widget = metaDataFactory.widgetFactory(widget);
        ScreenService.openPopup(widget);
    };
    
    self.newRowPIX = function(widget){
        widget.container = templateManager.container;

    };
    

    /**
     * Valida Tipo de Baixa
     */
    self.validaTipoBaixa = function(widget){
        if(widget.currentRow.IDBAIXAUTILP == 'P'){
            ScreenService.showMessage('Operação bloqueada. Tipo de baixa de compensação não pode ser utilizada.');
            
            widget.currentRow.NMTPBAIXAPAG = '';
            widget.currentRow.CDTPBAIXAPAG = '';
            widget.currentRow.IDBAIXAUTILP = '';
        }
    };
    
    /**
     * Altera Vencimento Titulo A Pagar
     * @param args
     */
    self.alteraVencimento = function(){
        var widget = templateManager.container.getWidget('TitulosAPagarGrid');
        
        if((widget.backupRow.DTVENBOLPAG.substr(0, 10) != widget.currentRow.DTVENBOLPAG.substr(0, 10))){
            widget.getField('DSMOTIPROR').readOnly = false;
            if(widget.currentRow.IDSISTEMA != 'PAG'){
                widget.getField('DSMOTIPROR').validations.required = true;
            }else{
                delete widget.getField('DSMOTIPROR').validations.required;
            }
        }else{
            delete widget.getField('DSMOTIPROR').validations.required;
            widget.getField('DSMOTIPROR').readOnly = true;
            widget.getField('DSMOTIPROR').setValue('');
        }
        
        templateManager.updateTemplate();
    };
    
    self.changeChavePix = function(widget){
        if(widget.getField('IDCHAVEPIX').value() == '01'){
            widget.getField('CDCHAVEPIX').setValue('+55');
        }else{
            widget.getField('CDCHAVEPIX').setValue('');
        }
        templateManager.updateTemplate();
    };
    
    self.buildDataSourceKanban = function(){
        var widget = templateManager.container.getWidget('TitulosAPagarKanban');
        widget.dataSource.data.forEach(function (data) {
            
            var dtatual = moment().format('DD/MM/YYYY');
            var dtvenbolpag = moment(data.DTVENBOLPAG, "DD/MM/YYYY HH:mm:ss").format('DD/MM/YYYY');
            
            
            switch (data.IDSTATBPAG) {
                case 'A':
                    data.column = data.IDSTATUSPAG == 'A'? 1: 2;
                    break;
                case 'P':
                    data.column = 3;
                    break;
                case 'B':
                    data.column = 4;
                    break;
                default:
                    data.column = 1;
            }
            
            
            var vrfinalbpag = self.formataValor(data.VRFINALBPAG);
            var valor = vrfinalbpag.toLocaleString('pt-BR', {minimumFractionDigits: 2});
            
            data.label = dtvenbolpag + " - " + data.NMRAZSOCFORN + " - " + valor; 
            
            var nrinsjurforn = "CNPJ/CPF: " + self.formataCnpjCpf(data.NRINSJURFORN);
            var nrparcbolpagvisu = "Parcela: " + data.NRPARCBOLPAGVISU;
            var nmtpbaixapag = "Tipo de Baixa: " + (data.NMTPBAIXAPAG?data.NMTPBAIXAPAG:"");
            var nrdocserie = "Documento: " + data.NRDOCSERIE;
            var idstatus = "Tipo: " + (data.IDSTATUS == 'A'?'Real':'Previsto');
            var vrorigpag = self.formataValor(data.VRORIGPAG);
            vrorigpag = "Valor Original: " + vrorigpag.toLocaleString('pt-BR', {minimumFractionDigits: 2});
            
            data.description = nrinsjurforn + "<br/>" + nrparcbolpagvisu + "<br/>" + nmtpbaixapag + "<br/>" + nrdocserie + "<br/>" + idstatus + "<br/>" + vrorigpag;
            
            
            
            //Object.assign(data, {'due-date': valor});
        });
    };
    
    self.formataCnpjCpf = function(value) {
        if(value.length === 14)
             value = value.substr(0, 2) + '.' + value.substr(2, 3) + '.' + value.substr(5, 3) + '/' + value.substr(8, 4) + '-' + value.substr(12, 2);
        else if(value.length === 11)
             value = value.substr(0, 3) + '.' + value.substr(3, 3) + '.' + value.substr(6, 3) + '-' + value.substr(9, 2);
        
        return value;
	};
	
    self.beforeMoveItem = function(args, e) {
        var widget = templateManager.container.getWidget('TitulosAPagarKanban');
        widget.reload();
        
        ScreenService.showMessage('Operação bloqueda. Não é possível realizar alterações por movimentação, no momento. Em breve, estaremos disponibilizando a função.');
	};
	
	 /**
     * Edita Baixa Pagamento
     * @param widget
     */
    self.editBaixaPagamento = function(widget){
        General.edit(widget);
        
        var widgetNewBaixaTabbed = templateManager.container.getWidget('NewBaixaTabbed');
        var widgetNewTitulosBaixaGrid = templateManager.container.getWidget('NewTitulosBaixaGrid');

        var idbaixautilp = widgetNewBaixaTabbed.getField('IDBAIXAUTILP').value();

        if((idbaixautilp == 'M') || (idbaixautilp == 'A')) {
            widgetNewTitulosBaixaGrid.getField('NMTPBAIXAPAG').readOnly  = true;
        }else{
            widgetNewTitulosBaixaGrid.getField('NMTPBAIXAPAG').readOnly  = false;
        }
    };
	
	
	 /**
     * Calcula Total Baixa Paga
     * @param widget
     */
    self.calculaTotalBaixaPaga = function(){
        var widgetNewBaixaTabbed = templateManager.container.getWidget('NewBaixaTabbed');
        var widgetNewTitulosBaixaGrid = templateManager.container.getWidget('NewTitulosBaixaGrid');
        
        var vrtotalbaixapaga = 0;
        
        var dataNewTitulosBaixaGrid = widgetNewTitulosBaixaGrid.getCheckedRows();
        
        dataNewTitulosBaixaGrid.forEach(function (data) {
            vrtotalbaixapaga += self.formataValor(data.VRPAGO);
        });
        
        widgetNewBaixaTabbed.currentRow.VRBAIXAPAG = vrtotalbaixapaga;
    };
	
	 /**
     * Edita Baixa Pagamento
     * @param widget
     */
    self.saveBaixaPagamento = function(args){
        var widget = args.owner.widget;
        
        if(widget.isValid()){
            var vrfinalbpag = self.formataValor(widget.currentRow.VRFINALBPAG);
            var vrpago      = self.formataValor(widget.currentRow.VRPAGO);
            
            if(vrfinalbpag != vrpago){
                if(vrfinalbpag > vrpago){
                        var currentRow = widget.dataSource.data[widget.currentRow.__index];
                        
                        var newRow = null;
                        
                        if(currentRow.NRPARCBOLPAGVISU == '000'){
                            currentRow.NRPARCBOLPAGVISU = String(parseInt(currentRow.NRPARCBOLPAGVISU) + 1).padStart(3, '0');
                            currentRow.NRPARCBOLPAG     = String(parseInt(currentRow.NRPARCBOLPAG) + 1).padStart(2, '0');
                            currentRow.NRORIGBOLPAG     = currentRow.NRLANBOLPAG;
                            
                            newRow = Util.clone(currentRow);
                            
                            newRow.NRPARCBOLPAGVISU =  String(parseInt(newRow.NRPARCBOLPAGVISU) + 1).padStart(3, '0');
                            newRow.NRPARCBOLPAG     =  String(parseInt(newRow.NRPARCBOLPAG) + 1).padStart(2, '0');
                        }else{
                            
                            newRow = Util.clone(currentRow);
                            
                            var filter = [
                                {
                                    "name": "NRORG",
                                    "operator": "=",
                                    "value": currentRow.NRORG
                                },
                                {
                                    "name": "CDFILIAL",
                                    "operator": "=",
                                    "value": currentRow.CDFILIAL
                                },
                                {
                                    "name": "NRORIGBOLPAG",
                                    "operator": "=",
                                    "value": currentRow.NRORIGBOLPAG
                                }
                            ];
                            
                            General.callRestEngine('fin#/crud/boletpagar_maxNrparcbolpag','FilterData', filter).then(function(result){
                                var maxNrparcbolpag = result.dataset.boletpagar_maxNrparcbolpag;
                                
                                if(maxNrparcbolpag.length > 0){
                                    
                                    var old_nrparcbolpagvisu = maxNrparcbolpag[0].NRPARCBOLPAGVISU;
                                    var old_nrparcbolpag = maxNrparcbolpag[0].NRPARCBOLPAG;
                                    
                                    var rowsNrorigbolpag = widget.dataSource.data.filter(function(boleto){
                                        return boleto.NRORIGBOLPAG == currentRow.NRORIGBOLPAG;
                                    });
                                    
                                    
                                    self.getNewNrparcbolpag(rowsNrorigbolpag).then(function(result) {
                                        var new_nrparcbolpagvisu_widget = result[0];
                                        var new_nrparcbolpag_widget = result[0];
                                        
                                        if(new_nrparcbolpagvisu_widget > old_nrparcbolpagvisu){
                                            newRow.NRPARCBOLPAGVISU =  String(parseInt(new_nrparcbolpagvisu_widget) + 1).padStart(3, '0');
                                            newRow.NRPARCBOLPAG     =  String(parseInt(new_nrparcbolpag_widget) + 1).padStart(2, '0');
                                        }else{
                                            newRow.NRPARCBOLPAGVISU =  String(parseInt(old_nrparcbolpagvisu) + 1).padStart(3, '0');
                                            newRow.NRPARCBOLPAG     =  String(parseInt(old_nrparcbolpag) + 1).padStart(2, '0');
                                        }
                                    });
                                }
                            });
                        }
                        
                        currentRow.VRFINALBPAG = currentRow.VRPAGO;
                        currentRow.VRBOLPAG    = currentRow.VRPAGO;
                        currentRow.PARCELADO   = true;
                        currentRow.CDMOTIPARC  = '01';
                        
                        //newRow.NRPARCBOLPAGVISU =  String(parseInt(newRow.NRPARCBOLPAGVISU) + 1).padStart(3, '0');
                        //newRow.NRPARCBOLPAG     =  String(parseInt(newRow.NRPARCBOLPAG) + 1).padStart(2, '0');
                        newRow.VRFINALBPAG      = newRow.VRFINALBPAG - newRow.VRPAGO;
                        newRow.VRBOLPAG         = newRow.VRFINALBPAG;
                        newRow.VRPAGO           = newRow.VRFINALBPAG;
                        newRow.NRORIGBOLPAG     = newRow.NRORIGBOLPAG ? newRow.NRORIGBOLPAG : newRow.NRLANBOLPAG;
                        newRow.NRLANBOLPAG      = null;
                        newRow.CDMOTIPARC       = '01';//TODO PARAMETRO PARA MOTIVO
                        newRow.PARCELADO        = true;
                        newRow.__index = newRow.__index + 1;
                        
                        widget.dataSource.data.splice(newRow.__index, 0, newRow);
                        
                        ScreenService.goBack();
                        ScreenService.showMessage('Registro salvo com sucesso.');
                }else ScreenService.showMessage('Operação bloqueada. Valor pago não pode ser superior ao valor líquido.');
            }else{
                ScreenService.goBack();
                ScreenService.showMessage('Registro salvo com sucesso.');
            }
        }
        
    };
    
     self.getNewNrparcbolpag = function(rowsNrorigbolpag) {
        var deferred = ZHPromise.defer();
        
        var maxNrparcbolpagvisu_widget = 0;
        var maxNrparcbolpag_widget = 0;
                                    
        rowsNrorigbolpag.forEach(function (data) {
            maxNrparcbolpagvisu_widget = (maxNrparcbolpagvisu_widget < parseInt(data.NRPARCBOLPAGVISU)) ? data.NRPARCBOLPAGVISU : maxNrparcbolpagvisu_widget;
            maxNrparcbolpag_widget = (maxNrparcbolpag_widget < parseInt(data.NRPARCBOLPAG)) ? data.NRPARCBOLPAG : maxNrparcbolpag_widget;
        });
        
        var result = [maxNrparcbolpagvisu_widget, maxNrparcbolpag_widget];
        
        deferred.resolve(result);   
        
        return deferred.promise;
    };
    
    /*
    * Habilita a action para impressão de recibo de baixa
    */
    self.habilitaActionRecibo = function(widget) {
        var widgetTitulosAPagarGrid = templateManager.container.getWidget("TitulosAPagarGrid");
        var statusBaixa = widgetTitulosAPagarGrid.getField("IDSTATBPAG").value();
        if(statusBaixa === "B"){
            widget.getAction('GETACTION').isVisible = true;
        } else {
            widget.getAction('GETACTION').isVisible = false;
        }
        
        templateManager.updateTemplate();
    };
    
    /*
    * Gera Recibo de Baixa BIRT
    * @params
    * CDFILIAL,NRORG,NRLANBOLPAG
    */
    self.geraReciboBaixa = function(widget) {
        var param = {};
        if(widget.name === 'TitulosAPagarGrid'){
            param = {
                'CDEMPRESA': widget.getCheckedRows()[0].CDEMPRESA,
                'NRORG':widget.getCheckedRows()[0].NRORG,
                'NRBAIXAPAG':widget.getCheckedRows()[0].NRBAIXAPAG,
                'CDFILIAL':widget.getCheckedRows()[0].CDFILIBAIPAG
            };
            
        } else{
            var widgetTitulosAPagarGrid = templateManager.container.getWidget("TitulosAPagarGrid");
            var empresa = widgetTitulosAPagarGrid.getField("CDEMPRESA").value();
            
            param = {
                'CDEMPRESA': empresa,
                'NRORG':widget.dataSource.data[0].NRORG,
                'NRBAIXAPAG':widget.dataSource.data[0].NRBAIXAPAG,
                'CDFILIAL':widget.dataSource.data[0].CDFILIAL
            };
        }
        
        General.openReport("fin#/geraReciboBaixa", 'FIN0001' ,param);
    };
    
    
    /* GERA RATEIO PADRAO DE ACORDO COM CENTRO DE CUSTO
    * Função do campo 'Padrao de Rateio' quando vai lançar um novo titulo, essa função pega os item de rateio e de acordo com o valor faz o rateamento para unidades/centro de custo cadastradas
    * @RateioDocGrid - to deixando esse @ nos coments pra ficar mais facil identificar todas as partes referente a esse padrao de rateio
    */

    self.rateamentoPadrao = function(widget){ 
        var gridRateio = templateManager.container.getWidget("RateioDocGrid");
        var cdRateio = widget.getField("CDRATEIO").value();
        
        gridRateio.dataSource.data = [];// limpa o grid de rateio impendindo que o próximo titulo receba valores do anterior
        
        var vrTotal = parseFloat(widget.getField("VRNOTAFISC").value());
        let valorRateado = [];
        
        var filter = [{
            "name": "CDRATEIO",
            "operator": "=",
            "value": cdRateio
        }];
        
        let valor;
        var valorPercentual = 0;
        // Busca os dados de item de rateio por centro de custo para montar o datasource de rateio conforme padrão de rateio
        General.callRestEngine('fin#/crud/itemrateio_centcust_titulos','FilterData', filter).then(function(result){
            result.dataset.itemrateio_centcust_titulos.forEach(function(dados){
                  valorPercentual += dados.VRRATEIO;
                  valor = ((dados.VRRATEIO / 100) * vrTotal);
                  valorRateado.push({
                      CDCENTCUST: dados.CDCENTCUST,
                      CDFILIAL: dados.CDFILIAL,
                      NMFILIAL: dados.NMFILIAL,
                      NMCENTCUST: dados.NMCENTCUST,
                      VRRATEIO: dados.VRRATEIO,
                      CDFIRATCTPAG: dados.CDFILIAL,
                      CDRATEIO: dados.CDRATEIO,
                      NMFIRATCTPAG: dados.NMFILIAL,
                      VRPERATEIO: dados.VRRATEIO,
                      VRRATCCCTPAG: valor
                  });
            });
                gridRateio.dataSource.data = valorRateado;
        });
    };
        
    self.limpaGridRateioPadrao = function(){
        var gridRateio = templateManager.container.getWidget("RateioDocGrid");
        gridRateio.dataSource.data = [];
    };
};


/* global Configuration */
Configuration(function (ContextRegister){
    ContextRegister.register('Pag00001_TitulosAPagar_Controller', Pag00001_TitulosAPagar_Controller);
});